ifndef CAMERA1ST_WDL;
define CAMERA1ST_WDL;
// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 1.00
// date: 060510
//
// title: First Person Camera
// class: CAMERA
// type: SUPPORT
// image: camera1st.pcx
// help: players eyes.
//
// This uses the new camera select system. (object based)
// class camera {
//		virtual register;
//		virtual update;
//		virtual select;
//		virtual reinit - not needed for this camera;
// }
//
// ENDHEADER
// ---------------------------------------------------------------------

define Camera1st_ID = 2;

// enable: Selectable?
// help: Make camera selectable by user? 
// id: 1
define	camera1st_user_sel;

function camera1st_Select(viewIndex);
function camera1st_Update(viewIndex);

var camera1st_ang[3];

// desc: update the view whos ID is passed in to the position/orientation
//      of the Camera
function	camera1st_Update(ViewIndex)
{
	if (CamSel_active_view_cameras[ViewIndex] == 0)
	{
		return;
	}
	if (CamSel_ents[ViewIndex] == 0)
	{
		return;
	}
	
	CamSel_active_view_camera = Ptr_For_Handle(CamSel_active_view_cameras[ViewIndex]);
	CamSel_ent = Ptr_For_Handle(CamSel_ents[ViewIndex]);
	CamSel_ent.invisible = on;
	
	//get my position
	vec_set(GL_Vec2.x, CamSel_ent.x);
	
	//ajust for eye height and leaning
	GL_Vec2.z += CamSel_Ent.Gl_Eye_Height;
	
	// ++gt add this back in after contest :-) 
	
	vec_set(CamSel_active_view_camera.x, GL_Vec2.x);
	vec_set(CamSel_active_view_camera.pan, CamSel_ent.pan);
	CamSel_active_view_camera.tilt = CamSel_tilt[ViewIndex];

	}

function camera1st_Select(viewIndex)
{
	CamSel_active_camera_update[viewIndex] = 	handle(camera1st_update);
	CamSel_active_camera_ID[viewIndex] = camera1st_ID;
	if (CamSel_ent)
	{
		CamSel_ent.visible = off;
	}	
}


starter camera1st_Register()
{
	if (CamSel_MaxCameraType >= CamSel_camera_max_types)
	{
		beep();
		diag("\nWDL-Error:camera1st_register - To Many Cameras Types");
		return;
	}
	else
	{
		CamSel_MaxCameraType += 1;
		CamSel_CameraTypes[CamSel_MaxCameraType] = handle(camera1st_Select);
		CamSel_CameraTypes_ID[CamSel_MaxCameraType] = camera1st_ID;
	}
	
	ifdef FixedCam_user_sel;
	CamSel_User_Selectable |= camera1st_ID;
	endif;
}

endif;