ifndef clib_wdl;
define clib_wdl;

// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 1
// date: 060511
//
// title: CLib
// class: FUNCTIONS
// type:  SUPPORT
// image: CLib.pcx
//
// needs: globals00
//
// external:
//
// prefix: Clib_
// idcode: X01
//
// ENDHEADER
// ---------------------------------------------------------------------

function Clib_Panel_Fade(pan,from,to,secs)
{
   var t = 0;
   var end_val;
   
   temp_panel = pan;
   temp_panel.transparent = on;
	temp_panel.alpha = from;
   temp_panel.visible = on;
	
   end_val = secs*16;	// calculate ending time step value
   t = 100*(secs - int(secs));
   wait(-t);		//delay fade for deleysec seconds
   
   //range check from and to;
  	if (from > 100) {
  		from = 100;
	}
	if (from < 0) {
		from = 0;
	}
  	if (to > 100) {
  		to = 100;
	}
	if (to < 0) {
		to = 0;
	}
	t = 0;
   while(t < end_val)
	{
		temp_panel = pan;
		temp_panel.alpha = from + (to-from)*t/(end_val);
		t += time_step;
		wait(1);
   }
	temp_panel = pan;	
   temp_panel.alpha = to;
   if (temp_panel.alpha == 0) 
   { 
   	temp_panel.visible = off; 
   }
   if (temp_panel.alpha == 100) 
   { 
   	temp_panel.transparent = off; 
   }
}

function clib_hat_to_joybuttons()
{
	var hattemp;
	
	hattemp = joy_hat;
	joy_13 = hattemp==315 || hattemp==0   || hattemp==45;
	joy_14 = hattemp==45  || hattemp==90  || hattemp==135;
	joy_15 = hattemp==135 || hattemp==180 || hattemp==225;
	joy_16 = hattemp==225 || hattemp==270 || hattemp==315;
}

function clib_hat2_to_joybuttons()
{
	var hattemp;
	
	hattemp = joy2_hat;
	joy2_13 = hattemp==315 || hattemp==0   || hattemp==45;
	joy2_14 = hattemp==45  || hattemp==90  || hattemp==135;
	joy2_15 = hattemp==135 || hattemp==180 || hattemp==225;
	joy2_16 = hattemp==225 || hattemp==270 || hattemp==315;
}

define clib_pan_top = 1;
define clib_pan_vcenter = 2;
define clib_pan_bottom = 4;
define clib_pan_left = 8;
define clib_pan_center = 16;
define clib_pan_right = 32;

function clib_move_panel(pan, pos)
{
	var height;
	var width;
	
	temp_panel = pan;
	height = temp_panel.size_y;
	width = temp_panel.size_x;
	
	//move to center by default
	temp_panel.pos_y = (screen_size.y - height) / 2;
	temp_panel.pos_x = (screen_size.x - width) / 2;
	
	//check bits for where to move. 
	if (pos & clib_pan_top)
	{
		temp_panel.pos_y = 0;
	}
	if (pos & clib_pan_vcenter)
	{
		temp_panel.pos_y = (screen_size.y - height) / 2;
	}
	if (pos & clib_pan_bottom)
	{
		temp_panel.pos_y = screen_size.y - height;
	}
	if (pos & clib_pan_left)
	{
		temp_panel.pos_x = 2;
	}
	if (pos & clib_pan_center)
	{
		temp_panel.pos_x = (screen_size.x - width) / 2;
	}
	if (pos & clib_pan_right)
	{
		temp_panel.pos_x = screen_size.x - width;
	}
}

function clib_scale_panel(pan,scalex,scaley)
{
	temp_panel = pan;
	
	if (temp_panel == null)
	{
		return;
	}
	temp_bmap = temp_panel.bmap;
	if (temp_bmap == null)
	{
		return;
	}
	temp_panel.scale_x = scalex / bmap_width(temp_bmap);
	temp_panel.scale_y = scaley / bmap_height(temp_bmap);
}

function clib_slide_pannel_sideways(pan, from, to, step)
{
	temp_panel = pan;
	if (temp_panel == null)
	{
		return;
	}
	temp_panel.pos_x = from;
	temp_panel.visible = on;
	if (from < to)
	{
		while (temp_panel.pos_x < to)
		{
			temp_panel.pos_x += step;
			wait(1);
			temp_panel = pan;
		}
	}
	else
	{
		while (temp_panel.pos_x > to)
		{
			temp_panel.pos_x -= step;
			wait(1);
			temp_panel = pan;
		}
	}
}

function clib_slide_pannel_updown(pan, from, to, step)
{
	temp_panel = pan;
	if (temp_panel == null)
	{
		return;
	}
	temp_panel.pos_y = from;
	temp_panel.visible = on;
	if (from < to)
	{
		while (temp_panel.pos_y < to)
		{
			temp_panel.pos_y += step;
			wait(1);
			temp_panel = pan;
		}
	}
	else
	{
		while (temp_panel.pos_y > to)
		{
			temp_panel.pos_y  -= step;
			wait(1);
			temp_panel = pan;
		}
	}
}

function clib_slide_textpannel_sideways(pan, txt, from, tostep)
{
	var to;
	var step;
	
	to = int(tostep);
	step = frc(tostep)*100;
	
	temp_panel = pan;
	if (temp_panel == null)
	{
		return;
	}
	temp_panel = txt;
	if (temp_panel == null)
	{
		return;
	}
	temp_panel = pan;
	temp_panel.pos_x = from;
	temp_panel.visible = on;
	temp_panel = txt;
	temp_panel.pos_x = from;
	temp_panel.visible = on;
	if (from < to)
	{
		temp_panel = pan;
		while (temp_panel.pos_x + step < to)
		{
			temp_panel.pos_x += step;
			temp_panel = txt;
			temp_panel.pos_x += step;
			wait(1);
			temp_panel = pan;
		}
		temp_panel.pos_x = to;
		temp_panel = txt;
		temp_panel.pos_x = to;
	}
	else
	{
		temp_panel = pan;
		while (temp_panel.pos_x - step > to)
		{
			temp_panel.pos_x -= step;
			temp_panel = txt;
			temp_panel.pos_x -= step;
			wait(1);
			temp_panel = pan;
		}
		temp_panel.pos_x = to;
		temp_panel = txt;
		temp_panel.pos_x = to;
	}
}

function clib_slide_textpannel_updown(pan, txt, from, tostep)
{
	var to;
	var step;
	
	to = int(tostep);
	step = abs(frc(tostep)*100);
	
	temp_panel = pan;
	if (temp_panel == null)
	{
		return;
	}
	temp_panel = txt;
	if (temp_panel == null)
	{
		return;
	}
	temp_panel = pan;
	temp_panel.pos_y = from;
	temp_panel.visible = on;
	temp_panel = txt;
	temp_panel.pos_y = from;
	temp_panel.visible = on;
	if (from < to)
	{
		temp_panel = pan;
		while (temp_panel.pos_y + step < to)
		{
			temp_panel.pos_y += step;
			temp_panel = txt;
			temp_panel.pos_y += step;
			wait(1);
			temp_panel = pan;
		}
		temp_panel.pos_y = to;
		temp_panel = txt;
		temp_panel.pos_y = to;
	}
	else
	{
		temp_panel = pan;
		while (temp_panel.pos_y - step > to)
		{
			temp_panel.pos_y -= step;
			temp_panel = txt;
			temp_panel.pos_y -= step;
			wait(1);
			temp_panel = pan;
		}
		temp_panel.pos_y = to;
		temp_panel = txt;
		temp_panel.pos_y = to;
	}
}

bmap CLIB_console_pcx = <console.pcx>;

//temp string buffers used for !print command
string* CLIB_key_buff;
string CLIB_tmp_buffer;
string CLIB_exec_buffer;
string CLIB_exec_buffer2;


//variable used to detect if we have called _console_init
var    CLIB_console_init_done = 0;

//the console termainl screen background panel
panel CLIB_console_bgnd
{
  layer 11;
  bmap = CLIB_console_pcx;
  flags refresh,d3d;
}


//main text panel used for display of the terminal screen
text CLIB_console_txt
{
  pos_x 4;
  layer	12;
  font 	standard_font;
  strings 24;
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
  string "                                                                                ";
}


//this function will copy the blank line to each line in the display
//to clear old text from the display. This function sets the flag
//variable _console_init_done to indicate that the console is ready to
//use. 

function CLIB_console_init()
{
	var index;
	
	index = 0;
	while (index < 24)
	{
		str_cpy(CLIB_console_txt.string[index],"");
		index += 1;		
	}  
	CLIB_console_init_done = 1;
}


//this function will copy each line to the line above itself. This
//is how we implement the scrolling of the text. 
function CLIB_scroll_console()
{
	var index;
	
  	index = 0;
  	while (index < 23)
  	{
  		str_cpy(CLIB_console_txt.string[index], CLIB_console_txt.string[index + 1]);
  		index += 1;
	}
	str_cpy(CLIB_console_txt.string[23],"");
}  

//This function will copy the new_text value to the last line in the display
//and then scroll the text display. If _console_init_done has not been set then
//_console_init will be called. The wait(4) instruction is used to keep 
//synchonization with the _console_init function. 

function CLIB_write_console(new_text)
{
	if (CLIB_console_init_done == 0) 
	{ 
		CLIB_console_init(); 
	}
	
	str_cpy(CLIB_console_txt.string[23],new_text);
	CLIB_scroll_console();
}

//This function will parse the input buffer for special commands and then
//execute the code needed for each command. 
function CLIB_parse_exec_buffer()
{
	if (str_stri(CLIB_exec_buffer,"i am ironman") == 2) {
		CLIB_scroll_console();
		if (GL_GOD_MODE != NULL)
		{
			GL_GOD_MODE();
			CLIB_write_console("Ok! you are Ironman if that makes you happy!");
			CLIB_write_console("You are now indestructable... just stay away from magnets.");
		}
		else
		{
			CLIB_write_console("Ironman mode not available.");
		}
		return(1);
	}
	if (str_stri(CLIB_exec_buffer,"give") == 2) 
	{
		if (str_stri(CLIB_exec_buffer,"ammo") >= 7 || str_stri(CLIB_exec_buffer,"all") >= 7) 
		{
			CLIB_scroll_console();
			if (GL_FULL_AMMO != NULL)
			{
				GL_FULL_AMMO();
				CLIB_write_console("Ammo Full");
			}
			else
			{
				CLIB_write_console("Ammo not available.");
			}
			if (str_stri(CLIB_exec_buffer,"all") < 7)
			{
				return(1);
			}
		}
		if (str_stri(CLIB_exec_buffer,"health") >= 7 || str_stri(CLIB_exec_buffer,"all") >= 7) 
		{
			CLIB_scroll_console();
			if (GL_FULL_HEALTH != NULL)
			{
				GL_FULL_HEALTH();
				CLIB_write_console("Health Restored");
			}
			else
			{
				CLIB_write_console("Health not available.");
			}
			if (str_stri(CLIB_exec_buffer,"all") < 7)
			{
				return(1);
			}
		}
		if (str_stri(CLIB_exec_buffer,"armor") >= 7 || str_stri(CLIB_exec_buffer,"all") >= 7) 
		{
			CLIB_scroll_console();
			if (GL_FULL_ARMOR != NULL)
			{
				GL_FULL_ARMOR();
				CLIB_write_console("Armor Restored");
			}
			else
			{
				CLIB_write_console("Armor not available.");
			}
			if (str_stri(CLIB_exec_buffer,"all") < 7)
			{
				return(1);
			}
		}
		if (str_stri(CLIB_exec_buffer,"keys") >= 7 || str_stri(CLIB_exec_buffer,"all") >= 7) 
		{
			CLIB_scroll_console();
			if (GL_ALL_KEYS != NULL)
			{
				GL_ALL_KEYS();
				CLIB_write_console("All Keys given");
			}
			else
			{
				CLIB_write_console("Keys not available.");
			}
			if (str_stri(CLIB_exec_buffer,"all") < 7)
			{
				return(1);
			}
		}
		if (str_stri(CLIB_exec_buffer,"weapons") >= 7 || str_stri(CLIB_exec_buffer,"all") >= 7) 
		{
			CLIB_scroll_console();
			if (GL_ALL_WEAPONS != NULL)
			{
				GL_ALL_WEAPONS();
				CLIB_write_console("All Weapons given");
			}
			else
			{
				CLIB_write_console("Weapons not available.");
			}
			if (str_stri(CLIB_exec_buffer,"all") < 7)
			{
				return(1);
			}
		}
		if (str_stri(CLIB_exec_buffer,"all") >= 7)
		{
			return(1);
		}
		else
		{
			return(0);
		}
	}
	if (str_stri(CLIB_exec_buffer,"cls") == 2) {
		CLIB_console_init();
		return(1);
	}
	if (str_stri(CLIB_exec_buffer,"print") == 2) {
		str_cpy(CLIB_tmp_buffer,CLIB_exec_buffer); // copy buffer
		str_clip(CLIB_tmp_buffer,6);					// remove !print
		str_cpy(CLIB_exec_buffer2,"str_for_num(CLIB_tmp_buffer,"); //build first part of command
		str_cat(CLIB_exec_buffer2,CLIB_tmp_buffer); // put in variable name
		str_cat(CLIB_exec_buffer2,");");			// finish command
		str_cpy(CLIB_exec_buffer,CLIB_tmp_buffer);	// make copy of variable name
		str_cat(CLIB_exec_buffer," = ");			// put in "=" sign
		str_cpy(CLIB_tmp_buffer,"");					// zero result buffer
		execute(CLIB_exec_buffer2);					// execute command					
		str_cat(CLIB_exec_buffer,CLIB_tmp_buffer);	// add result to buffer
		CLIB_scroll_console();
		CLIB_write_console(CLIB_exec_buffer);
		return(1);
	}
	return(0);
}

function CLIB_console()
{
	var res;
	
	my = null;
	if (CLIB_console_init_done == 0) 
	{ 
		CLIB_console_init(); 
	}
	
	if (CLIB_console_txt.visible == on) 
	{ 
		return; 			//already running
	}	
	
	freeze_mode = 1;
	CLIB_write_console("Enter commands. Press TAB to exit.");
	CLIB_console_txt.pos_y =  -256;
	CLIB_console_bgnd.pos_y = -256;
	
	if (video_mode == 6)
	{
		clib_scale_panel(CLIB_console_bgnd,640,256);
	}
	if (video_mode == 7)
	{
		clib_scale_panel(CLIB_console_bgnd,800,256);
	}
	if (video_mode == 8)
	{
		clib_scale_panel(CLIB_console_bgnd,1024,256);
	}
	if (video_mode == 9)
	{
		clib_scale_panel(CLIB_console_bgnd,1280,256);
	}


	clib_slide_textpannel_updown(CLIB_console_bgnd, CLIB_console_txt, -256, 0.16);
	wait(16);
	while(CLIB_console_txt.visible == on)
	{
		CLIB_key_buff = CLIB_console_txt.string[23];
		
		inkey(CLIB_key_buff);
		res = result;
		str_cpy(CLIB_exec_buffer,CLIB_console_txt.string[23]);
		if(res == 13)
		{
			if (str_stri(CLIB_exec_buffer,"!") == 1) 
			{
				if (!CLIB_parse_exec_buffer())
				{
					CLIB_scroll_console();
					CLIB_write_console("Error: invalid command");
				}
			} else {
				CLIB_scroll_console(); 
				execute(CLIB_exec_buffer);
			}
		}
		else
		{ 
			if(res==9) 
			{
				clib_slide_textpannel_updown(CLIB_console_bgnd, CLIB_console_txt, 0, -256.16);
				wait(16);
				CLIB_console_txt.visible = off;
				CLIB_console_bgnd.visible = off;
				freeze_mode = 0;
			}
		}
	}
}

function clib_startup()
{
	GL_CONSOLE = CLIB_console;
}

endif;
