ifndef Globals_wdl;
define Globals_wdl;

// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 1
// date: 060509
//
// title: Globals
// class: GLOBALS
// type:  SUPPORT
// image: globals.pcx
//
// needs:
//
// external:
//
// prefix: GL_
// idcode: X00
//
// system globals
// added debug system 
// added messaging event system
// 
// 
// ENDHEADER
// ---------------------------------------------------------------------


////////////////////////////////////////////////////////////////////////
// Globals

var GL_Mail_Slots[128];				//Global interprocess communications mail slots
var GL_Event_Max;
var Gl_Event_Start;

define GL_Event_End = 101;

define GL_MAIL_CHANGE_VIEW1 = 123;	//Change camera type in main view
define GL_MAIL_CHANGE_VIEW2 = 124;  //Change camera type in sub view 1
define GL_MAIL_CHANGE_VIEW3 = 125;  //Change camera type in sub view 2
define GL_MAIL_CHANGE_VIEW4 = 126;  //Change camera type in sub view 3
define GL_MAIL_CHANGE_VIEW5 = 127;  //Change camera type in sub view 4
define GL_MAIL_CHANGE_VIEW_NEXT = 1; // select next view
define GL_MAIL_CHANGE_VIEW_PREV = 2; // select previous view
define GL_MAIL_CHANGE_VIEW_SEL = 2000;  // select specific view ID + 2000

define GL_MSG_XY = 1;
define GL_MSG_PANTILT = 2;
define GL_MSG_ZROLL = 3;
define GL_MSG_CAM_XY = 4;
define GL_MSG_CAM_PANTILT = 5;
define GL_MSG_CAM_ZROLL = 6;
define GL_MSG_ACTIVATE = 7;
define GL_MSG_FIRE = 8;
define GL_MSG_ZOOM = 9;
define GL_MSG_MENU = 10;
define GL_MSG_QSAVE = 11;
define GL_MSG_QLOAD = 12;
define GL_MSG_DEBUG = 13;
define GL_MSG_HELP = 14;
define GL_MSG_CONSOLE = 15;

//setup for players and AI
define	GL_Health, skill1;
define   GL_Armor, skill2;
define   GL_Animation, skill3;
define 	GL_max_force_x,SKILL4;
define 	GL_max_force_y,SKILL5;
// max_force_z is handle by gravity.
define 	GL_max_ang_force_pan,SKILL6;
DEFINE 	GL_max_ang_force_tilt,SKILL7;
DEFINE 	GL_max_ang_force_roll,SKILL8;
define 	GL_trigger_range, SKILL9;    // distace that things are triggered
define 	GL_no_fall_dam, FLAG1;			// if set, entity does not take damage from falls
define   GL_Ironman, FLAG8;

define	GL_Entity_id, skill21;

//event handling - for c_scan etc
define	GL_Event_Message, skill22;
define	GL_Event_data,	skill23;
define 	GL_event_handled, skill24;
//movement and rotation skills
define	GL_X_Vel, skill25;
define	GL_Y_Vel, skill26;
define   GL_Z_Vel, skill27;
define	GL_Pan_Vel, skill28;
define	GL_Tilt_Vel, skill29;
define	Gl_Roll_Vel, skill30;
define	GL_Eye_Height,skill31;

//state information for actors (player and AI)
define	GL_Anim_Dist,skill32;			//animimation distance
define GL_biped_dist, SKILL33;  // distance covered last frame

define GL_biped_state1, skill34;	// biped state:
//if you add a state you must add an animation at the same time!
define GL_biped_state1_none_const,0;		// no movement (i.e. player dead)
define GL_biped_state1_stand_const,1;		// standing
define GL_biped_state1_walk_const,2;    	// walking. running, standing
define GL_biped_state1_run_const,3;     	// running
define GL_biped_state1_jump_const,4;    	// jumping
define GL_biped_state1_duck_const,5;    	// ducking or crawling
define GL_biped_state1_crawl_const,6;		// crawling (move while ducked)
define GL_biped_state1_swim_const,7;		// swimming
define GL_biped_state1_wade_const,8;		// wading in water
define GL_biped_state1_dying_const,9; 	// dying
define GL_biped_state1_attack_const, 10;
define GL_biped_state1_damage_const, 11;

//special case states
define GL_biped_state1_dead_const,97;    // finished dying
define GL_biped_state1_activate_const,98;// press a button or switch
define GL_biped_state1_override_const,99;  	// bipedPhy is being overriden at the movement with something else (driving, climbing, etc.)


define GL_biped_state2, skill35;	// biped state modifier:
define GL_biped_state2_none_const,0;					// no modifier
define GL_biped_state2_fall_const,1;			// biped is falling
define GL_biped_state2_underwater_const,2;	// biped is underwater
define GL_biped_state2_damage_const,3;		// biped has taken damage from environment (falling, crushing, etc.)
define GL_biped_state2_drown_const,4;		// biped is drowning
define GL_biped_state2_dying_const, 5;
define GL_biped_state2_dead_const,6;
define GL_biped_state2_value, skill36;	// state modifier value, dependent on state modifier

// note: state 2 modifiers can be used in combination with state 1 modifier above
define GL_biped_state3, skill37; // biped state modifier 2:
define GL_biped_state3_none_const,0;	// no modifier
define GL_biped_state3_attack_const,1;	// preforming an attack
define GL_biped_state3_damage_const,2;	// taking damage
define GL_biped_state3_value, skill38;	// state2 modifier value, dependent on state2 modifier


define GL_biped_jump_target, SKILL39;	// target to reach while jumping


//animation states
define GL_Anim_Old,skill40;
define GL_Anim_Cur,skill41;
define GL_Anim_Cycle,skill42;
define GL_Anim_Percent,skill43;
define GL_Anim_OnceOnly,skill44;
define GL_Anim_state, skill45;
define GL_Anim_state_none,0;
define GL_Anim_state_once,1;
define GL_Anim_state_force,2;
define GL_Anim_state_once_noblend,3;
define GL_Anim_state_transition,4;
define GL_Anim_state_new, 5;
define GL_Sound_Dist, skill46;
define GL_Sound_Last, skill47;


// Entity ID's
define GL_Player1 = 1; 		// player id
define GL_Player2 = 2; 		// player id

// AI IDs
define GL_AI_DUMB = 32;
define GL_AI_PATROL = 33;
define GL_AI_GUARD = 34;
define GL_AI_FIXED = 35;
define GL_AI_FLOAT = 36;
define GL_AI_ANIMAL = 37;
define GL_AI_SMART = 38;			

// Map entity IDs
define GL_LIFT = 64;
define GL_DOOR = 65;
define GL_WATER = 66;
define GL_FORCEFIELD = 67;
define GL_DAMAGE_FIELD = 68;		//like toxic floor, lava, etc
define GL_ACTION_AREA = 69;		//triggers doors etc
define GL_TRAP = 70;					//I feel like the walls are closing in :-)


define GL_EVENT_SCAN = 101;
define GL_EVENT_SHOOT = 102;
define GL_EVENT_EXPLODE = 103;
define GL_EVENT_AREA = 104;
define GL_EVENT_TRAP = 105;
define GL_EVENT_ALARM = 106;
define GL_EVENT_PUSH = 107;




////////////////////////////////////////////////////////////////////////
// Global Game State values

// state of the level
var		GL_Game_state = 0;

define	GL_GAME_STATE_NOT_SET = 0;	//State is invalide
define	GL_level_not_loaded = 1;	// level is not loaded
define	GL_level_loaded = 2;			// level is loaded
define	GL_level_restart = 3;		// level is being restarted
define	GL_level_change = 4; 		// level is changing 
define	GL_level_pause = 5;			// level is paused


//----------------------------------------------------------------------
// Temp values
string GL_temp_mdl = <temp.mdl>;	// placeholder model
var	 GL_vec1[3];					// temp vec
var	 GL_vec2[3];					// temp vec2
var	 nullvect[3] = 0,0,0;
var	 temp1;
var	 temp2;

//joystick hat buttons.
var joy_13 = 0;
var joy_14 = 0;
var joy_15 = 0;
var joy_16 = 0;
var joy2_13 = 0;
var joy2_14 = 0;
var joy2_15 = 0;
var joy2_16 = 0;

panel*	temp_panel;
bmap*		temp_bmap;
entity*	temp_ent;
entity*	GL_player1_ent;		//used for level change etc
entity*	GL_player2_ent;		//used for level change etc

font standard_font,<ackfont.pcx>,6,9;

function* GL_GOD_MODE;
function* GL_FULL_HEALTH;
function* GL_FULL_ARMOR;
function* GL_FULL_AMMO;
function* GL_ALL_WEAPONS;
function* GL_ALL_KEYS;


var GL_Recreate[40];
var GL_Recreate_Max = 0;
function* GL_Recreate_func;

function GL_Do_Recreate()
{
	var index = 0;
	while (index < GL_Recreate_Max)
	{

		GL_Recreate_func = ptr_for_handle(GL_Recreate[index]);
		if (GL_Recreate_func != null)
		{
			GL_Recreate_func();
		}
		index += 1;
	}
}

function* GL_START_MENU;
function* GL_INGAME_MENU;
function* GL_CONSOLE;
function* GL_HELP;
function* GL_SAVE;
function* GL_LOAD;


function* GL_DEBUG_DEFAULT;
function* GL_DEBUG_FNC;
var gl_debug_toggles[20];
var gl_debug_max = 0;
var gl_debug_current = 0;
var gl_debug_state = 0;

function GL_system_debug()
{
	if (gl_debug_state == 3)
	{
		beep();
		GL_DEBUG_FNC = ptr_for_handle(gl_debug_toggles[gl_debug_current]);
		if (GL_DEBUG_FNC)
		{
			GL_DEBUG_FNC();
		}
		gl_debug_current += 1;
		if (gl_debug_current < gl_debug_max)
		{
			GL_DEBUG_FNC = ptr_for_handle(gl_debug_toggles[gl_debug_current]);
			if (GL_DEBUG_FNC)
			{
				GL_DEBUG_FNC();
			}
			return;
		}
		gl_debug_state = 0;
		return;	
	}
	if (gl_debug_state == 2)
	{
		GL_DEBUG_DEFAULT();
		gl_debug_current = 0;
		if (gl_debug_max)
		{
			GL_DEBUG_FNC = ptr_for_handle(gl_debug_toggles[gl_debug_current]);
			if (GL_DEBUG_FNC)
			{
				GL_DEBUG_FNC();
			}
			gl_debug_state = 3;
		}
		else
		{
			gl_debug_state = 0;
		}
		return;	
	}
	if (gl_debug_state == 1)
	{
		GL_DEBUG_DEFAULT();
		gl_debug_state = 2;
		return;	
	}
	if (gl_debug_state == 0)
	{
		GL_DEBUG_DEFAULT();
		gl_debug_state = 1;
		return;	
	}
}


// low level code lifted from display.wdl. No need for separate file.
//----------------------------------------------------------------------
// section: General Settings

// entry: Screen Resolution
// entry_help: Set the initial screen resolution.
// entry_help: Note: Some resolutions may not be available on all video cards.
// entry_help:or for all versions of GStudio.
// entry_help: 1 - 320x200, 2 - 320x240, 3 - 320x400, 4 - 400x300,
// entry_help: 5 - 512x384, 6 - 640x480, 7 - 800x600, 8 - 1024x768
// entry_help: 9 - 1280x960, 10 - 1400x1050, 11 - 1600x1200
// cntl: spin 1 11 1
// id: 1
var   video_mode = 6;	// 800x600

// entry: Color Depth
// entry_help: Video color depth. Can be set to 16 (high-color) or 32 (true-color)
// cntl: spin 16 32 16
// id: 2
var 	video_depth = 32; // 16bit high-color

// entry: Force Full/Window?
// help: Force display to fullscreen (1) or windowed (2), or leave unchanged (0)
// cntl: spin 0 2 1
// id: 3
define	GL_force_window_full_const = 1;

// entry: Watermark Loc
// help: Select the corner where the watermark will appear.
// help:(0-off, 1-4 select corner)
// cntl: spin 0 4 1
// id: 4
var logo = 0;

//----------------------------------------------------------------------
// section: Limits

// entry: Max Entities
// help: Set the maximum number of entities.
// cntl: spin 0 x x
// id: 5
var max_entities = 500;

// entry: Max Particles
// help: Set the maximum number of Particles
// cntl: spin 0 x x
// id: 6
var max_particles = 2000;


//----------------------------------------------------------------------
// section: Frames Per Second (FPS)

// entry: FPS MAX
// help: Maximum frame per second (FPS)
// help: Note! TIME correction may not work at very high frame rates!
// cntl: spin 1 x 1
// id: 7
var fps_max = 75;

// entry: FPS MIN
// entry: Minimum frame per second (FPS)
// cntl: spin 1 x 1
// id: 8
var fps_min = 4;

// enable: FPS Lock
// help: Lock time step to maximum frame per second (FPS)
// id: 9
var fps_lock = ON;

// entry: Smoothing
// help: Average the last couple of frames to reduce "jerks"
// help: 0 = no smoothing, 0.5 = 2 frames, 0.99 = 10 frames
// id: 54
var	time_smooth = 0.00;

//----------------------------------------------------------------------
// section: Lighting

// entry: Max Dynamic
// entry_help: Gives the maxium number of dynamic lights (including the sun) that
// entry_help: can be active at the same time (Range: 2..8).
// cntl: spin 2 8 1
// id: 10
var max_lights = 8;


// enable: Dynamic Sun?
// help: Use directional light for sun?
// help: Note: This will use one of the dynamic lights.
// id: 11
var sun_light = 1;

//----------------------------------------------------------------------
// section: Shadow

// entry: Shadow Offset
// help: Set the distance that entity shadows are offset from the floor
// id: 12
var shadow_offset = 2.5;

// enable: Stencil Shadow
// help: Stencil shadows 'bend' around corners, and objects cast shadows on themselves.
// id: 53
var shadow_stencil = on;


//----------------------------------------------------------------------
// section: Entity Display Settings


// entry: Floor Range
// help: Set the range within which the light value of a entity is effected.
// cntl: spin 0 x 1
// id: 13
var floor_range = 1000;

// enable: Disable Trans. Sort
// help: (Advanced) Disable sorting of transparent entities
// id: 14
// var d3d_entsort = 0;

// enable: Share textures?
// help: (Advanced) Make map entities share texture with level and each other.
// id: 15
var tex_share = 1;



//----------------------------------------------------------------------
// section: Mouse

// entry: Mouse Icon
// help: Set the look of the windows mouse pointer when over the application window.
// entry_help:   0: The mouse pointer is always switched off over the window.
// entry_help:   1: The mouse pointer is switched off when mouse_mode is activated
// entry_help:        and a mouse_map is set, otherwise it's a hand.
// entry_help:   2: Like 1, but the mouse pointer is the standard arrow.
// entry_help:   3: Like 1, but the mouse pointer is a crosshair.
// entry_help:   4: Like 1, but the mouse pointer is a hourglass.
// cntl: spin 0 4 1
// id: 20
var	mouse_pointer = 0;	// turn off mouse pointer


//----------------------------------------------------------------------
// section: Advanced Settings

// entry: Anisotopy
// help: Maximum level of anisotopy (0 - off)
// help: Used to help eliminate distortion in textures whose surfaces
// help:are oriented with respect to the screen plane.
// help: Set to a value greater than 1.0 to activate.
// id: 21
var	d3d_anisotropy = 0;

// enable: Force Triple Buffer?
// help: (Advanced) Force triple buffering?
// id: 22
// var d3d_triplebuffer = 1;


// enable: Force VSync
// help: (Advanced) Force vertical sync?
// id: 24
// var d3d_vsync = 1;


// enable: Disable Mipmapping
// help: Deactivate mipmapping
// id: 26
// var d3d_mipmapping = 0;

// entry: Mipmap dist (flat)
// help: Set the relative distance for switching mipmap textures on flat surfaces
// id: 27
var mip_flat = 1.5;

// entry: Mipmap dist (shaded)
// help: Set the relative distance for switching mipmap textures on shaded surfaces
// id: 28
var mip_shaded = 1.0;

// enable: Adv. Light Res?
// help: Improve light resolution
// id: 29
// var d3d_lightres = 1;

// enable: Monochrome?
// help: Disable color lights
// id: 30
// var d3d_monochrome = 1;


// entry: Detail pixel num.
// help: Set the number of detail pixels per terrain surface pixel.
// id: 32
var GL_detail_size = 4;









//----------------------------------------------------------------------
// section: Clip Ranges

// entry: Clip Factor
// help: Multiplier for the clipping range or world (BSP) polygons.
// help: Example: A value of 2 would clip world polygons at twice
// help:the distance as object polygons.
// id: 40
var clip_factor = 2.0;

// entry: Clip Particles
// help: Multiplier for the clipping range of particles.
// help: Example: A value of 0.5 would clip particles at half the
// help:distance as object polygons.
// id: 41
var clip_particles = 0.5;

// entry: Clip Size
// help: Minimum number of pixels a polygon must cover before being clipped.
// help: Example: a value of 0.5 would clip polygons whose size is less
// help:than half a pixel.
// id: 42
var clip_size = 0.5;


function Gl_Event_Add(eventtype,data1,data2)
{
	if (GL_Event_Max < GL_Event_End)
	{
		GL_Mail_Slots[GL_Event_Max] = eventtype;
		GL_Mail_Slots[GL_Event_Max + 1] = data1;
		GL_Mail_Slots[GL_Event_Max + 2] = data2;
		GL_Event_Max += 3;
		return(0);
	}
	else
	{
		return(-1);
	}	
}

function GL_Event_Get(eventtype)
{
	var index = 0;
	while (index < GL_Event_Max)
	{
		if (GL_Mail_Slots[index] == eventtype)
		{
			return(index);
		}
		index += 3;
	}
	return(-1);
}

function GL_Event_Get_Data1(index)
{
	if (index >= 0 && index < GL_Event_Max)
	{
		return(GL_Mail_Slots[index+1]);
	}
	return(-1);
}

function GL_Event_Get_Data2(index)
{
	if (index >= 0 && index < GL_Event_Max)
	{
		return(GL_Mail_Slots[index+2]);
	}
	return(-1);
}

function GL_Event_Remove(index)
{
	if (index < 0 || index >= GL_Event_Max)
	{
		return;
	}
	while((index + 3) < GL_Event_Max)
	{
		vec_set(GL_Mail_Slots[index], GL_Mail_Slots[index + 3]);
		index += 3;
	}
	vec_set(GL_Mail_Slots[index],nullvect);
	GL_Event_Max -= 3;
}

function GL_Event_Manager()
{
	var index;
	me = null;
	while(1)
	{
		proc_late();
		index = GL_Event_Get(GL_MSG_DEBUG);
		if (index != -1)
		{
			GL_system_debug();
			GL_Event_Remove(index);
		}
		index = GL_Event_Get(GL_MSG_CONSOLE);
		if (index != -1)
		{
			if (GL_CONSOLE != NULL)
			{
				GL_CONSOLE();
			}
			GL_Event_Remove(index);
		}
		index = GL_Event_Get(GL_MSG_MENU);
		if (index != -1)
		{
			if (GL_Game_state != GL_level_loaded)
			{
				if (GL_START_MENU != NULL)
				{
					GL_START_MENU();
				}
			}
			if (GL_Game_state == GL_level_loaded)
			{
				if (GL_INGAME_MENU != NULL)
				{
					GL_INGAME_MENU();
				}
			}
			GL_Event_Remove(index);
		}
		index = GL_Event_Get(GL_MSG_HELP);
		if (index != -1)
		{
			if (GL_HELP != NULL)
			{
				GL_HELP();
			}
			GL_Event_Remove(index);
		}
		index = 0;
		if (GL_Event_Start)
		{
			//clean un consumed events from system
			//this should be made more effecient later
			while(index < GL_Event_Start)
			{
				GL_Event_Remove(0);
				index += 3;
			}
		}
		// mark where we started adding for next frame. 
		// This gives us one frame pre event to consume it.
		// after one frame assume no consumer and remove it.
		GL_Event_Start = GL_Event_Max;
		wait(1);
	}
}

// function_help: Init display values
// Init values
// Update views using assigned update functions
function	Globals00_startup()
{
	diag("\nWDL-Loaded:Globals00.wdl");

// entry: Near Camera clip
// help: Reduce this value if you can see through near objects
// cntl: spin 1 x 1
// id: 43
	camera.clip_near = 10;

// entry: Far Camera clip
// help: Increase this value if objects vanish too soon.
// cntl: spin 1 x 1
// id: 44
	camera.clip_far = 50000;

	// force a switch on the video modes if display00_force_window_full_const is set
	if(GL_force_window_full_const != 0) { video_switch(0,0,GL_force_window_full_const); }

//----------------------------------------------------------------------
// section: Background Color

// entry: Red
// help: Set background color's red component.
// help: Note: if all three components are set to 0, no background color is drawn.
// cntl: spin 0 255 1
// id: 45
	bg_color.red = 1;
// entry: Green
// help: Set background color's green component.
// help: Note: if all three components are set to 0, no background color is drawn.
// cntl: spin 0 255 1
// id: 46
	bg_color.green = 1;
// entry: Blue
// help: Set background color's blue component.
// help: note: if all three components are set to 0, no background color is drawn.
// cntl: spin 0 255 1
// id: 47
	bg_color.blue = 1;


//----------------------------------------------------------------------
//  section: Fog Settings

// entry: Fog color Index
// entry_help: Select the fog color from the Map Prop panel in WED.
// cntl: spin 0 5 1
// id: 52
	fog_color = 1;

// entry: Fog Start
// help: Percent of clip_range until fog start
// help: There won't be any fog closer than fog_start
// id: 50
	camera.fog_start = 75;
	camera.fog_start /= 100;
	if(camera.fog_start < 0) { camera.fog_start = 0; }


// entry: Fog End
// help: Percent of clip_range until fog end
// help:  The world will be all foggy beyond fog_end
// id: 51
	camera.fog_end = 90;
	camera.fog_end /= 100;
	if(camera.fog_end < 0) { camera.fog_end = 0; }

	camera.fog_start = camera.fog_start *  camera.clip_far; // fog at 80% of clip_range
	camera.fog_end = camera.fog_end *  camera.clip_far; // fog till 90% of clip_range
	
	GL_Event_Manager();	//start event manager 
	
	GL_DEBUG_DEFAULT = ON_F11;
	GL_START_MENU = ON_ESC;
	ON_F11 = NULL;
	ON_TAB = NULL;
	ON_F10 = NULL;
	ON_ESC = NULL;
}


endif;