ifndef menu_wdl;
define menu_wdl;
// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 1.00
// date: 060512
//
// title: MENU
// class: MENU
// type: SUPPORT
// image: menu.pcx
// help: menu integrated with level system
//
// this started life as an AUM article... original code was about 100 lines
// it is now at 650 lines and I removed most of game specific code before I 
// started. 
//
// Added exit panel to main menu
// Added in game menu
// added help outside of menu
// added background panel
// added exit to main menu from in game menu
// generalized code for eazy modification
// added gamma panel on layer 2
// added integration to messaging systm
// 
// ENDHEADER
// ---------------------------------------------------------------------



define menu_game_video_min = 6;
define menu_game_video_max = 9;

var menu_game_started = 0; // will be set to 1 when the game starts
var menu_resume_game_flag = 0;
var menu_in_menu = 0;

define menu_hot_spot_x = 31;
define menu_hot_spot_y = 17;
define menu_pointer_time1 = 7;
define menu_pointer_time2 = 7;
define menu_view_x = 0;
define menu_view_y = 0;
define menu_view_z = 350;
define menu_view_tilt = -90;
define menu_view_pan = 0;
bmap menu_pointer1_img = <pointer1.tga>; // mouse pointer
bmap menu_pointer2_img = <pointer2.tga>; // second version of the mouse pointer

//////////////////////////////////////////////////////////////////////////

define menu_use_background_img;
//define menu_main_not_overlay;

ifdef menu_use_background_img;
bmap menu_background_img 		= <menubackground.tga>; 	// main panel
endif;
bmap menu_main_img 				= <menupan.tga>; 	// main panel
bmap menu_in_game_img 			= <menupan.tga>; 	// main in game panel
bmap menu_exit_conferm_img 	= <exitconferm.tga>;

bmap menu_help_img = <help.tga>; // help panel


bmap menu_new1_img     = <menubtn1.tga>;
bmap menu_new2_img     = <menubtn1a.tga>;
bmap menu_new3_img     = <menubtn1b.tga>;
bmap menu_resume1_img  = <menubtn2.tga>;
bmap menu_resume2_img  = <menubtn2a.tga>;
bmap menu_resume3_img  = <menubtn2b.tga>;
bmap menu_options1_img = <menubtn3.tga>;
bmap menu_options2_img = <menubtn3a.tga>;
bmap menu_save1_img    = <menubtn4.tga>;
bmap menu_save2_img    = <menubtn4a.tga>;
bmap menu_save3_img    = <menubtn4b.tga>;
bmap menu_load1_img    = <menubtn5.tga>;
bmap menu_load2_img    = <menubtn5a.tga>;
bmap menu_help1_img    = <menubtn6.tga>;
bmap menu_help2_img    = <menubtn6a.tga>;
bmap menu_exit1_img    = <menubtn7.tga>;
bmap menu_exit2_img    = <menubtn7a.tga>;
bmap menu_exit_yes1_img= <yesbtn.tga>;
bmap menu_exit_yes2_img= <yesbtna.tga>;
bmap menu_exit_no1_img = <nobtn.tga>;
bmap menu_exit_no2_img = <nobtna.tga>;
bmap menu_gamma_img	  = <gamma.tga>;

sound menu_beep_sound = <beep.wav>;
sound menu_mouse_wav = <mouse.wav>;
sound menu_menu_wav = <menu.wav>; // used for main / help menu switching


function menu_mouse_over();
function menu_exit_game();
function menu_save_game();
function menu_load_game();
function menu_show_help();
function menu_show_help2();
function menu_show_main();
function menu_new_game();
function menu_resume_game();
function menu_options_game();
function menu_exit_game_conferm();
function menu_dont_exit_game();
function menu_main();
function menu_in_game();

ifdef menu_use_background_img;
panel menu_background_pan // main panel
{
	bmap = menu_background_img;
	layer = 20;
	pos_x = 0;
	pos_y = 0; 
}
endif;

panel menu_gamma_pan // main panel
{
	bmap = menu_gamma_img;
	layer = 2;
	pos_x = 0;
	pos_y = 0;
	alpha = 0;
	flags = refresh, transparent, visible; 
}

panel menu_main_pan // main panel
{
	bmap = menu_main_img;
	layer = 21;
	pos_x = 0;
	pos_y = 0; 
	
	button = 570,203, menu_new2_img,     menu_new1_img,     menu_new2_img,     menu_new_game,     null, menu_mouse_over;
	button = 570,244, menu_resume3_img,  menu_resume3_img,  menu_resume3_img,  null,              null, null;
	button = 568,284, menu_options2_img, menu_options1_img, menu_options2_img, menu_options_game, null, menu_mouse_over;
	button = 570,323, menu_save3_img,    menu_save3_img,    menu_save3_img,    null,              null, null;
	button = 570,364, menu_load2_img,    menu_load1_img,    menu_load2_img,    menu_load_game,    null, menu_mouse_over;
	button = 570,404, menu_help2_img     menu_help1_img,    menu_help2_img,    menu_show_help,    null, menu_mouse_over;
	button = 570,444, menu_exit2_img     menu_exit1_img,    menu_exit2_img,    menu_exit_game,    null, menu_mouse_over;
ifdef menu_main_not_overlay;
	flags = refresh;
ifelse;	
	flags = refresh, overlay;
endif;
}

panel menu_in_game_pan // main in game panel
{
	bmap = menu_in_game_img;
	layer = 21;
	pos_x = 0;
	pos_y = 0; 
	
	button = 570,203, menu_new3_img,     menu_new3_img,     menu_new3_img,     null,              null, null;
	button = 570,244, menu_resume2_img,  menu_resume1_img,  menu_resume2_img,  menu_resume_game,  null, menu_mouse_over;
	button = 568,284, menu_options2_img, menu_options1_img, menu_options2_img, menu_options_game, null, menu_mouse_over;
	button = 570,323, menu_save2_img,    menu_save1_img,    menu_save2_img,    menu_save_game,    null, menu_mouse_over;
	button = 570,364, menu_load2_img,    menu_load1_img,    menu_load2_img,    menu_load_game,    null, menu_mouse_over;
	button = 570,404, menu_help2_img     menu_help1_img,    menu_help2_img,    menu_show_help2,   null, menu_mouse_over;
	button = 570,444, menu_exit2_img     menu_exit1_img,    menu_exit2_img,    menu_exit_game2,   null, menu_mouse_over;

	flags = refresh, overlay;
}

panel menu_exit_conferm_pan // exit panel
{
	bmap = menu_exit_conferm_img;
	layer = 22;
	pos_x = 0;
	pos_y = 0; 
	button = 255, 293, menu_exit_yes2_img, menu_exit_yes1_img, menu_exit_yes2_img, menu_exit_game_conferm, null, menu_mouse_over;
	button = 480, 295, menu_exit_no2_img,  menu_exit_no1_img,  menu_exit_no2_img,  menu_dont_exit_game,    null, menu_mouse_over;

	flags = refresh, overlay;
}

panel menu_help_pan // help panel
{
	bmap = menu_help_img;
	layer = 22;
	pos_x = 0; 
	pos_y = 601; // for now 
	on_click = menu_show_main;

	flags = refresh; // pos_y = 601 keeps the panel outside the screen for now
}

panel menu_help2_pan // help panel
{
	bmap = menu_help_img;
	layer = 22;
	pos_x = 0; 
	pos_y = 601; // for now 

	flags = refresh; // pos_y = 601 keeps the panel outside the screen for now
}


///////////////////////////////////////////////////////////////////////////

function menu_main()
{
	var frameCount;
	
	if (menu_in_menu)
	{
		return;
	}
	menu_in_menu = 1;

	GL_Game_state = GL_level_not_loaded;

	clib_scale_panel(menu_help_pan,screen_size.x,screen_size.y);
	clib_scale_panel(menu_main_pan,screen_size.x,screen_size.y);
	clib_scale_panel(menu_exit_conferm_pan,screen_size.x,screen_size.y);
	clib_scale_panel(menu_gamma_pan,screen_size.x,screen_size.y);
ifdef menu_use_background_img;
	clib_scale_panel(menu_background_pan,screen_size.x,screen_size.y);
endif;

	Level_Load_number(0);
	wait (18);
	
	mouse_spot.x = menu_hot_spot_x; // ~ 63 / 2
	mouse_spot.y = menu_hot_spot_y; // ~ 35 / 2
	camera.x = menu_view_x; // choose a convenient camera position
	camera.y = menu_view_y;
	camera.z = menu_view_z;
	camera.tilt = menu_view_tilt; // and angle
	camera.pan = menu_view_pan;
	mouse_mode = 2; // show the pointer
	frameCount = menu_pointer_time1;
	
ifdef menu_use_background_img;
	menu_background_pan.visible = on;
endif;

	menu_main_pan.visible = on;
	menu_game_started = 0;
	while (menu_game_started == 0) // as long as we haven't started the game
	{
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;
		if (frameCount < 0) 
		{
			if (mouse_map == menu_pointer1_img) {
				mouse_map = menu_pointer2_img;
				frameCount = menu_pointer_time2;
			}
			else
			{
				mouse_map = menu_pointer1_img;
				frameCount = menu_pointer_time1;
			}
		}
		else
		{
			frameCount -= 1;
		}
		wait (1); 		      
	}
	menu_in_menu = 0;   
}	

function menu_in_game()
{
	var frameCount;
	var oldmouse;
	
	if (menu_in_menu) 
	{
		return;
	}
	menu_in_menu = 1;
	
	clib_scale_panel(menu_help_pan,screen_size.x,screen_size.y);
	clib_scale_panel(menu_in_game_pan,screen_size.x,screen_size.y);
	clib_scale_panel(menu_exit_conferm_pan,screen_size.x,screen_size.y);


	oldmouse = mouse_mode;
	mouse_spot.x = menu_hot_spot_x; // ~ 63 / 2
	mouse_spot.y = menu_hot_spot_y; // ~ 35 / 2
	mouse_mode = 2; // show the pointer
	frameCount = menu_pointer_time1;
	
	menu_in_game_pan.visible = on;
	freeze_mode = 1;
	GL_Game_state = GL_level_pause;
	
	menu_resume_game_flag = 0;
	if (Key_Pressed(plFpsInput_system_menu_scancode))
	{
		while (Key_Pressed(plFpsInput_system_menu_scancode))
		{
			wait(1);
		}
	}
	menu_resume_game_flag = 0;
	while (menu_resume_game_flag == 0) // as long as we haven't started the game
	{
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;
		if (frameCount < 0) 
		{
			if (mouse_map == menu_pointer1_img) {
				mouse_map = menu_pointer2_img;
				frameCount = menu_pointer_time2;
			}
			else
			{
				mouse_map = menu_pointer1_img;
				frameCount = menu_pointer_time1;
			}
		}
		else
		{
			frameCount -= 1;
		}
		wait(1);
		if (Key_Pressed(plFpsInput_system_menu_scancode))
		{
			menu_resume_game();
		} 		      
	}
	mouse_mode = oldmouse;   

	menu_in_game_pan.visible = off;
	freeze_mode = 0;
	GL_Game_state = GL_level_loaded;
	menu_in_menu = 0;
}	

function menu_resume_game()
{
	menu_resume_game_flag = 1;
	menu_in_game_pan.visible = off;
	menu_help_pan.pos_y = 601;
	menu_help_pan.visible = off;
}

function menu_mouse_over() // is executed when we are over the menu buttons
{
	snd_play (menu_mouse_wav, 70, 0);
}	

var menu_do_exit_game;
var menu_do_exit_processed;

function menu_exit_game()
{
	menu_do_exit_game = 0;
	menu_do_exit_processed = 0;
	menu_exit_conferm_pan.visible = on;
	while (menu_do_exit_processed == 0)
	{
		wait(1);
	}
	menu_exit_conferm_pan.visible = off;
	if (menu_do_exit_game)
	{
		exit;
	}
}

function menu_exit_game2()
{
	menu_do_exit_game = 0;
	menu_do_exit_processed = 0;
	menu_exit_conferm_pan.visible = on;
	while (menu_do_exit_processed == 0)
	{
		wait(1);
	}
	menu_exit_conferm_pan.visible = off;
	if (menu_do_exit_game)
	{
		menu_resume_game_flag = 1;
		menu_game_started = 0;
		wait(2); //give time for in game menu to exit
		
		if (Key_Pressed(280) == on)
		{
			while(Key_Pressed(280) == on)
			{
				wait(1);
			}
		}

		menu_main();
	}
}


function menu_load_game() 
{
	beep;
}

function menu_save_game()
{
	beep;
}

var menu_bail_show_help;

function menu_show_help()
{
	var help_pos;
	if (video_mode == 6)
	{
		help_pos = 481;
	}
	if (video_mode == 7)
	{
		help_pos = 601;
	}
	if (video_mode == 8)
	{
		help_pos = 769;
	}
	if (video_mode == 9)
	{
		help_pos = 1025;
	}
	menu_help_pan.pos_y = help_pos;
	menu_help_pan.visible = on;
	menu_bail_show_help = 0;
	while ((menu_bail_show_help==0) && (menu_help_pan.pos_y-10 > 0))
	{
		menu_help_pan.pos_y -= 10; // keep help_pan glued to main_pan
		wait (1);
	}
	menu_help_pan.pos_y = 0;
	snd_play (menu_menu_wav, 20, 0);
}

function menu_show_help2()
{
	var help_pos;
	if (video_mode == 6)
	{
		help_pos = 481;
	}
	if (video_mode == 7)
	{
		help_pos = 601;
	}
	if (video_mode == 8)
	{
		help_pos = 769;
	}
	if (video_mode == 9)
	{
		help_pos = 1025;
	}
	menu_help_pan.pos_y = help_pos;
	menu_help_pan.visible = on;
	menu_bail_show_help = 0;
	while ((menu_bail_show_help==0) && (menu_help_pan.pos_y-10 > 0))
	{
		menu_help_pan.pos_y -= 10; // keep help_pan glued to main_pan
		wait (1);
	}
	menu_help_pan.pos_y = 0;
	snd_play (menu_menu_wav, 20, 0);
}

function menu_show_main()
{
	var help_pos;
	if (video_mode == 6)
	{
		help_pos = 481;
	}
	if (video_mode == 7)
	{
		help_pos = 601;
	}
	if (video_mode == 8)
	{
		help_pos = 769;
	}
	if (video_mode == 9)
	{
		help_pos = 1025;
	}
	menu_bail_show_help = 1;
	wait(1);
	while (menu_help_pan.pos_y+10 < help_pos)
	{
		menu_help_pan.pos_y += 10; // keep help_pan glued to main_pan
		wait (1);
	}
	menu_help_pan.pos_y = help_pos;
	snd_play (menu_menu_wav, 20, 0);
	menu_help_pan.visible = off;
}

function menu_options_game()
{
	beep;
}


function menu_new_game()
{
	mouse_mode = 0; // hide the pointer
	menu_main_pan.visible = off; // hide main_pan
	menu_help_pan.visible = off;
ifdef menu_use_background_img;
	menu_background_pan.visible = off;
endif;
	menu_in_menu = 0;
	menu_game_started = 1;
	
	if (Key_Pressed(280) == on)
	{
		while(Key_Pressed(280) == on)
		{
			wait(1);
		}
	}

	Level_Load_number(1);
	GL_Game_state = GL_level_loaded;
	wait(3);
}

function menu_exit_game_conferm()
{
	menu_do_exit_game = 1;
	menu_do_exit_processed = 1;
}

function menu_dont_exit_game()
{
	menu_do_exit_game = 0;
	menu_do_exit_processed = 1;
}

function menu_help()
{
	var help_pos;
	var frameCount;
	var oldmouse;
	my = null;
	
	if (menu_in_menu)
	{
		return;
	}
	menu_in_menu = 1;
	if (video_mode == 6)
	{
		help_pos = 481;
		clib_scale_panel(menu_help2_pan,640,480);
	}
	if (video_mode == 7)
	{
		help_pos = 601;
		clib_scale_panel(menu_help2_pan,800,600);
	}
	if (video_mode == 8)
	{
		help_pos = 769;
		clib_scale_panel(menu_help2_pan,1024,768);
	}
	if (video_mode == 9)
	{
		help_pos = 1025;
		clib_scale_panel(menu_help2_pan,1280,1024);
	}
	freeze_mode = 1;
	menu_help2_pan.pos_y = help_pos;
	menu_help2_pan.visible = on;
	while (menu_help2_pan.pos_y-10 > 0)
	{
		menu_help2_pan.pos_y -= 10; // keep help_pan glued to main_pan
		wait (1);
	}
	menu_help_pan.pos_y = 0;
	snd_play (menu_menu_wav, 20, 0);

	oldmouse = mouse_mode;
	mouse_spot.x = menu_hot_spot_x; // ~ 63 / 2
	mouse_spot.y = menu_hot_spot_y; // ~ 35 / 2
	mouse_mode = 2; // show the pointer
	frameCount = menu_pointer_time1;
	mouse_map = menu_pointer1_img;
	GL_Game_state = GL_level_pause;
	
	menu_resume_game_flag = 0;
	while (menu_resume_game_flag == 0) // as long as we haven't started the game
	{
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;
		if (frameCount < 0) 
		{
			if (mouse_map == menu_pointer1_img) {
				mouse_map = menu_pointer2_img;
				frameCount = menu_pointer_time2;
			}
			else
			{
				mouse_map = menu_pointer1_img;
				frameCount = menu_pointer_time1;
			}
		}
		else
		{
			frameCount -= 1;
		}
		wait(1);
		if (Key_Pressed(280) == on)
		{
			menu_resume_game_flag = 1;
		} 		      
	}
	
	//wait till mouse released
	if (Key_Pressed(280) == on)
	{
		while(Key_Pressed(280) == on)
		{
			wait(1);
		}
	}

	wait(1);
	mouse_mode = oldmouse;   
	while (menu_help2_pan.pos_y+10 < help_pos)
	{
		menu_help2_pan.pos_y += 10; // keep help_pan glued to main_pan
		wait (1);
	}
	
	menu_help2_pan.pos_y = help_pos;
	snd_play (menu_menu_wav, 20, 0);
	menu_help2_pan.visible = off;
	clib_scale_panel(menu_help2_pan,800,600);

	freeze_mode = 0;
	GL_Game_state = GL_level_loaded;
	menu_in_menu = 0;
}


function menu_startup()
{
	wait(2);
	GL_START_MENU = menu_main;
	GL_INGAME_MENU = menu_in_game;
	GL_HELP = menu_help;
}

endif;
