ifndef _MiscInput_wdl;
define _MiscInput_wdl;
// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 1.00
// date: 060510
//
// title: MiscInput
// class: input
// type: SUPPORT
// image: miscinput.pcx
// help: Helper functions for keyboard mapping.
//
// Made input string a parameter so calling code avoides a str_cpy
// added keycode to string lookup function.
// changed some of the strings to be config panel ready. ie "cur up" not "CUU"
// ENDHEADER
// ---------------------------------------------------------------------


function MiscInput_str_for_key(ScanCode);
function	MiscInput_Key_For_Str(str);


string	MiscInput_temp_str[256];	// temp string
string*  MiscInput_temp_pointer;
// Desc: Return the scancode for the key corresponding to the string passed in
//
// Note: Assume we are using a US keyboard layout.
function	MiscInput_Key_For_Str(str)
{
	MiscInput_temp_pointer = str;
	str_cpy(MiscInput_temp_str, MiscInput_temp_pointer);
	
	// check for single letter strings
	if(str_len(MiscInput_temp_str) == 1)
	{
		// simple keycode (A-Z, 0-9)
		return(Key_For_Str(MiscInput_temp_str));
	}

	// Note: str_cmpi is string compare without case sensitivity.


	// Mouse Buttons
  	if(1 == str_cmpni(MiscInput_temp_str,"mouse")) // possible mouse button
	{
  		if(1 == str_cmpi(MiscInput_temp_str,"mouse lt")) // left mouse button
		{
			return(280);	// left mouse button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"mouse mid")) // middle mouse button
		{
			return(282);	// middle mouse button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"mouse rt")) // right mouse button
		{
			return(281);	// right mouse button scancode
		}
	}

	// Joystick Buttons
  	if(1 == str_cmpni(MiscInput_temp_str,"joy")) // possible joystick button
	{
  		if(1 == str_cmpni(MiscInput_temp_str,"joy2")) // possible second joystick button
		{
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_1")) // joy2 1 button
			{
				return(268);	// joy2 1 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_2")) // joy2 2 button
			{
				return(269);	// joy2 2 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_3")) // joy2 3 button
			{
				return(270);	// joy2 3 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_4")) // joy2 4 button
			{
				return(271);	// joy2 4 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_5")) // joy2 5 button
			{
				return(272);	// joy2 5 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_6")) // joy2 6 button
			{
				return(273);	// joy2 6 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_7")) // joy2 7 button
			{
				return(274);	// joy2 7 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_8")) // joy2 8 button
			{
				return(275);	// joy2 8 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_9")) // joy2 9 button
			{
				return(276);	// joy2 9 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_10")) // joy2 10 button
			{
				return(277);	// joy2 10 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_11")) // joy2 11 button
			{
				return(278);	// joy2 11 button scancode
			}
  			if(1 == str_cmpi(MiscInput_temp_str,"joy2_12")) // joy2 12 button
			{
				return(279);	// joy2 12 button scancode
			}
		}// end joy2_ buttons

		// first joystick buttons
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_1")) // joy 1 button
		{
			return(256);	// joy 1 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_2")) // joy 2 button
		{
			return(257);	// joy 2 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_3")) // joy 3 button
		{
			return(258);	// joy 3 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_4")) // joy 4 button
		{
			return(259);	// joy 4 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_5")) // joy 5 button
		{
			return(260);	// joy 5 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_6")) // joy 6 button
		{
			return(261);	// joy 6 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_7")) // joy 7 button
		{
			return(262);	// joy 7 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_8")) // joy 8 button
		{
			return(263);	// joy 8 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_9")) // joy 9 button
		{
			return(264);	// joy 9 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_10")) // joy 10 button
		{
			return(265);	// joy 10 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_11")) // joy 11 button
		{
			return(266);	// joy 11 button scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"joy_12")) // joy 12 button
		{
			return(267);	// joy 12 button scancode
		}
	}// end joystick buttons


	// keyboard function keys
  	if(1 == str_cmpni(MiscInput_temp_str,"f")) // possible function key
	{
  		if(1 == str_cmpi(MiscInput_temp_str,"f12")) // F12 key
		{
			return(88);	// f12 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f11")) // F11 key
		{
			return(87);	// f11 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f10")) // F10 key
		{
			return(68);	// f10 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f9")) // F9 key
		{
			return(67);	// f9 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f8")) // F8 key
		{
			return(66);	// f8 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f7")) // F7 key
		{
			return(65);	// f7 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f6")) // F6 key
		{
			return(64);	// f6 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f5")) // F5 key
		{
			return(63);	// f5 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f4")) // F4 key
		{
			return(62);	// f4 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f3")) // F3 key
		{
			return(61);	// f3 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f2")) // F2 key
		{
			return(60);	// f2 scancode
		}
  		if(1 == str_cmpi(MiscInput_temp_str,"f1")) // F1 key
		{
			return(59);	// f1 scancode
		}
	}

	// other special keyboard keys
  	if(1 == str_cmpi(MiscInput_temp_str,"esc")) // esc key
	{
		return(1);	// esc key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"bksp")) // backspace key
	{
		return(14);	// backspace or Losch key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"tab")) // tab key
	{
		return(15);	// tab key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"enter")) // enter key
	{
		return(28);	// enter key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"shiftl")) // left shift key
	{
		return(42);	// left shift key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"shiftr")) // right shift key
	{
		return(54);	// right shift key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"ctrl")) // ctrl key
	{
		return(29);	// ctrl key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"alt")) // alt key
	{
		return(56);	// alt key scancode
	}

  	if(1 == str_cmpi(MiscInput_temp_str,"prtsc")) // print scn key
	{
		return(55);	// print scn key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"numlock")) // numlock key
	{
		return(69);	// numlock key scancode
	}

	if(1 == str_cmpi(MiscInput_temp_str,"scrlock")) // Scroll Lock key
	{
		return(70);	// scroll lock key scancode
	}

  	if(1 == str_cmpi(MiscInput_temp_str,"ins")) // insert key
	{
		return(82);	// insert key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"del")) // delete key
	{
		return(83);	// delete key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"home")) // home key
	{
		return(71);	// home key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"end")) // end key
	{
		return(79);	// end key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"pg up")) // page up key
	{
		return(73);	// page up key scancode
	}
  	if(1 == str_cmpi(MiscInput_temp_str,"pg dn")) // page down key
	{
		return(81);	// page down key scancode
	}

	// cursor keys
	if(1 == str_cmpi(MiscInput_temp_str,"cur up")) // up cursor key
	{
		return(72);	// up cursor key scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"cur dn")) // down cursor key
	{
		return(80);	// down cursor key scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"cur lt")) // left cursor key
	{
		return(75);	// left cursor key scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"cur rt")) // right cursor key
	{
		return(77);	// right cursor key scancode
	}

	if(1 == str_cmpi(MiscInput_temp_str,"kp minus")) // Keypad Minus
	{
		return(74);	// Keypad Minus scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"kp plus")) // Keypad Plus
	{
		return(78);	// Keypad Plus scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"kp ast")) // Keypad Asterix
	{
		return(55);	// Keypad Asterix scancode
	}


	if(1 == str_cmpi(MiscInput_temp_str,"grave")) // grave key "~"
	{
		return(41);	// grave key scancode
	}

	if(1 == str_cmpi(MiscInput_temp_str,"minus")) // minus key
	{
		return(12);	// minus key scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"equal")) // equal key
	{
		return(13);	// equal key scancode
	}

	if(1 == str_cmpi(MiscInput_temp_str,"brackl")) // left bracket key
	{
		return(26);	// left bracket key scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"brackr")) // right bracket key
	{
		return(27);	// right bracket key scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"bksl")) // backslash key
	{
		return(43);	// backslash key scancode
	}

	if(1 == str_cmpi(MiscInput_temp_str,"semic")) // semicolon key
	{
		return(39);	// semicolon key scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"apos")) // apos "'" key
	{
		return(40);	// apos "'" key scancode
	}


	if(1 == str_cmpi(MiscInput_temp_str,"comma")) // comma key
	{
		return(51);	// comma key scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"period")) // period key
	{
		return(52);	// period key scancode
	}
	if(1 == str_cmpi(MiscInput_temp_str,"slash")) // slash key
	{
		return(53);	// slash key scancode
	}

  	if(1 == str_cmpi(MiscInput_temp_str,"space")) // space bar
	{
		return(57);	// space bar scancode
	}
}

string __MiscInput_Pvt_tmp[10];

function MiscInput_str_for_key(ScanCode)
{
	// function keys
	if (((scanCode >= 59) && (ScanCode <= 68)) || ScanCode == 87 || ScanCode == 88)
	{
		if (ScanCode <= 68)
		{
			str_for_num(__MiscInput_Pvt_tmp,ScanCode - 58);
		}
		else
		{
			str_for_num(__MiscInput_Pvt_tmp,ScanCode - 76);
		}
		
		str_cpy(MiscInput_temp_str,"f");
		str_cat(MiscInput_temp_str,__MiscInput_Pvt_tmp);
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	
	// mouse keys
	if ((ScanCode >= 280) && (ScanCode <= 282))
	{
		if (ScanCode == 280)
		{
			str_cpy(MiscInput_temp_str,"mouse lt");
		} else {
			if (ScanCode == 281)
			{
				str_cpy(MiscInput_temp_str,"mouse rt");
			} else {
				str_cpy(MiscInput_temp_str,"mouse mid");
			}
		}
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	
	// joystick 2 keys
	if ((ScanCode >= 268) && (ScanCode <= 279))
	{
		str_cpy(MiscInput_temp_str,"joy2_");
		str_for_num(__MiscInput_Pvt_tmp,ScanCode - 267);
		str_cat(MiscInput_temp_str,__MiscInput_Pvt_tmp);
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}

	// joystick 1 keys
	if ((ScanCode >= 256) && (ScanCode <= 267))
	{
		str_cpy(MiscInput_temp_str,"joy_");
		str_for_num(__MiscInput_Pvt_tmp,ScanCode - 255);
		str_cat(MiscInput_temp_str,__MiscInput_Pvt_tmp);
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}

	// other special keyboard keys
  	if(1 == ScanCode) // esc key
	{
		str_cpy(MiscInput_temp_str,"esc");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(14 == ScanCode) // backspace key
	{
		str_cpy(MiscInput_temp_str,"bksp");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(15 == ScanCode) // tab key
	{
		str_cpy(MiscInput_temp_str,"tab");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(28 == ScanCode) // enter key
	{
		str_cpy(MiscInput_temp_str,"enter");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(42 == ScanCode) // left shift key
	{
		str_cpy(MiscInput_temp_str,"shiftl");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(54 == ScanCode) // right shift key
	{
		str_cpy(MiscInput_temp_str,"shiftr");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(29 == ScanCode) // ctrl key
	{
		str_cpy(MiscInput_temp_str,"ctrl");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(56 == ScanCode) // alt key
	{
		str_cpy(MiscInput_temp_str,"alt");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(55 == ScanCode) // print scn key
	{
		str_cpy(MiscInput_temp_str,"prtsc");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(69 == ScanCode) // numlock key
	{
		str_cpy(MiscInput_temp_str,"numlock");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(70 == ScanCode) // Scroll Lock key
	{
		str_cpy(MiscInput_temp_str,"scrlock");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(82 == ScanCode) // insert key
	{
		str_cpy(MiscInput_temp_str,"ins");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(83 == ScanCode) // delete key
	{
		str_cpy(MiscInput_temp_str,"del");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(71 == ScanCode) // home key
	{
		str_cpy(MiscInput_temp_str,"home");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(79 == ScanCode) // end key
	{
		str_cpy(MiscInput_temp_str,"end");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(73 == ScanCode) // page up key
	{
		str_cpy(MiscInput_temp_str,"pg up");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
  	if(81 == ScanCode) // page down key
	{
		str_cpy(MiscInput_temp_str,"pg dn");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	// cursor keys
	if(72 == ScanCode) // up cursor key
	{
		str_cpy(MiscInput_temp_str,"cur up");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(80 == ScanCode) // down cursor key
	{
		str_cpy(MiscInput_temp_str,"cur dn");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(75 == ScanCode) // left cursor key
	{
		str_cpy(MiscInput_temp_str,"cur lt");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(77 == ScanCode) // right cursor key
	{
		str_cpy(MiscInput_temp_str,"cur rt");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(74 == ScanCode) // Keypad Minus
	{
		str_cpy(MiscInput_temp_str,"kp minus");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(78 == ScanCode) // Keypad Plus
	{
		str_cpy(MiscInput_temp_str,"kp plus");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(55 == ScanCode) // Keypad Asterix
	{
		str_cpy(MiscInput_temp_str,"kp ast");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(41 == ScanCode) // grave key "~"
	{
		str_cpy(MiscInput_temp_str,"grave");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(12 == ScanCode) // minus key
	{
		str_cpy(MiscInput_temp_str,"minus");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(13 == ScanCode) // equal key
	{
		str_cpy(MiscInput_temp_str,"equal");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(26 == ScanCode) // left bracket key
	{
		str_cpy(MiscInput_temp_str,"brackl");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(27 == ScanCode) // right bracket key
	{
		str_cpy(MiscInput_temp_str,"brackr");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(43 == ScanCode) // backslash key
	{
		str_cpy(MiscInput_temp_str,"bksl");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(39 == ScanCode) // semicolon key
	{
		str_cpy(MiscInput_temp_str,"semic");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(40 == ScanCode) // apos "'" key
	{
		str_cpy(MiscInput_temp_str,"apos");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(51 == ScanCode) // comma key
	{
		str_cpy(MiscInput_temp_str,"comma");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(52 == ScanCode) // period key
	{
		str_cpy(MiscInput_temp_str,"period");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	if(53 == ScanCode) // slash key
	{
		str_cpy(MiscInput_temp_str,"slash");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}

  	if(57 == ScanCode) // space bar
	{
		str_cpy(MiscInput_temp_str,"space");
		MiscInput_temp_pointer = MiscInput_temp_str;
		return(MiscInput_temp_pointer);	
	}
	
	str_cpy(MiscInput_temp_str,""); // make sure that string is empty first
	str_for_key(MiscInput_temp_str,ScanCode);
	MiscInput_temp_pointer = MiscInput_temp_str;
	return(MiscInput_temp_pointer);	
}

endif;
