ifndef invent02_wdl;
define invent02_wdl;

// ver: 1
// date: 040916
// Author Gordon Tackett - gt@westmarch.com
//	Copyright 2004 westmarch development inc. All rights reserved.
//
// title: Inventory (02)
// image: invent02.pcx
// help: Handle a complex visual inventory system.
// idcode: 0c0
// prefix: invent02_
//

//----------------------------------------------------------------------
// function prototypes

function _invent02_scroll_left();
function _invent02_scroll_right();
function _invent02_update_display();
function _invent02_format_msg(item);
function _invent02_move_msg();
function _invent02_hide_msg();
function _invent02_msg_decay();
function _invent02_show_msg();
function _invent02_mouse_on();
function _invent02_pickup_event();
function _invent02_IsItemInInventory(item);
function _invent02_AddItemToInventory(item,item_type);
function _invent02_RemoveItemfromInventory(ItemIndex);
function _invent02_wait_for_add();
function _invent02_AddItemToUsed(item);
function _invent02_HasItemBeenUsed(item);
function _invent02_use(index);
function _invent02_get_action(index);

function togle_inventory();

// ---------------------------------------------------------------------
// section: Background Panel
// entry: Screen Pointer
// entry_help: Mouse porinter for the inventory display
// id: 1
bmap _invent02_arrow,<arrow.pcx>;

// ---------------------------------------------------------------------
// entry: left button off
// id: 2
bmap _invent02_btn_left_off = <invent02_bar1.pcx>;

// ---------------------------------------------------------------------
// entry: left button on
// id: 3
bmap _invent02_btn_left_on  = <invent02_bar6.pcx>;

// ---------------------------------------------------------------------
// entry: left button over
// id: 4
bmap _invent02_btn_left_over= <invent02_bar4.pcx>;


// ---------------------------------------------------------------------
// entry: right button off
// id: 5
bmap _invent02_btn_right_off = <invent02_bar3.pcx>;

// ---------------------------------------------------------------------
// entry: right button on
// id: 6
bmap _invent02_btn_right_on  = <invent02_bar7.pcx>;

// ---------------------------------------------------------------------
// entry: right button over
// id: 7
bmap _invent02_btn_right_over= <invent02_bar5.pcx>;


// ---------------------------------------------------------------------
// entry: center background
// id: 8
bmap _invent02_backgrnd2_bmp = <invent02_bar2.pcx>;

// ---------------------------------------------------------------------
// entry: empty item image
// id: 9
bmap _invent02_item_bmp = <invent02_item.pcx>;


// ---------------------------------------------------------------------
// entry:message box background
// id: 10
bmap _invent02_msg_bmp = <invent02_msg.pcx>;

// ---------------------------------------------------------------------
// entry: Screen Pos
// cntl: spin -1 1 1
// entry_help: -1-off, 0-top, 1-bottom, 
// id: 11
define _invent02_back_pos_def = 1;


// ---------------------------------------------------------------------
// entry: Item Y Offset
// id: 12
define _invent02_item_y_offset = 8;


// ---------------------------------------------------------------------
// entry: Item Y Offset
// id: 13
define _invent02_bottom_offset = 0;

var	_invent02_back_pos = -1;

// section: Items
///////////////////////////////////////////////////////////////////////
// Entity skill & flag definitions
define _id__0c0, skill1;
define _item_type__0c0, skill2;
define _item_text1__0c0, skill21;
define _item_text2__0c0, skill22;
define _item_text3__0c0, skill23;
define _item_action__0c0,skill24;
define _item_sound__0c0,skill28;


define true, 1;
define false, 0;

//entry: Inventory Size
//id: 14
define _invent02_inventory_size,70;

//entry: Used Inventory size
//id: 15
define _invent02_inventory_used_size, 600;

var    _invent02_inventory[_invent02_inventory_size];
var    _invent02_inventory_items[_invent02_inventory_size];
var    _invent02_inventory_used[_invent02_inventory_used_size];

entity* _invent02_item_to_add;

//entry:Player Money
//id: 16
var	 _invent02_money = 0;

//entry: 1s units
//id  17
string _invent02_money_ones = "copper";

//entry: 100s units
//id  18
string _invent02_money_hundreds = "silver";

//entry: 1000s units
//id  19
string _invent02_money_thousands = "gold";

//entry: Pickup message prefix line 1
//id 21
string _invent02_pickup_prefix1 = "You found ";
//entry: Pickup message suffix line 1
//id 22
string _invent02_pickup_suffix1 = "!";
//entry: Pickup message suffix line 2
//id 23
string _invent02_pickup_prefix2 = "";
//entry: Pickup message suffix line 2
//id 24
string _invent02_pickup_suffix2 = "";
//entry: Pickup message suffix line 3
//id 25
string _invent02_pickup_prefix3 = "";
//entry: Pickup message suffix line 3
//id 26
string _invent02_pickup_suffix3 = ".";

//entry: Pickup message window time out
//id:27
define _invent02_msg_show_timer_time_max = 112;

// ---------------------------------------------------------------------
// section: Inventory Item #1

// entry: Item Bitmap
// id: 30
bmap invent02_item01_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 31
string invent02_item01_model,"";

//entry: Item Action
//id: 32
string invent02_item01_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 33
var invent02_item01_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 34
var invent02_item01_sell = 0;

//entry: Item pickup Sound
//id: 35
sound invent02_item01_sound = <pickup.wav>;

//entry: Item Message 1
//id: 36
string invent02_item01_message1 = "";

//entry: Item Message 2
//id: 37
string invent02_item01_message2 = "";

//entry: Item Message 3
//id: 38
string invent02_item01_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #2

// entry: Item Bitmap
// id: 40
bmap invent02_item02_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 41
string invent02_item02_model,"barrel.mdl";

//entry: Item Action
//id: 42
string invent02_item02_action,"_invent02_show_msg();";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 43
var invent02_item02_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 44
var invent02_item02_sell = 0;

//entry: Item pickup Sound
//id: 45
sound invent02_item02_sound = <pickup.wav>;

//entry: Item Message
//id: 46
string invent02_item02_message1 = "test balm";

//entry: Item Message
//id: 47
string invent02_item02_message2 = "";

//entry: Item Message
//id: 48
string invent02_item02_message3 = "it works";

// ---------------------------------------------------------------------
// section: Inventory Item #3

// entry: Item Bitmap
// id: 50
bmap invent02_item03_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 51
string invent02_item03_model,"";

//entry: Item Action
//id: 52
string invent02_item03_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 53
var invent02_item03_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 54
var invent02_item03_sell = 0;

//entry: Item pickup Sound
//id: 55
sound invent02_item03_sound = <pickup.wav>;

//entry: Item Message
//id: 56
string invent02_item03_message1 = "";

//entry: Item Message
//id: 57
string invent02_item03_message2 = "";

//entry: Item Message
//id: 58
string invent02_item03_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #4

// entry: Item Bitmap
// id: 60
bmap invent02_item04_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 61
string invent02_item04_model,"";

//entry: Item Action
//id: 62
string invent02_item04_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 63
var invent02_item04_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 64
var invent02_item04_sell = 0;

//entry: Item pickup Sound
//id: 65
sound invent02_item04_sound = <pickup.wav>;

//entry: Item Message
//id: 66
string invent02_item04_message1 = "";

//entry: Item Message
//id: 67
string invent02_item04_message2 = "";

//entry: Item Message
//id: 68
string invent02_item04_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #5

// entry: Item Bitmap
// id: 70
bmap invent02_item05_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 71
string invent02_item05_model,"";

//entry: Item Action
//id: 72
string invent02_item05_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 73
var invent02_item05_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 74
var invent02_item05_sell = 0;

//entry: Item pickup Sound
//id: 75
sound invent02_item05_sound = <pickup.wav>;

//entry: Item Message
//id: 76
string invent02_item05_message1 = "";

//entry: Item Message
//id: 77
string invent02_item05_message2 = "";

//entry: Item Message
//id: 78
string invent02_item05_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #6

// entry: Item Bitmap
// id: 80
bmap invent02_item06_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 81
string invent02_item06_model,"";

//entry: Item Action
//id: 82
string invent02_item06_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 83
var invent02_item06_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 84
var invent02_item06_sell = 0;

//entry: Item pickup Sound
//id: 85
sound invent02_item06_sound = <pickup.wav>;

//entry: Item Message
//id: 86
string invent02_item06_message1 = "";

//entry: Item Message
//id: 87
string invent02_item06_message2 = "";

//entry: Item Message
//id: 88
string invent02_item06_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #7

// entry: Item Bitmap
// id: 90
bmap invent02_item07_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 91
string invent02_item07_model,"";

//entry: Item Action
//id: 92
string invent02_item07_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 93
var invent02_item07_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 94
var invent02_item07_sell = 0;

//entry: Item pickup Sound
//id: 95
sound invent02_item07_sound = <pickup.wav>;

//entry: Item Message
//id: 96
string invent02_item07_message1 = "";

//entry: Item Message
//id: 97
string invent02_item07_message2 = "";

//entry: Item Message
//id: 98
string invent02_item07_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #8

// entry: Item Bitmap
// id: 100
bmap invent02_item08_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 101
string invent02_item08_model,"";

//entry: Item Action
//id: 102
string invent02_item08_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 103
var invent02_item08_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 104
var invent02_item08_sell = 0;

//entry: Item pickup Sound
//id: 105
sound invent02_item08_sound = <pickup.wav>;

//entry: Item Message
//id: 106
string invent02_item08_message1 = "";

//entry: Item Message
//id: 107
string invent02_item08_message2 = "";

//entry: Item Message
//id: 108
string invent02_item08_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #9

// entry: Item Bitmap
// id: 110
bmap invent02_item09_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 111
string invent02_item09_model,"";

//entry: Item Action
//id: 112
string invent02_item09_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 113
var invent02_item09_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 114
var invent02_item09_sell = 0;

//entry: Item pickup Sound
//id: 115
sound invent02_item09_sound = <pickup.wav>;

//entry: Item Message
//id: 116
string invent02_item09_message1 = "";

//entry: Item Message
//id: 117
string invent02_item09_message2 = "";

//entry: Item Message
//id: 118
string invent02_item09_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #10

// entry: Item Bitmap
// id: 120
bmap invent02_item10_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 121
string invent02_item10_model,"";

//entry: Item Action
//id: 122
string invent02_item10_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 123
var invent02_item10_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 124
var invent02_item10_sell = 0;

//entry: Item pickup Sound
//id: 125
sound invent02_item10_sound = <pickup.wav>;

//entry: Item Message
//id: 126
string invent02_item10_message1 = "";

//entry: Item Message
//id: 127
string invent02_item10_message2 = "";

//entry: Item Message
//id: 128
string invent02_item10_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #11

// entry: Item Bitmap
// id: 130
bmap invent02_item11_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 131
string invent02_item11_model,"";

//entry: Item Action
//id: 132
string invent02_item11_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 133
var invent02_item11_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 134
var invent02_item11_sell = 0;

//entry: Item pickup Sound
//id: 135
sound invent02_item11_sound = <pickup.wav>;

//entry: Item Message 1
//id: 136
string invent02_item11_message1 = "";

//entry: Item Message 2
//id: 137
string invent02_item11_message2 = "";

//entry: Item Message 3
//id: 138
string invent02_item11_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #12

// entry: Item Bitmap
// id: 140
bmap invent02_item12_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 141
string invent02_item12_model,"";

//entry: Item Action
//id: 142
string invent02_item12_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 143
var invent02_item12_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 144
var invent02_item12_sell = 0;

//entry: Item pickup Sound
//id: 145
sound invent02_item12_sound = <pickup.wav>;

//entry: Item Message
//id: 146
string invent02_item12_message1 = "";

//entry: Item Message
//id: 147
string invent02_item12_message2 = "";

//entry: Item Message
//id: 148
string invent02_item12_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #13

// entry: Item Bitmap
// id: 150
bmap invent02_item13_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 151
string invent02_item13_model,"";

//entry: Item Action
//id: 152
string invent02_item13_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 153
var invent02_item13_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 154
var invent02_item13_sell = 0;

//entry: Item pickup Sound
//id: 155
sound invent02_item13_sound = <pickup.wav>;

//entry: Item Message
//id: 156
string invent02_item13_message1 = "";

//entry: Item Message
//id: 157
string invent02_item13_message2 = "";

//entry: Item Message
//id: 158
string invent02_item13_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #14

// entry: Item Bitmap
// id: 160
bmap invent02_item14_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 161
string invent02_item14_model,"";

//entry: Item Action
//id: 162
string invent02_item14_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 163
var invent02_item14_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 164
var invent02_item14_sell = 0;

//entry: Item pickup Sound
//id: 165
sound invent02_item14_sound = <pickup.wav>;

//entry: Item Message
//id: 166
string invent02_item14_message1 = "";

//entry: Item Message
//id: 167
string invent02_item14_message2 = "";

//entry: Item Message
//id: 168
string invent02_item14_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #15

// entry: Item Bitmap
// id: 170
bmap invent02_item15_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 171
string invent02_item15_model,"";

//entry: Item Action
//id: 172
string invent02_item15_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 173
var invent02_item15_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 174
var invent02_item15_sell = 0;

//entry: Item pickup Sound
//id: 175
sound invent02_item15_sound = <pickup.wav>;

//entry: Item Message
//id: 176
string invent02_item15_message1 = "";

//entry: Item Message
//id: 177
string invent02_item15_message2 = "";

//entry: Item Message
//id: 178
string invent02_item15_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #16

// entry: Item Bitmap
// id: 180
bmap invent02_item16_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 181
string invent02_item16_model,"";

//entry: Item Action
//id: 182
string invent02_item16_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 183
var invent02_item16_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 184
var invent02_item16_sell = 0;

//entry: Item pickup Sound
//id: 185
sound invent02_item16_sound = <pickup.wav>;

//entry: Item Message
//id: 186
string invent02_item16_message1 = "";

//entry: Item Message
//id: 187
string invent02_item16_message2 = "";

//entry: Item Message
//id: 188
string invent02_item16_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #17

// entry: Item Bitmap
// id: 190
bmap invent02_item17_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 191
string invent02_item17_model,"";

//entry: Item Action
//id: 192
string invent02_item17_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 193
var invent02_item17_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 194
var invent02_item17_sell = 0;

//entry: Item pickup Sound
//id: 195
sound invent02_item17_sound = <pickup.wav>;

//entry: Item Message
//id: 196
string invent02_item17_message1 = "";

//entry: Item Message
//id: 197
string invent02_item17_message2 = "";

//entry: Item Message
//id: 198
string invent02_item17_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #18

// entry: Item Bitmap
// id: 200
bmap invent02_item18_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 201
string invent02_item18_model,"";

//entry: Item Action
//id: 202
string invent02_item18_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 203
var invent02_item18_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 204
var invent02_item18_sell = 0;

//entry: Item pickup Sound
//id: 205
sound invent02_item18_sound = <pickup.wav>;

//entry: Item Message
//id: 206
string invent02_item18_message1 = "";

//entry: Item Message
//id: 207
string invent02_item18_message2 = "";

//entry: Item Message
//id: 208
string invent02_item18_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #19

// entry: Item Bitmap
// id: 210
bmap invent02_item19_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 211
string invent02_item19_model,"";

//entry: Item Action
//id: 212
string invent02_item19_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 213
var invent02_item19_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 214
var invent02_item19_sell = 0;

//entry: Item pickup Sound
//id: 215
sound invent02_item19_sound = <pickup.wav>;

//entry: Item Message
//id: 216
string invent02_item19_message1 = "";

//entry: Item Message
//id: 217
string invent02_item19_message2 = "";

//entry: Item Message
//id: 218
string invent02_item19_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #20

// entry: Item Bitmap
// id: 220
bmap invent02_item20_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 221
string invent02_item20_model,"";

//entry: Item Action
//id: 222
string invent02_item20_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 223
var invent02_item20_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 224
var invent02_item20_sell = 0;

//entry: Item pickup Sound
//id: 225
sound invent02_item20_sound = <pickup.wav>;

//entry: Item Message
//id: 226
string invent02_item20_message1 = "";

//entry: Item Message
//id: 227
string invent02_item20_message2 = "";

//entry: Item Message
//id: 228
string invent02_item20_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #21

// entry: Item Bitmap
// id: 230
bmap invent02_item21_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 231
string invent02_item21_model,"";

//entry: Item Action
//id: 232
string invent02_item21_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 233
var invent02_item21_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 234
var invent02_item21_sell = 0;

//entry: Item pickup Sound
//id: 235
sound invent02_item21_sound = <pickup.wav>;

//entry: Item Message 1
//id: 236
string invent02_item21_message1 = "";

//entry: Item Message 2
//id: 237
string invent02_item21_message2 = "";

//entry: Item Message 3
//id: 238
string invent02_item21_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #22

// entry: Item Bitmap
// id: 240
bmap invent02_item22_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 241
string invent02_item22_model,"";

//entry: Item Action
//id: 242
string invent02_item22_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 243
var invent02_item22_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 244
var invent02_item22_sell = 0;

//entry: Item pickup Sound
//id: 245
sound invent02_item22_sound = <pickup.wav>;

//entry: Item Message
//id: 246
string invent02_item22_message1 = "";

//entry: Item Message
//id: 247
string invent02_item22_message2 = "";

//entry: Item Message
//id: 248
string invent02_item22_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #23

// entry: Item Bitmap
// id: 250
bmap invent02_item23_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 251
string invent02_item23_model,"";

//entry: Item Action
//id: 252
string invent02_item23_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 253
var invent02_item23_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 254
var invent02_item23_sell = 0;

//entry: Item pickup Sound
//id: 255
sound invent02_item23_sound = <pickup.wav>;

//entry: Item Message
//id: 256
string invent02_item23_message1 = "";

//entry: Item Message
//id: 257
string invent02_item23_message2 = "";

//entry: Item Message
//id: 258
string invent02_item23_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #24

// entry: Item Bitmap
// id: 260
bmap invent02_item24_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 261
string invent02_item24_model,"";

//entry: Item Action
//id: 262
string invent02_item24_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 263
var invent02_item24_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 264
var invent02_item24_sell = 0;

//entry: Item pickup Sound
//id: 265
sound invent02_item24_sound = <pickup.wav>;

//entry: Item Message
//id: 266
string invent02_item24_message1 = "";

//entry: Item Message
//id: 267
string invent02_item24_message2 = "";

//entry: Item Message
//id: 268
string invent02_item24_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #25

// entry: Item Bitmap
// id: 270
bmap invent02_item25_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 271
string invent02_item25_model,"";

//entry: Item Action
//id: 272
string invent02_item25_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 273
var invent02_item25_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 274
var invent02_item25_sell = 0;

//entry: Item pickup Sound
//id: 275
sound invent02_item25_sound = <pickup.wav>;

//entry: Item Message
//id: 276
string invent02_item25_message1 = "";

//entry: Item Message
//id: 277
string invent02_item25_message2 = "";

//entry: Item Message
//id: 278
string invent02_item25_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #26

// entry: Item Bitmap
// id: 280
bmap invent02_item26_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 281
string invent02_item26_model,"";

//entry: Item Action
//id: 282
string invent02_item26_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 283
var invent02_item26_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 284
var invent02_item26_sell = 0;

//entry: Item pickup Sound
//id: 285
sound invent02_item26_sound = <pickup.wav>;

//entry: Item Message
//id: 286
string invent02_item26_message1 = "";

//entry: Item Message
//id: 287
string invent02_item26_message2 = "";

//entry: Item Message
//id: 288
string invent02_item26_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #27

// entry: Item Bitmap
// id: 290
bmap invent02_item27_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 291
string invent02_item27_model,"";

//entry: Item Action
//id: 292
string invent02_item27_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 293
var invent02_item27_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 294
var invent02_item27_sell = 0;

//entry: Item pickup Sound
//id: 295
sound invent02_item27_sound = <pickup.wav>;

//entry: Item Message
//id: 296
string invent02_item27_message1 = "";

//entry: Item Message
//id: 297
string invent02_item27_message2 = "";

//entry: Item Message
//id: 298
string invent02_item27_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #28

// entry: Item Bitmap
// id: 300
bmap invent02_item28_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 301
string invent02_item28_model,"";

//entry: Item Action
//id: 302
string invent02_item28_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 303
var invent02_item28_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 304
var invent02_item28_sell = 0;

//entry: Item pickup Sound
//id: 305
sound invent02_item28_sound = <pickup.wav>;

//entry: Item Message
//id: 306
string invent02_item28_message1 = "";

//entry: Item Message
//id: 307
string invent02_item28_message2 = "";

//entry: Item Message
//id: 308
string invent02_item28_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #29

// entry: Item Bitmap
// id: 310
bmap invent02_item29_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 311
string invent02_item29_model,"";

//entry: Item Action
//id: 312
string invent02_item29_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 313
var invent02_item29_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 314
var invent02_item29_sell = 0;

//entry: Item pickup Sound
//id: 315
sound invent02_item29_sound = <pickup.wav>;

//entry: Item Message
//id: 316
string invent02_item29_message1 = "";

//entry: Item Message
//id: 317
string invent02_item29_message2 = "";

//entry: Item Message
//id: 318
string invent02_item29_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #30

// entry: Item Bitmap
// id: 320
bmap invent02_item30_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 321
string invent02_item30_model,"";

//entry: Item Action
//id: 322
string invent02_item30_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 323
var invent02_item30_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 324
var invent02_item30_sell = 0;

//entry: Item pickup Sound
//id: 325
sound invent02_item30_sound = <pickup.wav>;

//entry: Item Message
//id: 326
string invent02_item30_message1 = "";

//entry: Item Message
//id: 327
string invent02_item30_message2 = "";

//entry: Item Message
//id: 328
string invent02_item30_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #31

// entry: Item Bitmap
// id: 330
bmap invent02_item31_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 331
string invent02_item31_model,"";

//entry: Item Action
//id: 332
string invent02_item31_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 333
var invent02_item31_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 334
var invent02_item31_sell = 0;

//entry: Item pickup Sound
//id: 335
sound invent02_item31_sound = <pickup.wav>;

//entry: Item Message 1
//id: 336
string invent02_item31_message1 = "";

//entry: Item Message 2
//id: 337
string invent02_item31_message2 = "";

//entry: Item Message 3
//id: 338
string invent02_item31_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #32

// entry: Item Bitmap
// id: 340
bmap invent02_item32_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 341
string invent02_item32_model,"";

//entry: Item Action
//id: 342
string invent02_item32_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 343
var invent02_item32_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 344
var invent02_item32_sell = 0;

//entry: Item pickup Sound
//id: 345
sound invent02_item32_sound = <pickup.wav>;

//entry: Item Message
//id: 346
string invent02_item32_message1 = "";

//entry: Item Message
//id: 347
string invent02_item32_message2 = "";

//entry: Item Message
//id: 348
string invent02_item32_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #33

// entry: Item Bitmap
// id: 350
bmap invent02_item33_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 351
string invent02_item33_model,"";

//entry: Item Action
//id: 352
string invent02_item33_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 353
var invent02_item33_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 354
var invent02_item33_sell = 0;

//entry: Item pickup Sound
//id: 355
sound invent02_item33_sound = <pickup.wav>;

//entry: Item Message
//id: 356
string invent02_item33_message1 = "";

//entry: Item Message
//id: 357
string invent02_item33_message2 = "";

//entry: Item Message
//id: 358
string invent02_item33_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #34

// entry: Item Bitmap
// id: 360
bmap invent02_item34_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 361
string invent02_item34_model,"";

//entry: Item Action
//id: 362
string invent02_item34_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 363
var invent02_item34_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 364
var invent02_item34_sell = 0;

//entry: Item pickup Sound
//id: 365
sound invent02_item34_sound = <pickup.wav>;

//entry: Item Message
//id: 366
string invent02_item34_message1 = "";

//entry: Item Message
//id: 367
string invent02_item34_message2 = "";

//entry: Item Message
//id: 368
string invent02_item34_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #35

// entry: Item Bitmap
// id: 370
bmap invent02_item35_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 371
string invent02_item35_model,"";

//entry: Item Action
//id: 372
string invent02_item35_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 373
var invent02_item35_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 374
var invent02_item35_sell = 0;

//entry: Item pickup Sound
//id: 375
sound invent02_item35_sound = <pickup.wav>;

//entry: Item Message
//id: 376
string invent02_item35_message1 = "";

//entry: Item Message
//id: 377
string invent02_item35_message2 = "";

//entry: Item Message
//id: 378
string invent02_item35_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #36

// entry: Item Bitmap
// id: 380
bmap invent02_item36_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 381
string invent02_item36_model,"";

//entry: Item Action
//id: 382
string invent02_item36_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 383
var invent02_item36_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 384
var invent02_item36_sell = 0;

//entry: Item pickup Sound
//id: 385
sound invent02_item36_sound = <pickup.wav>;

//entry: Item Message
//id: 386
string invent02_item36_message1 = "";

//entry: Item Message
//id: 387
string invent02_item36_message2 = "";

//entry: Item Message
//id: 388
string invent02_item36_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #37

// entry: Item Bitmap
// id: 390
bmap invent02_item37_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 391
string invent02_item37_model,"";

//entry: Item Action
//id: 392
string invent02_item37_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 393
var invent02_item37_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 394
var invent02_item37_sell = 0;

//entry: Item pickup Sound
//id: 395
sound invent02_item37_sound = <pickup.wav>;

//entry: Item Message
//id: 396
string invent02_item37_message1 = "";

//entry: Item Message
//id: 397
string invent02_item37_message2 = "";

//entry: Item Message
//id: 398
string invent02_item37_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #38

// entry: Item Bitmap
// id: 400
bmap invent02_item38_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 401
string invent02_item38_model,"";

//entry: Item Action
//id: 402
string invent02_item38_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 403
var invent02_item38_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 404
var invent02_item38_sell = 0;

//entry: Item pickup Sound
//id: 405
sound invent02_item38_sound = <pickup.wav>;

//entry: Item Message
//id: 406
string invent02_item38_message1 = "";

//entry: Item Message
//id: 407
string invent02_item38_message2 = "";

//entry: Item Message
//id: 408
string invent02_item38_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #39

// entry: Item Bitmap
// id: 410
bmap invent02_item39_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 411
string invent02_item39_model,"";

//entry: Item Action
//id: 412
string invent02_item39_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 413
var invent02_item39_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 414
var invent02_item39_sell = 0;

//entry: Item pickup Sound
//id: 415
sound invent02_item39_sound = <pickup.wav>;

//entry: Item Message
//id: 416
string invent02_item39_message1 = "";

//entry: Item Message
//id: 417
string invent02_item39_message2 = "";

//entry: Item Message
//id: 418
string invent02_item39_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #40

// entry: Item Bitmap
// id: 420
bmap invent02_item40_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 421
string invent02_item40_model,"";

//entry: Item Action
//id: 422
string invent02_item40_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 423
var invent02_item40_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 424
var invent02_item40_sell = 0;

//entry: Item pickup Sound
//id: 425
sound invent02_item40_sound = <pickup.wav>;

//entry: Item Message
//id: 426
string invent02_item40_message1 = "";

//entry: Item Message
//id: 427
string invent02_item40_message2 = "";

//entry: Item Message
//id: 428
string invent02_item40_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #41

// entry: Item Bitmap
// id: 430
bmap invent02_item41_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 431
string invent02_item41_model,"";

//entry: Item Action
//id: 432
string invent02_item41_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 433
var invent02_item41_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 434
var invent02_item41_sell = 0;

//entry: Item pickup Sound
//id: 435
sound invent02_item41_sound = <pickup.wav>;

//entry: Item Message 1
//id: 436
string invent02_item41_message1 = "";

//entry: Item Message 2
//id: 437
string invent02_item41_message2 = "";

//entry: Item Message 3
//id: 438
string invent02_item41_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #42

// entry: Item Bitmap
// id: 440
bmap invent02_item42_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 441
string invent02_item42_model,"";

//entry: Item Action
//id: 442
string invent02_item42_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 443
var invent02_item42_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 444
var invent02_item42_sell = 0;

//entry: Item pickup Sound
//id: 445
sound invent02_item42_sound = <pickup.wav>;

//entry: Item Message
//id: 446
string invent02_item42_message1 = "";

//entry: Item Message
//id: 447
string invent02_item42_message2 = "";

//entry: Item Message
//id: 448
string invent02_item42_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #43

// entry: Item Bitmap
// id: 450
bmap invent02_item43_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 451
string invent02_item43_model,"";

//entry: Item Action
//id: 452
string invent02_item43_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 453
var invent02_item43_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 454
var invent02_item43_sell = 0;

//entry: Item pickup Sound
//id: 455
sound invent02_item43_sound = <pickup.wav>;

//entry: Item Message
//id: 456
string invent02_item43_message1 = "";

//entry: Item Message
//id: 457
string invent02_item43_message2 = "";

//entry: Item Message
//id: 458
string invent02_item43_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #44

// entry: Item Bitmap
// id: 460
bmap invent02_item44_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 461
string invent02_item44_model,"";

//entry: Item Action
//id: 462
string invent02_item44_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 463
var invent02_item44_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 464
var invent02_item44_sell = 0;

//entry: Item pickup Sound
//id: 465
sound invent02_item44_sound = <pickup.wav>;

//entry: Item Message
//id: 466
string invent02_item44_message1 = "";

//entry: Item Message
//id: 467
string invent02_item44_message2 = "";

//entry: Item Message
//id: 468
string invent02_item44_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #45

// entry: Item Bitmap
// id: 470
bmap invent02_item45_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 471
string invent02_item45_model,"";

//entry: Item Action
//id: 472
string invent02_item45_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 473
var invent02_item45_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 474
var invent02_item45_sell = 0;

//entry: Item pickup Sound
//id: 475
sound invent02_item45_sound = <pickup.wav>;

//entry: Item Message
//id: 476
string invent02_item45_message1 = "";

//entry: Item Message
//id: 477
string invent02_item45_message2 = "";

//entry: Item Message
//id: 478
string invent02_item45_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #46

// entry: Item Bitmap
// id: 480
bmap invent02_item46_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 481
string invent02_item46_model,"";

//entry: Item Action
//id: 482
string invent02_item46_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 483
var invent02_item46_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 484
var invent02_item46_sell = 0;

//entry: Item pickup Sound
//id: 485
sound invent02_item46_sound = <pickup.wav>;

//entry: Item Message
//id: 486
string invent02_item46_message1 = "";

//entry: Item Message
//id: 487
string invent02_item46_message2 = "";

//entry: Item Message
//id: 488
string invent02_item46_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #47

// entry: Item Bitmap
// id: 490
bmap invent02_item47_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 491
string invent02_item47_model,"";

//entry: Item Action
//id: 492
string invent02_item47_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 493
var invent02_item47_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 494
var invent02_item47_sell = 0;

//entry: Item pickup Sound
//id: 495
sound invent02_item47_sound = <pickup.wav>;

//entry: Item Message
//id: 496
string invent02_item47_message1 = "";

//entry: Item Message
//id: 497
string invent02_item47_message2 = "";

//entry: Item Message
//id: 498
string invent02_item47_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #48

// entry: Item Bitmap
// id: 500
bmap invent02_item48_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 501
string invent02_item48_model,"";

//entry: Item Action
//id: 502
string invent02_item48_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 503
var invent02_item48_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 504
var invent02_item48_sell = 0;

//entry: Item pickup Sound
//id: 505
sound invent02_item48_sound = <pickup.wav>;

//entry: Item Message
//id: 506
string invent02_item48_message1 = "";

//entry: Item Message
//id: 507
string invent02_item48_message2 = "";

//entry: Item Message
//id: 508
string invent02_item48_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #49

// entry: Item Bitmap
// id: 510
bmap invent02_item49_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 511
string invent02_item49_model,"";

//entry: Item Action
//id: 512
string invent02_item49_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 513
var invent02_item49_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 514
var invent02_item59_sell = 0;

//entry: Item pickup Sound
//id: 515
sound invent02_item49_sound = <pickup.wav>;

//entry: Item Message
//id: 516
string invent02_item49_message1 = "";

//entry: Item Message
//id: 517
string invent02_item49_message2 = "";

//entry: Item Message
//id: 518
string invent02_item49_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #50

// entry: Item Bitmap
// id: 520
bmap invent02_item50_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 521
string invent02_item50_model,"";

//entry: Item Action
//id: 522
string invent02_item50_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 523
var invent02_item50_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 524
var invent02_item50_sell = 0;

//entry: Item pickup Sound
//id: 525
sound invent02_item50_sound = <pickup.wav>;

//entry: Item Message
//id: 526
string invent02_item50_message1 = "";

//entry: Item Message
//id: 527
string invent02_item50_message2 = "";

//entry: Item Message
//id: 528
string invent02_item50_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #51

// entry: Item Bitmap
// id: 530
bmap invent02_item51_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 531
string invent02_item51_model,"";

//entry: Item Action
//id: 532
string invent02_item51_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 533
var invent02_item51_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 534
var invent02_item51_sell = 0;

//entry: Item pickup Sound
//id: 535
sound invent02_item51_sound = <pickup.wav>;

//entry: Item Message 1
//id: 536
string invent02_item51_message1 = "";

//entry: Item Message 2
//id: 537
string invent02_item51_message2 = "";

//entry: Item Message 3
//id: 538
string invent02_item51_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #52

// entry: Item Bitmap
// id: 540
bmap invent02_item52_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 541
string invent02_item52_model,"";

//entry: Item Action
//id: 542
string invent02_item52_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 543
var invent02_item52_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 544
var invent02_item52_sell = 0;

//entry: Item pickup Sound
//id: 545
sound invent02_item52_sound = <pickup.wav>;

//entry: Item Message
//id: 546
string invent02_item52_message1 = "";

//entry: Item Message
//id: 547
string invent02_item52_message2 = "";

//entry: Item Message
//id: 548
string invent02_item52_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #53

// entry: Item Bitmap
// id: 550
bmap invent02_item53_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 551
string invent02_item53_model,"";

//entry: Item Action
//id: 552
string invent02_item53_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 553
var invent02_item53_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 554
var invent02_item53_sell = 0;

//entry: Item pickup Sound
//id: 555
sound invent02_item53_sound = <pickup.wav>;

//entry: Item Message
//id: 556
string invent02_item53_message1 = "";

//entry: Item Message
//id: 557
string invent02_item53_message2 = "";

//entry: Item Message
//id: 558
string invent02_item53_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #54

// entry: Item Bitmap
// id: 560
bmap invent02_item54_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 561
string invent02_item54_model,"";

//entry: Item Action
//id: 562
string invent02_item54_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 563
var invent02_item54_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 564
var invent02_item54_sell = 0;

//entry: Item pickup Sound
//id: 565
sound invent02_item54_sound = <pickup.wav>;

//entry: Item Message
//id: 566
string invent02_item54_message1 = "";

//entry: Item Message
//id: 567
string invent02_item54_message2 = "";

//entry: Item Message
//id: 568
string invent02_item54_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #55

// entry: Item Bitmap
// id: 570
bmap invent02_item55_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 571
string invent02_item55_model,"";

//entry: Item Action
//id: 572
string invent02_item55_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 573
var invent02_item55_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 574
var invent02_item55_sell = 0;

//entry: Item pickup Sound
//id: 575
sound invent02_item55_sound = <pickup.wav>;

//entry: Item Message
//id: 576
string invent02_item55_message1 = "";

//entry: Item Message
//id: 577
string invent02_item55_message2 = "";

//entry: Item Message
//id: 578
string invent02_item55_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #56

// entry: Item Bitmap
// id: 580
bmap invent02_item56_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 581
string invent02_item56_model,"";

//entry: Item Action
//id: 582
string invent02_item56_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 583
var invent02_item56_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 584
var invent02_item56_sell = 0;

//entry: Item pickup Sound
//id: 585
sound invent02_item56_sound = <pickup.wav>;

//entry: Item Message
//id: 586
string invent02_item56_message1 = "";

//entry: Item Message
//id: 587
string invent02_item56_message2 = "";

//entry: Item Message
//id: 588
string invent02_item56_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #57

// entry: Item Bitmap
// id: 590
bmap invent02_item57_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 591
string invent02_item57_model,"";

//entry: Item Action
//id: 592
string invent02_item57_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 593
var invent02_item57_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 594
var invent02_item57_sell = 0;

//entry: Item pickup Sound
//id: 595
sound invent02_item57_sound = <pickup.wav>;

//entry: Item Message
//id: 596
string invent02_item57_message1 = "";

//entry: Item Message
//id: 597
string invent02_item57_message2 = "";

//entry: Item Message
//id: 598
string invent02_item57_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #58

// entry: Item Bitmap
// id: 600
bmap invent02_item58_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 601
string invent02_item58_model,"";

//entry: Item Action
//id: 602
string invent02_item58_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 603
var invent02_item58_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 604
var invent02_item58_sell = 0;

//entry: Item pickup Sound
//id: 605
sound invent02_item58_sound = <pickup.wav>;

//entry: Item Message
//id: 606
string invent02_item58_message1 = "";

//entry: Item Message
//id: 607
string invent02_item58_message2 = "";

//entry: Item Message
//id: 608
string invent02_item58_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #59

// entry: Item Bitmap
// id: 610
bmap invent02_item59_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 611
string invent02_item59_model,"";

//entry: Item Action
//id: 612
string invent02_item59_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 613
var invent02_item59_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 614
var invent02_item59_sell = 0;

//entry: Item pickup Sound
//id: 615
sound invent02_item59_sound = <pickup.wav>;

//entry: Item Message
//id: 616
string invent02_item59_message1 = "";

//entry: Item Message
//id: 617
string invent02_item59_message2 = "";

//entry: Item Message
//id: 618
string invent02_item59_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #60

// entry: Item Bitmap
// id: 620
bmap invent02_item60_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 621
string invent02_item60_model,"";

//entry: Item Action
//id: 622
string invent02_item60_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 623
var invent02_item60_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 624
var invent02_item60_sell = 0;

//entry: Item pickup Sound
//id: 625
sound invent02_item60_sound = <pickup.wav>;

//entry: Item Message
//id: 626
string invent02_item60_message1 = "";

//entry: Item Message
//id: 627
string invent02_item60_message2 = "";

//entry: Item Message
//id: 628
string invent02_item60_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #61

// entry: Item Bitmap
// id: 630
bmap invent02_item61_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 631
string invent02_item61_model,"";

//entry: Item Action
//id: 632
string invent02_item61_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 633
var invent02_item61_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 634
var invent02_item61_sell = 0;

//entry: Item pickup Sound
//id: 635
sound invent02_item61_sound = <pickup.wav>;

//entry: Item Message 1
//id: 636
string invent02_item61_message1 = "";

//entry: Item Message 2
//id: 637
string invent02_item61_message2 = "";

//entry: Item Message 3
//id: 638
string invent02_item61_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #62

// entry: Item Bitmap
// id: 640
bmap invent02_item62_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 641
string invent02_item62_model,"";

//entry: Item Action
//id: 642
string invent02_item62_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 643
var invent02_item62_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 644
var invent02_item62_sell = 0;

//entry: Item pickup Sound
//id: 645
sound invent02_item62_sound = <pickup.wav>;

//entry: Item Message
//id: 646
string invent02_item62_message1 = "";

//entry: Item Message
//id: 647
string invent02_item62_message2 = "";

//entry: Item Message
//id: 648
string invent02_item62_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #63

// entry: Item Bitmap
// id: 650
bmap invent02_item63_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 651
string invent02_item63_model,"";

//entry: Item Action
//id: 652
string invent02_item63_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 653
var invent02_item63_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 654
var invent02_item63_sell = 0;

//entry: Item pickup Sound
//id: 655
sound invent02_item63_sound = <pickup.wav>;

//entry: Item Message
//id: 656
string invent02_item63_message1 = "";

//entry: Item Message
//id: 657
string invent02_item63_message2 = "";

//entry: Item Message
//id: 658
string invent02_item63_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #64

// entry: Item Bitmap
// id: 660
bmap invent02_item64_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 661
string invent02_item64_model,"";

//entry: Item Action
//id: 662
string invent02_item64_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 663
var invent02_item64_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 664
var invent02_item64_sell = 0;

//entry: Item pickup Sound
//id: 665
sound invent02_item64_sound = <pickup.wav>;

//entry: Item Message
//id: 666
string invent02_item64_message1 = "";

//entry: Item Message
//id: 667
string invent02_item64_message2 = "";

//entry: Item Message
//id: 668
string invent02_item64_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #65

// entry: Item Bitmap
// id: 670
bmap invent02_item65_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 671
string invent02_item65_model,"";

//entry: Item Action
//id: 672
string invent02_item65_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 673
var invent02_item65_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 674
var invent02_item65_sell = 0;

//entry: Item pickup Sound
//id: 675
sound invent02_item65_sound = <pickup.wav>;

//entry: Item Message
//id: 676
string invent02_item65_message1 = "";

//entry: Item Message
//id: 677
string invent02_item65_message2 = "";

//entry: Item Message
//id: 678
string invent02_item65_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #66

// entry: Item Bitmap
// id: 680
bmap invent02_item66_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 681
string invent02_item66_model,"";

//entry: Item Action
//id: 682
string invent02_item66_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 683
var invent02_item66_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 684
var invent02_item66_sell = 0;

//entry: Item pickup Sound
//id: 685
sound invent02_item66_sound = <pickup.wav>;

//entry: Item Message
//id: 686
string invent02_item66_message1 = "";

//entry: Item Message
//id: 687
string invent02_item66_message2 = "";

//entry: Item Message
//id: 688
string invent02_item66_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #67

// entry: Item Bitmap
// id: 690
bmap invent02_item67_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 691
string invent02_item67_model,"";

//entry: Item Action
//id: 692
string invent02_item67_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 693
var invent02_item67_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 694
var invent02_item67_sell = 0;

//entry: Item pickup Sound
//id: 695
sound invent02_item67_sound = <pickup.wav>;

//entry: Item Message
//id: 696
string invent02_item67_message1 = "";

//entry: Item Message
//id: 697
string invent02_item67_message2 = "";

//entry: Item Message
//id:698
string invent02_item67_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #68

// entry: Item Bitmap
// id: 700
bmap invent02_item68_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 701
string invent02_item68_model,"";

//entry: Item Action
//id: 702
string invent02_item68_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 703
var invent02_item68_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 704
var invent02_item68_sell = 0;

//entry: Item pickup Sound
//id: 705
sound invent02_item68_sound = <pickup.wav>;

//entry: Item Message
//id: 706
string invent02_item68_message1 = "";

//entry: Item Message
//id: 707
string invent02_item68_message2 = "";

//entry: Item Message
//id: 708
string invent02_item68_message3 = "";

// ---------------------------------------------------------------------
// section: Inventory Item #69

// entry: Item Bitmap
// id: 710
bmap invent02_item69_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 711
string invent02_item69_model,"";

//entry: Item Action
//id: 712
string invent02_item69_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id:713
var invent02_item69_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 714
var invent02_item69_sell = 0;

//entry: Item pickup Sound
//id: 715
sound invent02_item69_sound = <pickup.wav>;

//entry: Item Message
//id: 716
string invent02_item69_message1 = "";

//entry: Item Message
//id: 717
string invent02_item69_message2 = "";

//entry: Item Message
//id: 718
string invent02_item69_message3 = "";


// ---------------------------------------------------------------------
// section: Inventory Item #70

// entry: Item Bitmap
// id: 720
bmap invent02_item70_bmp = <invent02_balm.pcx>;

//entry: Item Model
// id: 721
string invent02_item70_model,"";

//entry: Item Action
//id: 722
string invent02_item70_action,"";

//entry: Item Buy Price
//cntl: spin 0 x 1
//id: 723
var invent02_item70_buy = 0;

//entry: Item Sel Price
//cntl: spin 0 x 1
//id: 724
var invent02_item70_sell = 0;

//entry: Item pickup Sound
//id: 725
sound invent02_item70_sound = <pickup.wav>;

//entry: Item Message
//id: 726
string invent02_item70_message1 = "";

//entry: Item Message
//id: 727
string invent02_item70_message2 = "";

//entry: Item Message
//id: 728
string invent02_item70_message3 = "";



var _invent02_to_vec[3];   // can't use local vecs when calling functions
var _invent02_from_vec[3];

function	invent02_drop_Scan()
{
	var height;
	ifdef _use_a5_;
	var trace_hit;
	endif;
	
	// Use trace to scan the surface under the entity
	vec_set(_invent02_from_vec,my.min_x);
	vec_set(_invent02_to_vec,my.min_x);
	_invent02_to_vec.z -= 4000;
	height = c_trace(_invent02_from_vec,_invent02_to_vec,
		IGNORE_ME + IGNORE_PASSENTS + USE_BOX + ACTIVATE_SONAR);
	ifdef _use_a5_;
	if(height == 0) { trace_hit = 0; } else { trace_hit = 1; }
	endif;
	height -= 16;
	// Use the new "trace_hit" flag to see if we hit anything
	// NOTE: Use with new collision code!
	if(0 == trace_hit) // 0-if nothing hit
	{
		return;
	}
	c_move(me,nullvector,_invent02_to_vec,trace_mode);

}

	function invent02_play_snd(item)
	{
	
		if (item == 1)
		{
			snd_play(invent02_item01_sound,100,0);
		}			
		if (item == 2)
		{
			snd_play(invent02_item02_sound,100,0);
		}			
		if (item == 3)
		{
			snd_play(invent02_item03_sound,100,0);
		}			
		if (item == 4)
		{
			snd_play(invent02_item04_sound,100,0);
		}			
		if (item == 5)
		{
			snd_play(invent02_item05_sound,100,0);
		}			
		if (item == 6)
		{
			snd_play(invent02_item06_sound,100,0);
		}			
		if (item == 7)
		{
			snd_play(invent02_item07_sound,100,0);
		}			
		if (item == 8)
		{
			snd_play(invent02_item08_sound,100,0);
		}			
		if (item == 9)
		{
			snd_play(invent02_item09_sound,100,0);
		}			
		if (item == 10)
		{
			snd_play(invent02_item10_sound,100,0);
		}			
		if (item == 11)
		{
			snd_play(invent02_item11_sound,100,0);
		}			
		if (item == 12)
		{
			snd_play(invent02_item12_sound,100,0);
		}			
		if (item == 13)
		{
			snd_play(invent02_item13_sound,100,0);
		}			
		if (item == 14)
		{
			snd_play(invent02_item14_sound,100,0);
		}			
		if (item == 15)
		{
			snd_play(invent02_item15_sound,100,0);
		}			
		if (item == 16)
		{
			snd_play(invent02_item16_sound,100,0);
		}			
		if (item == 17)
		{
			snd_play(invent02_item17_sound,100,0);
		}			
		if (item == 18)
		{
			snd_play(invent02_item18_sound,100,0);
		}			
		if (item == 19)
		{
			snd_play(invent02_item19_sound,100,0);
		}			
		if (item == 20)
		{
			snd_play(invent02_item20_sound,100,0);
		}			
		if (item == 21)
		{
			snd_play(invent02_item21_sound,100,0);
		}			
		if (item == 22)
		{
			snd_play(invent02_item22_sound,100,0);
		}			
		if (item == 23)
		{
			snd_play(invent02_item23_sound,100,0);
		}			
		if (item == 24)
		{
			snd_play(invent02_item24_sound,100,0);
		}			
		if (item == 25)
		{
			snd_play(invent02_item25_sound,100,0);
		}			
		if (item == 26)
		{
			snd_play(invent02_item26_sound,100,0);
		}			
		if (item == 27)
		{
			snd_play(invent02_item27_sound,100,0);
		}			
		if (item == 28)
		{
			snd_play(invent02_item28_sound,100,0);
		}			
		if (item == 29)
		{
			snd_play(invent02_item29_sound,100,0);
		}			
		if (item == 30)
		{
			snd_play(invent02_item30_sound,100,0);
		}			
		if (item == 31)
		{
			snd_play(invent02_item31_sound,100,0);
		}			
		if (item == 32)
		{
			snd_play(invent02_item32_sound,100,0);
		}			
		if (item == 33)
		{
			snd_play(invent02_item33_sound,100,0);
		}			
		if (item == 34)
		{
			snd_play(invent02_item34_sound,100,0);
		}			
		if (item == 35)
		{
			snd_play(invent02_item35_sound,100,0);
		}			
		if (item == 36)
		{
			snd_play(invent02_item36_sound,100,0);
		}			
		if (item == 37)
		{
			snd_play(invent02_item37_sound,100,0);
		}			
		if (item == 38)
		{
			snd_play(invent02_item38_sound,100,0);
		}			
		if (item == 39)
		{
			snd_play(invent02_item39_sound,100,0);
		}			
		if (item == 40)
		{
			snd_play(invent02_item40_sound,100,0);
		}			
		if (item == 41)
		{
			snd_play(invent02_item41_sound,100,0);
		}			
		if (item == 42)
		{
			snd_play(invent02_item42_sound,100,0);
		}			
		if (item == 43)
		{
			snd_play(invent02_item43_sound,100,0);
		}			
		if (item == 44)
		{
			snd_play(invent02_item44_sound,100,0);
		}			
		if (item == 45)
		{
			snd_play(invent02_item45_sound,100,0);
		}			
		if (item == 46)
		{
			snd_play(invent02_item46_sound,100,0);
		}			
		if (item == 47)
		{
			snd_play(invent02_item47_sound,100,0);
		}			
		if (item == 48)
		{
			snd_play(invent02_item48_sound,100,0);
		}			
		if (item == 49)
		{
			snd_play(invent02_item49_sound,100,0);
		}			
		if (item == 50)
		{
			snd_play(invent02_item50_sound,100,0);
		}			
		if (item == 52)
		{
			snd_play(invent02_item52_sound,100,0);
		}			
		if (item == 52)
		{
			snd_play(invent02_item52_sound,100,0);
		}			
		if (item == 53)
		{
			snd_play(invent02_item53_sound,100,0);
		}			
		if (item == 54)
		{
			snd_play(invent02_item54_sound,100,0);
		}			
		if (item == 55)
		{
			snd_play(invent02_item55_sound,100,0);
		}			
		if (item == 56)
		{
			snd_play(invent02_item56_sound,100,0);
		}			
		if (item == 57)
		{
			snd_play(invent02_item57_sound,100,0);
		}			
		if (item == 58)
		{
			snd_play(invent02_item58_sound,100,0);
		}			
		if (item == 59)
		{
			snd_play(invent02_item59_sound,100,0);
		}			
		if (item == 60)
		{
			snd_play(invent02_item60_sound,100,0);
		}			
		if (item == 61)
		{
			snd_play(invent02_item61_sound,100,0);
		}			
		if (item == 62)
		{
			snd_play(invent02_item62_sound,100,0);
		}			
		if (item == 63)
		{
			snd_play(invent02_item63_sound,100,0);
		}			
		if (item == 64)
		{
			snd_play(invent02_item64_sound,100,0);
		}			
		if (item == 65)
		{
			snd_play(invent02_item65_sound,100,0);
		}			
		if (item == 66)
		{
			snd_play(invent02_item66_sound,100,0);
		}			
		if (item == 67)
		{
			snd_play(invent02_item67_sound,100,0);
		}			
		if (item == 68)
		{
			snd_play(invent02_item68_sound,100,0);
		}			
		if (item == 69)
		{
			snd_play(invent02_item69_sound,100,0);
		}			
		if (item == 70)
		{
			snd_play(invent02_item70_sound,100,0);
		}			
	
	};
	
	
//============================================================
// action: invent02_morph
// title: Inventory Item
// Desc: An inventory item will have an ID and an item type.
// .
// uses _id__0c0
// uses _item_type__0c0;
//
//------------------
// section: Inventory Item
//	skill1: ID 100
//	skill2: Type 2
//-------------------------------------
	action invent02_morph
	{
		//make object invisible just incase user forgot to
		my.passable = on;
		my.invisible = on;
		my.shadow = off;
		my.enable_scan = off;
		my.enable_impact = off;
		my.enable_sonar = off;
	
		if (_invent02_IsItemInInventory(my._id__0c0))
		{
			return;
		}
		if (_invent02_HasItemBeenUsed(my._id__0c0))
		{
			return;
		}
		if (my._item_type__0c0 == 1)
		{
			ent_morph(me,invent02_item01_model);
			my._item_text1__0c0 = handle(invent02_item01_message1);
			my._item_text2__0c0 = handle(invent02_item01_message2);
			my._item_text3__0c0 = handle(invent02_item01_message3);
			my._item_action__0c0 = handle(invent02_item01_action);
			my._item_sound__0c0 = handle(invent02_item01_sound);
		}
		if (my._item_type__0c0 == 2)
		{
			ent_morph(me,invent02_item02_model);
			my._item_text1__0c0 = handle(invent02_item02_message1);
			my._item_text2__0c0 = handle(invent02_item02_message2);
			my._item_text3__0c0 = handle(invent02_item02_message3);
			my._item_action__0c0 = handle(invent02_item02_action);
			my._item_sound__0c0 = handle(invent02_item02_sound);
		}
		if (my._item_type__0c0 == 3)
		{
			ent_morph(me,invent02_item03_model);
			my._item_text1__0c0 = handle(invent02_item03_message1);
			my._item_text2__0c0 = handle(invent02_item03_message2);
			my._item_text3__0c0 = handle(invent02_item03_message3);
			my._item_action__0c0 = handle(invent02_item03_action);
			my._item_sound__0c0 = handle(invent02_item03_sound);
		}
		if (my._item_type__0c0 == 4)
		{
			ent_morph(me,invent02_item04_model);
			my._item_text1__0c0 = handle(invent02_item04_message1);
			my._item_text2__0c0 = handle(invent02_item04_message2);
			my._item_text3__0c0 = handle(invent02_item04_message3);
			my._item_action__0c0 = handle(invent02_item04_action);
			my._item_sound__0c0 = handle(invent02_item04_sound);
		}
		if (my._item_type__0c0 == 5)
		{
			ent_morph(me,invent02_item05_model);
			my._item_text1__0c0 = handle(invent02_item05_message1);
			my._item_text2__0c0 = handle(invent02_item05_message2);
			my._item_text3__0c0 = handle(invent02_item05_message3);
			my._item_action__0c0 = handle(invent02_item05_action);
			my._item_sound__0c0 = handle(invent02_item05_sound);
		}
		if (my._item_type__0c0 == 6)
		{
			ent_morph(me,invent02_item06_model);
			my._item_text1__0c0 = handle(invent02_item06_message1);
			my._item_text2__0c0 = handle(invent02_item06_message2);
			my._item_text3__0c0 = handle(invent02_item06_message3);
			my._item_action__0c0 = handle(invent02_item06_action);
			my._item_sound__0c0 = handle(invent02_item06_sound);
		}
		if (my._item_type__0c0 == 7)
		{
			ent_morph(me,invent02_item07_model);
			my._item_text1__0c0 = handle(invent02_item07_message1);
			my._item_text2__0c0 = handle(invent02_item07_message2);
			my._item_text3__0c0 = handle(invent02_item07_message3);
			my._item_action__0c0 = handle(invent02_item07_action);
			my._item_sound__0c0 = handle(invent02_item07_sound);
		}
		if (my._item_type__0c0 == 8)
		{
			ent_morph(me,invent02_item08_model);
			my._item_text1__0c0 = handle(invent02_item08_message1);
			my._item_text2__0c0 = handle(invent02_item08_message2);
			my._item_text3__0c0 = handle(invent02_item08_message3);
			my._item_action__0c0 = handle(invent02_item08_action);
			my._item_sound__0c0 = handle(invent02_item08_sound);
		}
		if (my._item_type__0c0 == 9)
		{
			ent_morph(me,invent02_item09_model);
			my._item_text1__0c0 = handle(invent02_item09_message1);
			my._item_text2__0c0 = handle(invent02_item09_message2);
			my._item_text3__0c0 = handle(invent02_item09_message3);
			my._item_action__0c0 = handle(invent02_item09_action);
			my._item_sound__0c0 = handle(invent02_item09_sound);
		}
		if (my._item_type__0c0 == 10)
		{
			ent_morph(me,invent02_item10_model);
			my._item_text1__0c0 = handle(invent02_item10_message1);
			my._item_text2__0c0 = handle(invent02_item10_message2);
			my._item_text3__0c0 = handle(invent02_item10_message3);
			my._item_action__0c0 = handle(invent02_item10_action);
			my._item_sound__0c0 = handle(invent02_item10_sound);
		}
		if (my._item_type__0c0 == 11)
		{
			ent_morph(me,invent02_item11_model);
			my._item_text1__0c0 = handle(invent02_item11_message1);
			my._item_text2__0c0 = handle(invent02_item11_message2);
			my._item_text3__0c0 = handle(invent02_item11_message3);
			my._item_action__0c0 = handle(invent02_item11_action);
			my._item_sound__0c0 = handle(invent02_item11_sound);
		}
		if (my._item_type__0c0 == 12)
		{
			ent_morph(me,invent02_item12_model);
			my._item_text1__0c0 = handle(invent02_item12_message1);
			my._item_text2__0c0 = handle(invent02_item12_message2);
			my._item_text3__0c0 = handle(invent02_item12_message3);
			my._item_action__0c0 = handle(invent02_item12_action);
			my._item_sound__0c0 = handle(invent02_item12_sound);
		}
		if (my._item_type__0c0 == 13)
		{
			ent_morph(me,invent02_item13_model);
			my._item_text1__0c0 = handle(invent02_item13_message1);
			my._item_text2__0c0 = handle(invent02_item13_message2);
			my._item_text3__0c0 = handle(invent02_item13_message3);
			my._item_action__0c0 = handle(invent02_item13_action);
			my._item_sound__0c0 = handle(invent02_item13_sound);
		}
		if (my._item_type__0c0 == 14)
		{
			ent_morph(me,invent02_item14_model);
			my._item_text1__0c0 = handle(invent02_item14_message1);
			my._item_text2__0c0 = handle(invent02_item14_message2);
			my._item_text3__0c0 = handle(invent02_item14_message3);
			my._item_action__0c0 = handle(invent02_item14_action);
			my._item_sound__0c0 = handle(invent02_item14_sound);
		}
		if (my._item_type__0c0 == 15)
		{
			ent_morph(me,invent02_item15_model);
			my._item_text1__0c0 = handle(invent02_item15_message1);
			my._item_text2__0c0 = handle(invent02_item15_message2);
			my._item_text3__0c0 = handle(invent02_item15_message3);
			my._item_action__0c0 = handle(invent02_item15_action);
			my._item_sound__0c0 = handle(invent02_item15_sound);
		}
		if (my._item_type__0c0 == 16)
		{
			ent_morph(me,invent02_item16_model);
			my._item_text1__0c0 = handle(invent02_item16_message1);
			my._item_text2__0c0 = handle(invent02_item16_message2);
			my._item_text3__0c0 = handle(invent02_item16_message3);
			my._item_action__0c0 = handle(invent02_item16_action);
			my._item_sound__0c0 = handle(invent02_item16_sound);
		}
		if (my._item_type__0c0 == 17)
		{
			ent_morph(me,invent02_item17_model);
			my._item_text1__0c0 = handle(invent02_item17_message1);
			my._item_text2__0c0 = handle(invent02_item17_message2);
			my._item_text3__0c0 = handle(invent02_item17_message3);
			my._item_action__0c0 = handle(invent02_item17_action);
			my._item_sound__0c0 = handle(invent02_item17_sound);
		}
		if (my._item_type__0c0 == 18)
		{
			ent_morph(me,invent02_item18_model);
			my._item_text1__0c0 = handle(invent02_item18_message1);
			my._item_text2__0c0 = handle(invent02_item18_message2);
			my._item_text3__0c0 = handle(invent02_item18_message3);
			my._item_action__0c0 = handle(invent02_item18_action);
			my._item_sound__0c0 = handle(invent02_item18_sound);
		}
		if (my._item_type__0c0 == 19)
		{
			ent_morph(me,invent02_item19_model);
			my._item_text1__0c0 = handle(invent02_item19_message1);
			my._item_text2__0c0 = handle(invent02_item19_message2);
			my._item_text3__0c0 = handle(invent02_item19_message3);
			my._item_action__0c0 = handle(invent02_item19_action);
			my._item_sound__0c0 = handle(invent02_item19_sound);
		}
		if (my._item_type__0c0 == 20)
		{
			ent_morph(me,invent02_item20_model);
			my._item_text1__0c0 = handle(invent02_item20_message1);
			my._item_text2__0c0 = handle(invent02_item20_message2);
			my._item_text3__0c0 = handle(invent02_item20_message3);
			my._item_action__0c0 = handle(invent02_item20_action);
			my._item_sound__0c0 = handle(invent02_item20_sound);
		}
		if (my._item_type__0c0 == 21)
		{
			ent_morph(me,invent02_item21_model);
			my._item_text1__0c0 = handle(invent02_item21_message1);
			my._item_text2__0c0 = handle(invent02_item21_message2);
			my._item_text3__0c0 = handle(invent02_item21_message3);
			my._item_action__0c0 = handle(invent02_item21_action);
			my._item_sound__0c0 = handle(invent02_item21_sound);
		}
		if (my._item_type__0c0 == 22)
		{
			ent_morph(me,invent02_item22_model);
			my._item_text1__0c0 = handle(invent02_item22_message1);
			my._item_text2__0c0 = handle(invent02_item22_message2);
			my._item_text3__0c0 = handle(invent02_item22_message3);
			my._item_action__0c0 = handle(invent02_item22_action);
			my._item_sound__0c0 = handle(invent02_item22_sound);
		}
		if (my._item_type__0c0 == 23)
		{
			ent_morph(me,invent02_item23_model);
			my._item_text1__0c0 = handle(invent02_item23_message1);
			my._item_text2__0c0 = handle(invent02_item23_message2);
			my._item_text3__0c0 = handle(invent02_item23_message3);
			my._item_action__0c0 = handle(invent02_item23_action);
			my._item_sound__0c0 = handle(invent02_item23_sound);
		}
		if (my._item_type__0c0 == 24)
		{
			ent_morph(me,invent02_item24_model);
			my._item_text1__0c0 = handle(invent02_item24_message1);
			my._item_text2__0c0 = handle(invent02_item24_message2);
			my._item_text3__0c0 = handle(invent02_item24_message3);
			my._item_action__0c0 = handle(invent02_item24_action);
			my._item_sound__0c0 = handle(invent02_item24_sound);
		}
		if (my._item_type__0c0 == 25)
		{
			ent_morph(me,invent02_item25_model);
			my._item_text1__0c0 = handle(invent02_item25_message1);
			my._item_text2__0c0 = handle(invent02_item25_message2);
			my._item_text3__0c0 = handle(invent02_item25_message3);
			my._item_action__0c0 = handle(invent02_item25_action);
			my._item_sound__0c0 = handle(invent02_item25_sound);
		}
		if (my._item_type__0c0 == 26)
		{
			ent_morph(me,invent02_item26_model);
			my._item_text1__0c0 = handle(invent02_item26_message1);
			my._item_text2__0c0 = handle(invent02_item26_message2);
			my._item_text3__0c0 = handle(invent02_item26_message3);
			my._item_action__0c0 = handle(invent02_item26_action);
			my._item_sound__0c0 = handle(invent02_item26_sound);
		}
		if (my._item_type__0c0 == 27)
		{
			ent_morph(me,invent02_item27_model);
			my._item_text1__0c0 = handle(invent02_item27_message1);
			my._item_text2__0c0 = handle(invent02_item27_message2);
			my._item_text3__0c0 = handle(invent02_item27_message3);
			my._item_action__0c0 = handle(invent02_item27_action);
			my._item_sound__0c0 = handle(invent02_item27_sound);
		}
		if (my._item_type__0c0 == 28)
		{
			ent_morph(me,invent02_item28_model);
			my._item_text1__0c0 = handle(invent02_item28_message1);
			my._item_text2__0c0 = handle(invent02_item28_message2);
			my._item_text3__0c0 = handle(invent02_item28_message3);
			my._item_action__0c0 = handle(invent02_item28_action);
			my._item_sound__0c0 = handle(invent02_item28_sound);
		}
		if (my._item_type__0c0 == 29)
		{
			ent_morph(me,invent02_item29_model);
			my._item_text1__0c0 = handle(invent02_item29_message1);
			my._item_text2__0c0 = handle(invent02_item29_message2);
			my._item_text3__0c0 = handle(invent02_item29_message3);
			my._item_action__0c0 = handle(invent02_item29_action);
			my._item_sound__0c0 = handle(invent02_item29_sound);
		}
		if (my._item_type__0c0 == 30)
		{
			ent_morph(me,invent02_item30_model);
			my._item_text1__0c0 = handle(invent02_item30_message1);
			my._item_text2__0c0 = handle(invent02_item30_message2);
			my._item_text3__0c0 = handle(invent02_item30_message3);
			my._item_action__0c0 = handle(invent02_item30_action);
			my._item_sound__0c0 = handle(invent02_item30_sound);
		}
		if (my._item_type__0c0 == 31)
		{
			ent_morph(me,invent02_item31_model);
			my._item_text1__0c0 = handle(invent02_item31_message1);
			my._item_text2__0c0 = handle(invent02_item31_message2);
			my._item_text3__0c0 = handle(invent02_item31_message3);
			my._item_action__0c0 = handle(invent02_item31_action);
			my._item_sound__0c0 = handle(invent02_item31_sound);
		}
		if (my._item_type__0c0 == 32)
		{
			ent_morph(me,invent02_item32_model);
			my._item_text1__0c0 = handle(invent02_item32_message1);
			my._item_text2__0c0 = handle(invent02_item32_message2);
			my._item_text3__0c0 = handle(invent02_item32_message3);
			my._item_action__0c0 = handle(invent02_item32_action);
			my._item_sound__0c0 = handle(invent02_item32_sound);
		}
		if (my._item_type__0c0 == 33)
		{
			ent_morph(me,invent02_item33_model);
			my._item_text1__0c0 = handle(invent02_item33_message1);
			my._item_text2__0c0 = handle(invent02_item33_message2);
			my._item_text3__0c0 = handle(invent02_item33_message3);
			my._item_action__0c0 = handle(invent02_item33_action);
			my._item_sound__0c0 = handle(invent02_item33_sound);
		}
		if (my._item_type__0c0 == 34)
		{
			ent_morph(me,invent02_item34_model);
			my._item_text1__0c0 = handle(invent02_item34_message1);
			my._item_text2__0c0 = handle(invent02_item34_message2);
			my._item_text3__0c0 = handle(invent02_item34_message3);
			my._item_action__0c0 = handle(invent02_item34_action);
			my._item_sound__0c0 = handle(invent02_item34_sound);
		}
		if (my._item_type__0c0 == 35)
		{
			ent_morph(me,invent02_item35_model);
			my._item_text1__0c0 = handle(invent02_item35_message1);
			my._item_text2__0c0 = handle(invent02_item35_message2);
			my._item_text3__0c0 = handle(invent02_item35_message3);
			my._item_action__0c0 = handle(invent02_item35_action);
			my._item_sound__0c0 = handle(invent02_item35_sound);
		}
		if (my._item_type__0c0 == 36)
		{
			ent_morph(me,invent02_item36_model);
			my._item_text1__0c0 = handle(invent02_item36_message1);
			my._item_text2__0c0 = handle(invent02_item36_message2);
			my._item_text3__0c0 = handle(invent02_item36_message3);
			my._item_action__0c0 = handle(invent02_item36_action);
			my._item_sound__0c0 = handle(invent02_item36_sound);
		}
		if (my._item_type__0c0 == 37)
		{
			ent_morph(me,invent02_item37_model);
			my._item_text1__0c0 = handle(invent02_item37_message1);
			my._item_text2__0c0 = handle(invent02_item37_message2);
			my._item_text3__0c0 = handle(invent02_item37_message3);
			my._item_action__0c0 = handle(invent02_item37_action);
			my._item_sound__0c0 = handle(invent02_item37_sound);
		}
		if (my._item_type__0c0 == 38)
		{
			ent_morph(me,invent02_item38_model);
			my._item_text1__0c0 = handle(invent02_item38_message1);
			my._item_text2__0c0 = handle(invent02_item38_message2);
			my._item_text3__0c0 = handle(invent02_item38_message3);
			my._item_action__0c0 = handle(invent02_item38_action);
			my._item_sound__0c0 = handle(invent02_item38_sound);
		}
		if (my._item_type__0c0 == 39)
		{
			ent_morph(me,invent02_item39_model);
			my._item_text1__0c0 = handle(invent02_item39_message1);
			my._item_text2__0c0 = handle(invent02_item39_message2);
			my._item_text3__0c0 = handle(invent02_item39_message3);
			my._item_action__0c0 = handle(invent02_item39_action);
			my._item_sound__0c0 = handle(invent02_item39_sound);
		}
		if (my._item_type__0c0 == 40)
		{
			ent_morph(me,invent02_item40_model);
			my._item_text1__0c0 = handle(invent02_item40_message1);
			my._item_text2__0c0 = handle(invent02_item40_message2);
			my._item_text3__0c0 = handle(invent02_item40_message3);
			my._item_action__0c0 = handle(invent02_item40_action);
			my._item_sound__0c0 = handle(invent02_item40_sound);
		}
		if (my._item_type__0c0 == 41)
		{
			ent_morph(me,invent02_item41_model);
			my._item_text1__0c0 = handle(invent02_item41_message1);
			my._item_text2__0c0 = handle(invent02_item41_message2);
			my._item_text3__0c0 = handle(invent02_item41_message3);
			my._item_action__0c0 = handle(invent02_item41_action);
			my._item_sound__0c0 = handle(invent02_item41_sound);
		}
		if (my._item_type__0c0 == 42)
		{
			ent_morph(me,invent02_item42_model);
			my._item_text1__0c0 = handle(invent02_item42_message1);
			my._item_text2__0c0 = handle(invent02_item42_message2);
			my._item_text3__0c0 = handle(invent02_item42_message3);
			my._item_action__0c0 = handle(invent02_item42_action);
			my._item_sound__0c0 = handle(invent02_item42_sound);
		}
		if (my._item_type__0c0 == 43)
		{
			ent_morph(me,invent02_item43_model);
			my._item_text1__0c0 = handle(invent02_item43_message1);
			my._item_text2__0c0 = handle(invent02_item43_message2);
			my._item_text3__0c0 = handle(invent02_item43_message3);
			my._item_action__0c0 = handle(invent02_item43_action);
			my._item_sound__0c0 = handle(invent02_item43_sound);
		}
		if (my._item_type__0c0 == 44)
		{
			ent_morph(me,invent02_item44_model);
			my._item_text1__0c0 = handle(invent02_item44_message1);
			my._item_text2__0c0 = handle(invent02_item44_message2);
			my._item_text3__0c0 = handle(invent02_item44_message3);
			my._item_action__0c0 = handle(invent02_item44_action);
			my._item_sound__0c0 = handle(invent02_item44_sound);
		}
		if (my._item_type__0c0 == 45)
		{
			ent_morph(me,invent02_item45_model);
			my._item_text1__0c0 = handle(invent02_item45_message1);
			my._item_text2__0c0 = handle(invent02_item45_message2);
			my._item_text3__0c0 = handle(invent02_item45_message3);
			my._item_action__0c0 = handle(invent02_item45_action);
			my._item_sound__0c0 = handle(invent02_item45_sound);
		}
		if (my._item_type__0c0 == 46)
		{
			ent_morph(me,invent02_item46_model);
			my._item_text1__0c0 = handle(invent02_item46_message1);
			my._item_text2__0c0 = handle(invent02_item46_message2);
			my._item_text3__0c0 = handle(invent02_item46_message3);
			my._item_action__0c0 = handle(invent02_item46_action);
			my._item_sound__0c0 = handle(invent02_item46_sound);
		}
		if (my._item_type__0c0 == 47)
		{
			ent_morph(me,invent02_item47_model);
			my._item_text1__0c0 = handle(invent02_item47_message1);
			my._item_text2__0c0 = handle(invent02_item47_message2);
			my._item_text3__0c0 = handle(invent02_item47_message3);
			my._item_action__0c0 = handle(invent02_item47_action);
			my._item_sound__0c0 = handle(invent02_item47_sound);
		}
		if (my._item_type__0c0 == 48)
		{
			ent_morph(me,invent02_item48_model);
			my._item_text1__0c0 = handle(invent02_item48_message1);
			my._item_text2__0c0 = handle(invent02_item48_message2);
			my._item_text3__0c0 = handle(invent02_item48_message3);
			my._item_action__0c0 = handle(invent02_item48_action);
			my._item_sound__0c0 = handle(invent02_item48_sound);
		}
		if (my._item_type__0c0 == 49)
		{
			ent_morph(me,invent02_item49_model);
			my._item_text1__0c0 = handle(invent02_item49_message1);
			my._item_text2__0c0 = handle(invent02_item49_message2);
			my._item_text3__0c0 = handle(invent02_item49_message3);
			my._item_action__0c0 = handle(invent02_item49_action);
			my._item_sound__0c0 = handle(invent02_item49_sound);
		}
		if (my._item_type__0c0 == 50)
		{
			ent_morph(me,invent02_item50_model);
			my._item_text1__0c0 = handle(invent02_item50_message1);
			my._item_text2__0c0 = handle(invent02_item50_message2);
			my._item_text3__0c0 = handle(invent02_item50_message3);
			my._item_action__0c0 = handle(invent02_item50_action);
			my._item_sound__0c0 = handle(invent02_item50_sound);
		}
		if (my._item_type__0c0 == 51)
		{
			ent_morph(me,invent02_item51_model);
			my._item_text1__0c0 = handle(invent02_item51_message1);
			my._item_text2__0c0 = handle(invent02_item51_message2);
			my._item_text3__0c0 = handle(invent02_item51_message3);
			my._item_action__0c0 = handle(invent02_item51_action);
			my._item_sound__0c0 = handle(invent02_item51_sound);
		}
		if (my._item_type__0c0 == 52)
		{
			ent_morph(me,invent02_item52_model);
			my._item_text1__0c0 = handle(invent02_item52_message1);
			my._item_text2__0c0 = handle(invent02_item52_message2);
			my._item_text3__0c0 = handle(invent02_item52_message3);
			my._item_action__0c0 = handle(invent02_item52_action);
			my._item_sound__0c0 = handle(invent02_item52_sound);
		}
		if (my._item_type__0c0 == 53)
		{
			ent_morph(me,invent02_item53_model);
			my._item_text1__0c0 = handle(invent02_item53_message1);
			my._item_text2__0c0 = handle(invent02_item53_message2);
			my._item_text3__0c0 = handle(invent02_item53_message3);
			my._item_action__0c0 = handle(invent02_item53_action);
			my._item_sound__0c0 = handle(invent02_item53_sound);
		}
		if (my._item_type__0c0 == 54)
		{
			ent_morph(me,invent02_item54_model);
			my._item_text1__0c0 = handle(invent02_item54_message1);
			my._item_text2__0c0 = handle(invent02_item54_message2);
			my._item_text3__0c0 = handle(invent02_item54_message3);
			my._item_action__0c0 = handle(invent02_item54_action);
			my._item_sound__0c0 = handle(invent02_item54_sound);
		}
		if (my._item_type__0c0 == 55)
		{
			ent_morph(me,invent02_item55_model);
			my._item_text1__0c0 = handle(invent02_item55_message1);
			my._item_text2__0c0 = handle(invent02_item55_message2);
			my._item_text3__0c0 = handle(invent02_item55_message3);
			my._item_action__0c0 = handle(invent02_item55_action);
			my._item_sound__0c0 = handle(invent02_item55_sound);
		}
		if (my._item_type__0c0 == 56)
		{
			ent_morph(me,invent02_item56_model);
			my._item_text1__0c0 = handle(invent02_item56_message1);
			my._item_text2__0c0 = handle(invent02_item56_message2);
			my._item_text3__0c0 = handle(invent02_item56_message3);
			my._item_action__0c0 = handle(invent02_item56_action);
			my._item_sound__0c0 = handle(invent02_item56_sound);
		}
		if (my._item_type__0c0 == 57)
		{
			ent_morph(me,invent02_item57_model);
			my._item_text1__0c0 = handle(invent02_item57_message1);
			my._item_text2__0c0 = handle(invent02_item57_message2);
			my._item_text3__0c0 = handle(invent02_item57_message3);
			my._item_action__0c0 = handle(invent02_item57_action);
			my._item_sound__0c0 = handle(invent02_item57_sound);
		}
		if (my._item_type__0c0 == 58)
		{
			ent_morph(me,invent02_item58_model);
			my._item_text1__0c0 = handle(invent02_item58_message1);
			my._item_text2__0c0 = handle(invent02_item58_message2);
			my._item_text3__0c0 = handle(invent02_item58_message3);
			my._item_action__0c0 = handle(invent02_item58_action);
			my._item_sound__0c0 = handle(invent02_item58_sound);
		}
		if (my._item_type__0c0 == 59)
		{
			ent_morph(me,invent02_item59_model);
			my._item_text1__0c0 = handle(invent02_item59_message1);
			my._item_text2__0c0 = handle(invent02_item59_message2);
			my._item_text3__0c0 = handle(invent02_item59_message3);
			my._item_action__0c0 = handle(invent02_item59_action);
			my._item_sound__0c0 = handle(invent02_item59_sound);
		}
		if (my._item_type__0c0 == 60)
		{
			ent_morph(me,invent02_item60_model);
			my._item_text1__0c0 = handle(invent02_item60_message1);
			my._item_text2__0c0 = handle(invent02_item60_message2);
			my._item_text3__0c0 = handle(invent02_item60_message3);
			my._item_action__0c0 = handle(invent02_item60_action);
			my._item_sound__0c0 = handle(invent02_item60_sound);
		}
		if (my._item_type__0c0 == 61)
		{
			ent_morph(me,invent02_item61_model);
			my._item_text1__0c0 = handle(invent02_item61_message1);
			my._item_text2__0c0 = handle(invent02_item61_message2);
			my._item_text3__0c0 = handle(invent02_item61_message3);
			my._item_action__0c0 = handle(invent02_item61_action);
			my._item_sound__0c0 = handle(invent02_item61_sound);
		}
		if (my._item_type__0c0 == 62)
		{
			ent_morph(me,invent02_item62_model);
			my._item_text1__0c0 = handle(invent02_item62_message1);
			my._item_text2__0c0 = handle(invent02_item62_message2);
			my._item_text3__0c0 = handle(invent02_item62_message3);
			my._item_action__0c0 = handle(invent02_item62_action);
			my._item_sound__0c0 = handle(invent02_item62_sound);
		}
		if (my._item_type__0c0 == 63)
		{
			ent_morph(me,invent02_item63_model);
			my._item_text1__0c0 = handle(invent02_item63_message1);
			my._item_text2__0c0 = handle(invent02_item63_message2);
			my._item_text3__0c0 = handle(invent02_item63_message3);
			my._item_action__0c0 = handle(invent02_item63_action);
			my._item_sound__0c0 = handle(invent02_item63_sound);
		}
		if (my._item_type__0c0 == 64)
		{
			ent_morph(me,invent02_item64_model);
			my._item_text1__0c0 = handle(invent02_item64_message1);
			my._item_text2__0c0 = handle(invent02_item64_message2);
			my._item_text3__0c0 = handle(invent02_item64_message3);
			my._item_action__0c0 = handle(invent02_item64_action);
			my._item_sound__0c0 = handle(invent02_item64_sound);
		}
		if (my._item_type__0c0 == 65)
		{
			ent_morph(me,invent02_item65_model);
			my._item_text1__0c0 = handle(invent02_item65_message1);
			my._item_text2__0c0 = handle(invent02_item65_message2);
			my._item_text3__0c0 = handle(invent02_item65_message3);
			my._item_action__0c0 = handle(invent02_item65_action);
			my._item_sound__0c0 = handle(invent02_item65_sound);
		}
		if (my._item_type__0c0 == 66)
		{
			ent_morph(me,invent02_item66_model);
			my._item_text1__0c0 = handle(invent02_item66_message1);
			my._item_text2__0c0 = handle(invent02_item66_message2);
			my._item_text3__0c0 = handle(invent02_item66_message3);
			my._item_action__0c0 = handle(invent02_item66_action);
			my._item_sound__0c0 = handle(invent02_item66_sound);
		}
		if (my._item_type__0c0 == 67)
		{
			ent_morph(me,invent02_item67_model);
			my._item_text1__0c0 = handle(invent02_item67_message1);
			my._item_text2__0c0 = handle(invent02_item67_message2);
			my._item_text3__0c0 = handle(invent02_item67_message3);
			my._item_action__0c0 = handle(invent02_item67_action);
			my._item_sound__0c0 = handle(invent02_item67_sound);
		}
		if (my._item_type__0c0 == 68)
		{
			ent_morph(me,invent02_item68_model);
			my._item_text1__0c0 = handle(invent02_item68_message1);
			my._item_text2__0c0 = handle(invent02_item68_message2);
			my._item_text3__0c0 = handle(invent02_item68_message3);
			my._item_action__0c0 = handle(invent02_item68_action);
			my._item_sound__0c0 = handle(invent02_item68_sound);
		}
		if (my._item_type__0c0 == 69)
		{
			ent_morph(me,invent02_item69_model);
			my._item_text1__0c0 = handle(invent02_item69_message1);
			my._item_text2__0c0 = handle(invent02_item69_message2);
			my._item_text3__0c0 = handle(invent02_item69_message3);
			my._item_action__0c0 = handle(invent02_item69_action);
			my._item_sound__0c0 = handle(invent02_item69_sound);
		}
		if (my._item_type__0c0 == 70)
		{
			ent_morph(me,invent02_item70_model);
			my._item_text1__0c0 = handle(invent02_item70_message1);
			my._item_text2__0c0 = handle(invent02_item70_message2);
			my._item_text3__0c0 = handle(invent02_item70_message3);
			my._item_action__0c0 = handle(invent02_item70_action);
			my._item_sound__0c0 = handle(invent02_item70_sound);
		}
		ifdef	GID01_OLD_COLLIDE;	// use the old collision code
			my.fat = OFF; my.narrow = ON;
		ifelse;	// use A6 collison
			my.fat = ON; my.narrow = ON;
		endif;
		my.invisible = off;
		my.passable = off;
		my.shadow = on;
		my.enable_scan = on; // player scans
		my.enable_impact = on; // player hits
		my.enable_sonar = on; // player steps on
		wait(1);
		my.event = _invent02_pickup_event;
		invent02_drop_Scan();
		wait(1);
		_invent02_wait_for_add();
	};





var _invent02_msg_show_timer = 0;
var _invent02_item_pos = 0;

	function _invent02_get_action(index)
	{
		var item;
		item = _invent02_inventory_items[index];
		if (item <= 0) 
		{
			return (handle(""));
		}
		if (item == 1)
		{
			return (handle(invent02_item01_action));
		}
		if (item == 2)
		{
			return (handle(invent02_item02_action));
		}
		if (item == 3)
		{
			return (handle(invent02_item03_action));
		}
		if (item == 4)
		{
			return (handle(invent02_item04_action));
		}
		if (item == 5)
		{
			return (handle(invent02_item05_action));
		}
		if (item == 6)
		{
			return (handle(invent02_item06_action));
		}
		if (item == 7)
		{
			return (handle(invent02_item07_action));
		}
		if (item == 8)
		{
			return (handle(invent02_item08_action));
		}
		if (item == 9)
		{
			return (handle(invent02_item09_action));
		}
		if (item == 10)
		{
			return (handle(invent02_item10_action));
		}
		if (item == 11)
		{
			return (handle(invent02_item11_action));
		}
		if (item == 12)
		{
			return (handle(invent02_item12_action));
		}
		if (item == 13)
		{
			return (handle(invent02_item13_action));
		}
		if (item == 14)
		{
			return (handle(invent02_item14_action));
		}
		if (item == 15)
		{
			return (handle(invent02_item15_action));
		}
		if (item == 16)
		{
			return (handle(invent02_item16_action));
		}
		if (item == 17)
		{
			return (handle(invent02_item17_action));
		}
		if (item == 18)
		{
			return (handle(invent02_item18_action));
		}
		if (item == 19)
		{
			return (handle(invent02_item19_action));
		}
		if (item == 20)
		{
			return (handle(invent02_item20_action));
		}
		if (item == 21)
		{
			return (handle(invent02_item21_action));
		}
		if (item == 22)
		{
			return (handle(invent02_item22_action));
		}
		if (item == 23)
		{
			return (handle(invent02_item23_action));
		}
		if (item == 24)
		{
			return (handle(invent02_item24_action));
		}
		if (item == 25)
		{
			return (handle(invent02_item25_action));
		}
		if (item == 26)
		{
			return (handle(invent02_item26_action));
		}
		if (item == 27)
		{
			return (handle(invent02_item27_action));
		}
		if (item == 28)
		{
			return (handle(invent02_item28_action));
		}
		if (item == 29)
		{
			return (handle(invent02_item29_action));
		}
		if (item == 30)
		{
			return (handle(invent02_item30_action));
		}
		if (item == 31)
		{
			return (handle(invent02_item31_action));
		}
		if (item == 32)
		{
			return (handle(invent02_item32_action));
		}
		if (item == 33)
		{
			return (handle(invent02_item33_action));
		}
		if (item == 34)
		{
			return (handle(invent02_item34_action));
		}
		if (item == 35)
		{
			return (handle(invent02_item35_action));
		}
		if (item == 36)
		{
			return (handle(invent02_item36_action));
		}
		if (item == 37)
		{
			return (handle(invent02_item37_action));
		}
		if (item == 38)
		{
			return (handle(invent02_item38_action));
		}
		if (item == 39)
		{
			return (handle(invent02_item39_action));
		}
		if (item == 40)
		{
			return (handle(invent02_item40_action));
		}
		if (item == 41)
		{
			return (handle(invent02_item41_action));
		}
		if (item == 42)
		{
			return (handle(invent02_item42_action));
		}
		if (item == 43)
		{
			return (handle(invent02_item43_action));
		}
		if (item == 44)
		{
			return (handle(invent02_item44_action));
		}
		if (item == 45)
		{
			return (handle(invent02_item45_action));
		}
		if (item == 46)
		{
			return (handle(invent02_item46_action));
		}
		if (item == 47)
		{
			return (handle(invent02_item47_action));
		}
		if (item == 48)
		{
			return (handle(invent02_item48_action));
		}
		if (item == 49)
		{
			return (handle(invent02_item49_action));
		}
		if (item == 50)
		{
			return (handle(invent02_item50_action));
		}
		if (item == 51)
		{
			return (handle(invent02_item51_action));
		}
		if (item == 52)
		{
			return (handle(invent02_item52_action));
		}
		if (item == 53)
		{
			return (handle(invent02_item53_action));
		}
		if (item == 54)
		{
			return (handle(invent02_item54_action));
		}
		if (item == 55)
		{
			return (handle(invent02_item55_action));
		}
		if (item == 56)
		{
			return (handle(invent02_item56_action));
		}
		if (item == 57)
		{
			return (handle(invent02_item57_action));
		}
		if (item == 58)
		{
			return (handle(invent02_item58_action));
		}
		if (item == 59)
		{
			return (handle(invent02_item59_action));
		}
		if (item == 60)
		{
			return (handle(invent02_item60_action));
		}
		if (item == 61)
		{
			return (handle(invent02_item61_action));
		}
		if (item == 62)
		{
			return (handle(invent02_item62_action));
		}
		if (item == 63)
		{
			return (handle(invent02_item63_action));
		}
		if (item == 64)
		{
			return (handle(invent02_item64_action));
		}
		if (item == 65)
		{
			return (handle(invent02_item65_action));
		}
		if (item == 66)
		{
			return (handle(invent02_item66_action));
		}
		if (item == 67)
		{
			return (handle(invent02_item67_action));
		}
		if (item == 68)
		{
			return (handle(invent02_item68_action));
		}
		if (item == 69)
		{
			return (handle(invent02_item69_action));
		}
		if (item == 70)
		{
			return (handle(invent02_item70_action));
		}
		return (handle(""));
	};

	function _invent02_get_icon(index)
	{
		var item;
		item = _invent02_inventory_items[index];
		if (item <= 0)
		{
			return (handle(_invent02_item_bmp));
		}
		if (item == 1)
		{
			return (handle(invent02_item01_bmp));
		}
		if (item == 2)
		{
			return (handle(invent02_item02_bmp));
		}
		if (item == 3)
		{
			return (handle(invent02_item03_bmp));
		}
		if (item == 4)
		{
			return (handle(invent02_item04_bmp));
		}
		if (item == 5)
		{
			return (handle(invent02_item05_bmp));
		}
		if (item == 6)
		{
			return (handle(invent02_item06_bmp));
		}
		if (item == 7)
		{
			return (handle(invent02_item07_bmp));
		}
		if (item == 8)
		{
			return (handle(invent02_item08_bmp));
		}
		if (item == 9)
		{
			return (handle(invent02_item09_bmp));
		}
		if (item == 10)
		{
			return (handle(invent02_item10_bmp));
		}
		if (item == 11)
		{
			return (handle(invent02_item11_bmp));
		}
		if (item == 12)
		{
			return (handle(invent02_item12_bmp));
		}
		if (item == 13)
		{
			return (handle(invent02_item13_bmp));
		}
		if (item == 14)
		{
			return (handle(invent02_item14_bmp));
		}
		if (item == 15)
		{
			return (handle(invent02_item15_bmp));
		}
		if (item == 16)
		{
			return (handle(invent02_item16_bmp));
		}
		if (item == 17)
		{
			return (handle(invent02_item17_bmp));
		}
		if (item == 18)
		{
			return (handle(invent02_item18_bmp));
		}
		if (item == 19)
		{
			return (handle(invent02_item19_bmp));
		}
		if (item == 20)
		{
			return (handle(invent02_item20_bmp));
		}
		if (item == 21)
		{
			return (handle(invent02_item21_bmp));
		}
		if (item == 22)
		{
			return (handle(invent02_item22_bmp));
		}
		if (item == 23)
		{
			return (handle(invent02_item23_bmp));
		}
		if (item == 24)
		{
			return (handle(invent02_item24_bmp));
		}
		if (item == 25)
		{
			return (handle(invent02_item25_bmp));
		}
		if (item == 26)
		{
			return (handle(invent02_item26_bmp));
		}
		if (item == 27)
		{
			return (handle(invent02_item27_bmp));
		}
		if (item == 28)
		{
			return (handle(invent02_item28_bmp));
		}
		if (item == 29)
		{
			return (handle(invent02_item29_bmp));
		}
		if (item == 30)
		{
			return (handle(invent02_item30_bmp));
		}
		if (item == 31)
		{
			return (handle(invent02_item31_bmp));
		}
		if (item == 32)
		{
			return (handle(invent02_item32_bmp));
		}
		if (item == 33)
		{
			return (handle(invent02_item33_bmp));
		}
		if (item == 34)
		{
			return (handle(invent02_item34_bmp));
		}
		if (item == 35)
		{
			return (handle(invent02_item35_bmp));
		}
		if (item == 36)
		{
			return (handle(invent02_item36_bmp));
		}
		if (item == 37)
		{
			return (handle(invent02_item37_bmp));
		}
		if (item == 38)
		{
			return (handle(invent02_item38_bmp));
		}
		if (item == 39)
		{
			return (handle(invent02_item39_bmp));
		}
		if (item == 40)
		{
			return (handle(invent02_item40_bmp));
		}
		if (item == 41)
		{
			return (handle(invent02_item41_bmp));
		}
		if (item == 42)
		{
			return (handle(invent02_item42_bmp));
		}
		if (item == 43)
		{
			return (handle(invent02_item43_bmp));
		}
		if (item == 44)
		{
			return (handle(invent02_item44_bmp));
		}
		if (item == 45)
		{
			return (handle(invent02_item45_bmp));
		}
		if (item == 46)
		{
			return (handle(invent02_item46_bmp));
		}
		if (item == 47)
		{
			return (handle(invent02_item47_bmp));
		}
		if (item == 48)
		{
			return (handle(invent02_item48_bmp));
		}
		if (item == 49)
		{
			return (handle(invent02_item49_bmp));
		}
		if (item == 50)
		{
			return (handle(invent02_item50_bmp));
		}
		if (item == 51)
		{
			return (handle(invent02_item51_bmp));
		}
		if (item == 52)
		{
			return (handle(invent02_item52_bmp));
		}
		if (item == 53)
		{
			return (handle(invent02_item53_bmp));
		}
		if (item == 54)
		{
			return (handle(invent02_item54_bmp));
		}
		if (item == 55)
		{
			return (handle(invent02_item55_bmp));
		}
		if (item == 56)
		{
			return (handle(invent02_item56_bmp));
		}
		if (item == 57)
		{
			return (handle(invent02_item57_bmp));
		}
		if (item == 58)
		{
			return (handle(invent02_item58_bmp));
		}
		if (item == 59)
		{
			return (handle(invent02_item59_bmp));
		}
		if (item == 60)
		{
			return (handle(invent02_item60_bmp));
		}
		if (item == 61)
		{
			return (handle(invent02_item61_bmp));
		}
		if (item == 62)
		{
			return (handle(invent02_item62_bmp));
		}
		if (item == 63)
		{
			return (handle(invent02_item63_bmp));
		}
		if (item == 64)
		{
			return (handle(invent02_item64_bmp));
		}
		if (item == 65)
		{
			return (handle(invent02_item65_bmp));
		}
		if (item == 66)
		{
			return (handle(invent02_item66_bmp));
		}
		if (item == 67)
		{
			return (handle(invent02_item67_bmp));
		}
		if (item == 68)
		{
			return (handle(invent02_item68_bmp));
		}
		if (item == 69)
		{
			return (handle(invent02_item69_bmp));
		}
		if (item == 70)
		{
			return (handle(invent02_item70_bmp));
		}
	};


// ---------------------------------------------------------------------
//
//  This section of code is for the auto fadeout message box 
//
// ---------------------------------------------------------------------

// ---------------------------------------------------------------------
// font for the message box

	font myfont = <invent02_font.pcx>,12,16;


// ---------------------------------------------------------------------
// background panel
panel _invent02_pan_msg
{
	bmap = _invent02_msg_bmp;
	layer = 7;
	pos_x = 0;
	pos_y = 0;
	flags = refresh, overlay, transparent;
}

// ---------------------------------------------------------------------
// 3 lines of 30 characters text window
text _invent02_text_msg
{
	strings 3;
	string "                              ";
	string "                              ";
	string "                              ";
	layer 8;
	pos_x = 0;
	pos_y = 0;
	font = myfont;
	flags = transparent;
}

// ---------------------------------------------------------------------
// some temp strings for formating a line of text and centering it
//
string _invent02_format_msg_tmp = "                              ";
string _invent02_format_msg_fnl = "                              ";
string _diag_num[30];

// ---------------------------------------------------------------------
// This function formats 3 lines of text using the
// line prefix and suffix parts and then centering 
// the resulting line.see items 19-24 for the prefix
// and suffix line parts.
//
	function _invent02_format_msg(item)
	{
		var len;
		var index;
		var line1;
		var line2;
		var line3;
		
		if (item == 1)
		{
			line1 = handle(invent02_item01_message1);
			line2 = handle(invent02_item01_message2);
			line3 = handle(invent02_item01_message3);
		}
		if (item == 2)
		{
			line1 = handle(invent02_item02_message1);
			line2 = handle(invent02_item02_message2);
			line3 = handle(invent02_item02_message3);
		}
		if (item == 3)
		{
			line1 = handle(invent02_item03_message1);
			line2 = handle(invent02_item03_message2);
			line3 = handle(invent02_item03_message3);
		}
		if (item == 4)
		{
			line1 = handle(invent02_item04_message1);
			line2 = handle(invent02_item04_message2);
			line3 = handle(invent02_item04_message3);
		}
		if (item == 5)
		{
			line1 = handle(invent02_item05_message1);
			line2 = handle(invent02_item05_message2);
			line3 = handle(invent02_item05_message3);
		}
		if (item == 6)
		{
			line1 = handle(invent02_item06_message1);
			line2 = handle(invent02_item06_message2);
			line3 = handle(invent02_item06_message3);
		}
		if (item == 7)
		{
			line1 = handle(invent02_item07_message1);
			line2 = handle(invent02_item07_message2);
			line3 = handle(invent02_item07_message3);
		}
		if (item == 8)
		{
			line1 = handle(invent02_item08_message1);
			line2 = handle(invent02_item08_message2);
			line3 = handle(invent02_item08_message3);
		}
		if (item == 9)
		{
			line1 = handle(invent02_item09_message1);
			line2 = handle(invent02_item09_message2);
			line3 = handle(invent02_item09_message3);
		}
		if (item == 10)
		{
			line1 = handle(invent02_item10_message1);
			line2 = handle(invent02_item10_message2);
			line3 = handle(invent02_item10_message3);
		}
		if (item == 11)
		{
			line1 = handle(invent02_item11_message1);
			line2 = handle(invent02_item11_message2);
			line3 = handle(invent02_item11_message3);
		}
		if (item == 12)
		{
			line1 = handle(invent02_item12_message1);
			line2 = handle(invent02_item12_message2);
			line3 = handle(invent02_item12_message3);
		}
		if (item == 13)
		{
			line1 = handle(invent02_item13_message1);
			line2 = handle(invent02_item13_message2);
			line3 = handle(invent02_item13_message3);
		}
		if (item == 14)
		{
			line1 = handle(invent02_item14_message1);
			line2 = handle(invent02_item14_message2);
			line3 = handle(invent02_item14_message3);
		}
		if (item == 15)
		{
			line1 = handle(invent02_item15_message1);
			line2 = handle(invent02_item15_message2);
			line3 = handle(invent02_item15_message3);
		}
		if (item == 16)
		{
			line1 = handle(invent02_item16_message1);
			line2 = handle(invent02_item16_message2);
			line3 = handle(invent02_item16_message3);
		}
		if (item == 17)
		{
			line1 = handle(invent02_item17_message1);
			line2 = handle(invent02_item17_message2);
			line3 = handle(invent02_item17_message3);
		}
		if (item == 18)
		{
			line1 = handle(invent02_item18_message1);
			line2 = handle(invent02_item18_message2);
			line3 = handle(invent02_item18_message3);
		}
		if (item == 19)
		{
			line1 = handle(invent02_item19_message1);
			line2 = handle(invent02_item19_message2);
			line3 = handle(invent02_item19_message3);
		}
		if (item == 20)
		{
			line1 = handle(invent02_item20_message1);
			line2 = handle(invent02_item20_message2);
			line3 = handle(invent02_item20_message3);
		}
		if (item == 21)
		{
			line1 = handle(invent02_item21_message1);
			line2 = handle(invent02_item21_message2);
			line3 = handle(invent02_item21_message3);
		}
		if (item == 22)
		{
			line1 = handle(invent02_item22_message1);
			line2 = handle(invent02_item22_message2);
			line3 = handle(invent02_item22_message3);
		}
		if (item == 23)
		{
			line1 = handle(invent02_item23_message1);
			line2 = handle(invent02_item23_message2);
			line3 = handle(invent02_item23_message3);
		}
		if (item == 24)
		{
			line1 = handle(invent02_item24_message1);
			line2 = handle(invent02_item24_message2);
			line3 = handle(invent02_item24_message3);
		}
		if (item == 25)
		{
			line1 = handle(invent02_item25_message1);
			line2 = handle(invent02_item25_message2);
			line3 = handle(invent02_item25_message3);
		}
		if (item == 26)
		{
			line1 = handle(invent02_item26_message1);
			line2 = handle(invent02_item26_message2);
			line3 = handle(invent02_item26_message3);
		}
		if (item == 27)
		{
			line1 = handle(invent02_item27_message1);
			line2 = handle(invent02_item27_message2);
			line3 = handle(invent02_item27_message3);
		}
		if (item == 28)
		{
			line1 = handle(invent02_item28_message1);
			line2 = handle(invent02_item28_message2);
			line3 = handle(invent02_item28_message3);
		}
		if (item == 29)
		{
			line1 = handle(invent02_item29_message1);
			line2 = handle(invent02_item29_message2);
			line3 = handle(invent02_item29_message3);
		}
		if (item == 30)
		{
			line1 = handle(invent02_item30_message1);
			line2 = handle(invent02_item30_message2);
			line3 = handle(invent02_item30_message3);
		}
		if (item == 31)
		{
			line1 = handle(invent02_item31_message1);
			line2 = handle(invent02_item31_message2);
			line3 = handle(invent02_item31_message3);
		}
		if (item == 32)
		{
			line1 = handle(invent02_item32_message1);
			line2 = handle(invent02_item32_message2);
			line3 = handle(invent02_item32_message3);
		}
		if (item == 33)
		{
			line1 = handle(invent02_item33_message1);
			line2 = handle(invent02_item33_message2);
			line3 = handle(invent02_item33_message3);
		}
		if (item == 34)
		{
			line1 = handle(invent02_item34_message1);
			line2 = handle(invent02_item34_message2);
			line3 = handle(invent02_item34_message3);
		}
		if (item == 35)
		{
			line1 = handle(invent02_item35_message1);
			line2 = handle(invent02_item35_message2);
			line3 = handle(invent02_item35_message3);
		}
		if (item == 36)
		{
			line1 = handle(invent02_item36_message1);
			line2 = handle(invent02_item36_message2);
			line3 = handle(invent02_item36_message3);
		}
		if (item == 37)
		{
			line1 = handle(invent02_item37_message1);
			line2 = handle(invent02_item37_message2);
			line3 = handle(invent02_item37_message3);
		}
		if (item == 38)
		{
			line1 = handle(invent02_item38_message1);
			line2 = handle(invent02_item38_message2);
			line3 = handle(invent02_item38_message3);
		}
		if (item == 39)
		{
			line1 = handle(invent02_item39_message1);
			line2 = handle(invent02_item39_message2);
			line3 = handle(invent02_item39_message3);
		}
		if (item == 40)
		{
			line1 = handle(invent02_item40_message1);
			line2 = handle(invent02_item40_message2);
			line3 = handle(invent02_item40_message3);
		}
		if (item == 41)
		{
			line1 = handle(invent02_item41_message1);
			line2 = handle(invent02_item41_message2);
			line3 = handle(invent02_item41_message3);
		}
		if (item == 42)
		{
			line1 = handle(invent02_item42_message1);
			line2 = handle(invent02_item42_message2);
			line3 = handle(invent02_item42_message3);
		}
		if (item == 43)
		{
			line1 = handle(invent02_item43_message1);
			line2 = handle(invent02_item43_message2);
			line3 = handle(invent02_item43_message3);
		}
		if (item == 44)
		{
			line1 = handle(invent02_item44_message1);
			line2 = handle(invent02_item44_message2);
			line3 = handle(invent02_item44_message3);
		}
		if (item == 45)
		{
			line1 = handle(invent02_item45_message1);
			line2 = handle(invent02_item45_message2);
			line3 = handle(invent02_item45_message3);
		}
		if (item == 46)
		{
			line1 = handle(invent02_item46_message1);
			line2 = handle(invent02_item46_message2);
			line3 = handle(invent02_item46_message3);
		}
		if (item == 47)
		{
			line1 = handle(invent02_item47_message1);
			line2 = handle(invent02_item47_message2);
			line3 = handle(invent02_item47_message3);
		}
		if (item == 48)
		{
			line1 = handle(invent02_item48_message1);
			line2 = handle(invent02_item48_message2);
			line3 = handle(invent02_item48_message3);
		}
		if (item == 49)
		{
			line1 = handle(invent02_item49_message1);
			line2 = handle(invent02_item49_message2);
			line3 = handle(invent02_item49_message3);
		}
		if (item == 50)
		{
			line1 = handle(invent02_item50_message1);
			line2 = handle(invent02_item50_message2);
			line3 = handle(invent02_item50_message3);
		}
		if (item == 51)
		{
			line1 = handle(invent02_item51_message1);
			line2 = handle(invent02_item51_message2);
			line3 = handle(invent02_item51_message3);
		}
		if (item == 52)
		{
			line1 = handle(invent02_item52_message1);
			line2 = handle(invent02_item52_message2);
			line3 = handle(invent02_item52_message3);
		}
		if (item == 53)
		{
			line1 = handle(invent02_item53_message1);
			line2 = handle(invent02_item53_message2);
			line3 = handle(invent02_item53_message3);
		}
		if (item == 54)
		{
			line1 = handle(invent02_item54_message1);
			line2 = handle(invent02_item54_message2);
			line3 = handle(invent02_item54_message3);
		}
		if (item == 55)
		{
			line1 = handle(invent02_item55_message1);
			line2 = handle(invent02_item55_message2);
			line3 = handle(invent02_item55_message3);
		}
		if (item == 56)
		{
			line1 = handle(invent02_item56_message1);
			line2 = handle(invent02_item56_message2);
			line3 = handle(invent02_item56_message3);
		}
		if (item == 57)
		{
			line1 = handle(invent02_item57_message1);
			line2 = handle(invent02_item57_message2);
			line3 = handle(invent02_item57_message3);
		}
		if (item == 58)
		{
			line1 = handle(invent02_item58_message1);
			line2 = handle(invent02_item58_message2);
			line3 = handle(invent02_item58_message3);
		}
		if (item == 59)
		{
			line1 = handle(invent02_item59_message1);
			line2 = handle(invent02_item59_message2);
			line3 = handle(invent02_item59_message3);
		}
		if (item == 60)
		{
			line1 = handle(invent02_item60_message1);
			line2 = handle(invent02_item60_message2);
			line3 = handle(invent02_item60_message3);
		}
		if (item == 61)
		{
			line1 = handle(invent02_item61_message1);
			line2 = handle(invent02_item61_message2);
			line3 = handle(invent02_item61_message3);
		}
		if (item == 62)
		{
			line1 = handle(invent02_item62_message1);
			line2 = handle(invent02_item62_message2);
			line3 = handle(invent02_item62_message3);
		}
		if (item == 63)
		{
			line1 = handle(invent02_item63_message1);
			line2 = handle(invent02_item63_message2);
			line3 = handle(invent02_item63_message3);
		}
		if (item == 64)
		{
			line1 = handle(invent02_item64_message1);
			line2 = handle(invent02_item64_message2);
			line3 = handle(invent02_item64_message3);
		}
		if (item == 65)
		{
			line1 = handle(invent02_item65_message1);
			line2 = handle(invent02_item65_message2);
			line3 = handle(invent02_item65_message3);
		}
		if (item == 66)
		{
			line1 = handle(invent02_item66_message1);
			line2 = handle(invent02_item66_message2);
			line3 = handle(invent02_item66_message3);
		}
		if (item == 67)
		{
			line1 = handle(invent02_item67_message1);
			line2 = handle(invent02_item67_message2);
			line3 = handle(invent02_item67_message3);
		}
		if (item == 68)
		{
			line1 = handle(invent02_item68_message1);
			line2 = handle(invent02_item68_message2);
			line3 = handle(invent02_item68_message3);
		}
		if (item == 69)
		{
			line1 = handle(invent02_item69_message1);
			line2 = handle(invent02_item69_message2);
			line3 = handle(invent02_item69_message3);
		}
		if (item == 70)
		{
			line1 = handle(invent02_item70_message1);
			line2 = handle(invent02_item70_message2);
			line3 = handle(invent02_item70_message3);
		}
	
		
		str_cpy(_invent02_format_msg_tmp,_invent02_pickup_prefix1);
		str_cat(_invent02_format_msg_tmp,ptr_for_handle(line1));
		str_cat(_invent02_format_msg_tmp,_invent02_pickup_suffix1);
		str_cpy(_invent02_format_msg_fnl,"");
		len = (30 - str_len(_invent02_format_msg_tmp)) / 2;
		while (len > 0)
		{
			str_cat(_invent02_format_msg_fnl," ");
			len -= 1;
		}
		str_cat(_invent02_format_msg_fnl,_invent02_format_msg_tmp);
		str_cpy(_invent02_text_msg.string[0],_invent02_format_msg_fnl);
	
		str_cpy(_invent02_format_msg_tmp,_invent02_pickup_prefix2);
		str_cat(_invent02_format_msg_tmp,ptr_for_handle(line2));
		str_cat(_invent02_format_msg_tmp,_invent02_pickup_suffix2);
		str_cpy(_invent02_format_msg_fnl,"");
		len = (30 - str_len(_invent02_format_msg_tmp)) / 2;
	   while (len > 0)
		{
			str_cat(_invent02_format_msg_fnl," ");
			len -= 1;
		}
		str_cat(_invent02_format_msg_fnl,_invent02_format_msg_tmp);
		str_cpy(_invent02_text_msg.string[1],_invent02_format_msg_fnl);
	
		str_cpy(_invent02_format_msg_tmp,_invent02_pickup_prefix3);
		str_cat(_invent02_format_msg_tmp,ptr_for_handle(line3));
		str_cat(_invent02_format_msg_tmp,_invent02_pickup_suffix3);
		str_cpy(_invent02_format_msg_fnl,"");
		len = (30 - str_len(_invent02_format_msg_tmp)) / 2;
		while (len > 0)
		{
			str_cat(_invent02_format_msg_fnl," ");
			len -= 1;
		}
		str_cat(_invent02_format_msg_fnl,_invent02_format_msg_tmp);
		str_cpy(_invent02_text_msg.string[2],_invent02_format_msg_fnl);
	};


// ---------------------------------------------------------------------
// move message window to center of screen
//
	function _invent02_move_msg()
	{
		var xoffset;
		var yoffset;
		xoffset = (screen_size.x - bmap_width(_invent02_msg_bmp)) / 2;
		yoffset = (screen_size.y - bmap_height(_invent02_msg_bmp)) / 2;
		_invent02_pan_msg.pos_x = xoffset;
		_invent02_pan_msg.pos_y = yoffset;
		_invent02_text_msg.pos_x = xoffset + 10;
		_invent02_text_msg.pos_y = yoffset + 9;
	};
	

	function _invent02_hide_msg()
	{
		_invent02_pan_msg.visible = off;
		_invent02_text_msg.visible = off;
	};

var _invent02_in_decay = false;

	function _invent02_msg_decay()
	{
		_invent02_in_decay = true;
		while (1)
		{
			wait(1);
			_invent02_msg_show_timer -= 1 * time;
			if (_invent02_msg_show_timer <= 0) 
			{
				_invent02_in_decay = false;
				_invent02_hide_msg();
				break;
			}
			if (_invent02_msg_show_timer < 35)
			{
				_invent02_pan_msg.alpha = _invent02_msg_show_timer * 2;
				_invent02_text_msg.alpha = _invent02_msg_show_timer * 2;
			} else {
				_invent02_pan_msg.alpha = 70;
				_invent02_text_msg.alpha = 70;
			}
		}
	};

	function _invent02_show_msg()
	{
		_invent02_pan_msg.visible = on;
		_invent02_pan_msg.alpha = 70;
		_invent02_text_msg.visible = on;
		_invent02_text_msg.alpha = 70;
		_invent02_msg_show_timer = _invent02_msg_show_timer_time_max;
		if (!_invent02_in_decay)
		{
			_invent02_msg_decay();
		}
	};



panel _invent02_pan_part_01
{
	bmap = _invent02_btn_left_off;
	layer = 5;
	pos_X = 0;
	pos_y = -200;
	button 0,0,
		_invent02_btn_left_on,
		_invent02_btn_left_off,
		_invent02_btn_left_over,
		_invent02_scroll_left,
		null,
		null;
	flags = refresh,visible;
}

panel _invent02_pan_part_02
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 32;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_03
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 64;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_04
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 96;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_05
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 128;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_06
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 160;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_07
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 192;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_08
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 224;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_09
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 256;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_10
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 288;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_11
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 320;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_12
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 352;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_13
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 384;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_14
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 416;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_15
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 448;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_16
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 480;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_17
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 512;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_18
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 544;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_19
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 576;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_20
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 608;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_21
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 640;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_22
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 672;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_23
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 704;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_24
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 736;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_25
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 768;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_26
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 800;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_27
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 832;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_28
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 864;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_29
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 896;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_30
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 928;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_31
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 960;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_32
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 992;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_33
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 1024;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_34
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 1056;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_35
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 1088;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_36
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 1120;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_37
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 1152;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_38
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 1184;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_39
{
	bmap = _invent02_backgrnd2_bmp;
	layer = 5;
	pos_X = 1216;
	pos_y = -200;
	flags = refresh,visible;
}

panel _invent02_pan_part_40
{
	bmap = _invent02_btn_right_off;
	layer = 5;
	pos_X = 1248;
	pos_y = -200;
	button 0,0,
		_invent02_btn_right_on,
		_invent02_btn_right_off,
		_invent02_btn_right_over,
		_invent02_scroll_right,
		null,
		null;
	flags = refresh,visible;
}

bmap _invent02_bar_sel = <invent02_bar_sel.pcx>;
bmap _invent02_bar_sel_on = <invent02_bar_sel_on.pcx>;

function _invent02_use0()
{
	_invent02_use(0);
}

panel _invent02_pan_part_02a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 32;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use0,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use1()
{
	_invent02_use(1);
}


panel _invent02_pan_part_03a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 64;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use1,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use2()
{
	_invent02_use(2);
}

panel _invent02_pan_part_04a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 96;
	pos_y = -200;
	flags = refresh,visible;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use2,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use3()
{
	_invent02_use(3);
}

panel _invent02_pan_part_05a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 128;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use3,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use4()
{
	_invent02_use(4);
}

panel _invent02_pan_part_06a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 160;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use4,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use5()
{
	_invent02_use(5);
}

panel _invent02_pan_part_07a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 192;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use5,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use6()
{
	_invent02_use(6);
}

panel _invent02_pan_part_08a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 224;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use6,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use7()
{
	_invent02_use(7);
}

panel _invent02_pan_part_09a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 256;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use7,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use8()
{
	_invent02_use(8);
}

panel _invent02_pan_part_10a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 288;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use8,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use9()
{
	_invent02_use(9);
}

panel _invent02_pan_part_11a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 320;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use9,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use10()
{
	_invent02_use(10);
}

panel _invent02_pan_part_12a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 352;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use10,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use11()
{
	_invent02_use(11);
}

panel _invent02_pan_part_13a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 384;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use11,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use12()
{
	_invent02_use(12);
}

panel _invent02_pan_part_14a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 416;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use12,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use13()
{
	_invent02_use(13);
}

panel _invent02_pan_part_15a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 448;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use13,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use14()
{
	_invent02_use(14);
}

panel _invent02_pan_part_16a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 480;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use14,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use15()
{
	_invent02_use(15);
}

panel _invent02_pan_part_17a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 512;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use15,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use16()
{
	_invent02_use(16);
}

panel _invent02_pan_part_18a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 544;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use16,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use17()
{
	_invent02_use(17);
}

panel _invent02_pan_part_19a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 576;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use17,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use18()
{
	_invent02_use(18);
}

panel _invent02_pan_part_20a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 608;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use18,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use19()
{
	_invent02_use(19);
}

panel _invent02_pan_part_21a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 640;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use19,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use20()
{
	_invent02_use(20);
}

panel _invent02_pan_part_22a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 672;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use20,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use21()
{
	_invent02_use(21);
}

panel _invent02_pan_part_23a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 704;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use21,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use22()
{
	_invent02_use(22);
}

panel _invent02_pan_part_24a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 736;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use22,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use23()
{
	_invent02_use(23);
}

panel _invent02_pan_part_25a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 768;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use23,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use24()
{
	_invent02_use(24);
}

panel _invent02_pan_part_26a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 800;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use24,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use25()
{
	_invent02_use(25);
}

panel _invent02_pan_part_27a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 832;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use25,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use26()
{
	_invent02_use(26);
}

panel _invent02_pan_part_28a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 864;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use26,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use27()
{
	_invent02_use(27);
}

panel _invent02_pan_part_29a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 896;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use27,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use28()
{
	_invent02_use(28);
}

panel _invent02_pan_part_30a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 928;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use28,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use29()
{
	_invent02_use(29);
}

panel _invent02_pan_part_31a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 960;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use29,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use30()
{
	_invent02_use(30);
}

panel _invent02_pan_part_32a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 992;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use30,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use31()
{
	_invent02_use(31);
}

panel _invent02_pan_part_33a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 1024;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use31,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use32()
{
	_invent02_use(32);
}

panel _invent02_pan_part_34a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 1056;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use32,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use33()
{
	_invent02_use(33);
}

panel _invent02_pan_part_35a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 1088;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use33,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use34()
{
	_invent02_use(34);
}

panel _invent02_pan_part_36a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 1120;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use34,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use35()
{
	_invent02_use(35);
}

panel _invent02_pan_part_37a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 1152;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use35,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use36()
{
	_invent02_use(36);
}

panel _invent02_pan_part_38a
{
	bmap = _invent02_item_bmp;
	layer = 6;
	pos_X = 1184;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use36,
		null,
		null;
	flags = refresh,visible,overlay;
}

function _invent02_use37()
{
	_invent02_use(37);
}

panel _invent02_pan_part_39a
{
	bmap = _invent02_item_bmp;
	layer = 5;
	pos_X = 1216;
	pos_y = -200;
	button 0,0,
		_invent02_bar_sel_on,
		_invent02_bar_sel_on,
		_invent02_bar_sel,
		_invent02_use37,
		null,
		null;
	flags = refresh,visible,overlay;
}


	function _invent02_use(index)
	{
		var Item;
		var MyAction;
		Item = _invent02_item_pos + index;
		if (item >= _invent02_inventory_size)
		{
			item -= _invent02_inventory_size;
		}
	
		MyAction = _invent02_get_action(item);
		
		if (str_cmp(ptr_for_handle(MyAction),"") == 0)
		{
			execute(ptr_for_handle(MyAction));
		}
		_invent02_RemoveItemfromInventory(Item);
		_invent02_update_display();
	};


	function _invent02_update_display()
	{
		var index;
		index = _invent02_item_pos;
		_invent02_pan_part_02a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_03a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_04a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_05a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_06a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_07a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_08a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_09a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_10a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_11a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_12a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_13a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_14a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_15a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_16a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_17a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_18a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_19a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_20a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_21a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_22a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_23a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_24a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_25a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_26a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_27a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_28a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_29a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_30a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_31a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_32a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_33a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_34a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_35a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_36a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_37a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_38a.bmap = ptr_for_handle(_invent02_get_icon(index));
		index += 1; if (index >= _invent02_inventory_size) { index = 0; };
		_invent02_pan_part_39a.bmap = ptr_for_handle(_invent02_get_icon(index));
	};


	function _invent02_update_panels()
	{
		var index = 0;
		wait(3);
		if (_invent02_back_pos == -1)
		{
			_invent02_pan_part_01.pos_y = -200;
			_invent02_pan_part_02.pos_y = -200;
			_invent02_pan_part_03.pos_y = -200;
			_invent02_pan_part_04.pos_y = -200;
			_invent02_pan_part_05.pos_y = -200;
			_invent02_pan_part_06.pos_y = -200;
			_invent02_pan_part_07.pos_y = -200;
			_invent02_pan_part_08.pos_y = -200;
			_invent02_pan_part_09.pos_y = -200;
			_invent02_pan_part_10.pos_y = -200;
			_invent02_pan_part_11.pos_y = -200;
			_invent02_pan_part_12.pos_y = -200;
			_invent02_pan_part_13.pos_y = -200;
			_invent02_pan_part_14.pos_y = -200;
			_invent02_pan_part_15.pos_y = -200;
			_invent02_pan_part_16.pos_y = -200;
			_invent02_pan_part_17.pos_y = -200;
			_invent02_pan_part_18.pos_y = -200;
			_invent02_pan_part_19.pos_y = -200;
			_invent02_pan_part_20.pos_y = -200;
			_invent02_pan_part_21.pos_y = -200;
			_invent02_pan_part_22.pos_y = -200;
			_invent02_pan_part_23.pos_y = -200;
			_invent02_pan_part_24.pos_y = -200;
			_invent02_pan_part_25.pos_y = -200;
			_invent02_pan_part_26.pos_y = -200;
			_invent02_pan_part_27.pos_y = -200;
			_invent02_pan_part_28.pos_y = -200;
			_invent02_pan_part_29.pos_y = -200;
			_invent02_pan_part_30.pos_y = -200;
			_invent02_pan_part_31.pos_y = -200;
			_invent02_pan_part_32.pos_y = -200;
			_invent02_pan_part_33.pos_y = -200;
			_invent02_pan_part_34.pos_y = -200;
			_invent02_pan_part_35.pos_y = -200;
			_invent02_pan_part_36.pos_y = -200;
			_invent02_pan_part_37.pos_y = -200;
			_invent02_pan_part_38.pos_y = -200;
			_invent02_pan_part_39.pos_y = -200;
			_invent02_pan_part_40.pos_y = -200;
			_invent02_pan_part_02a.pos_y = -200;
			_invent02_pan_part_03a.pos_y = -200;
			_invent02_pan_part_04a.pos_y = -200;
			_invent02_pan_part_05a.pos_y = -200;
			_invent02_pan_part_06a.pos_y = -200;
			_invent02_pan_part_07a.pos_y = -200;
			_invent02_pan_part_08a.pos_y = -200;
			_invent02_pan_part_09a.pos_y = -200;
			_invent02_pan_part_10a.pos_y = -200;
			_invent02_pan_part_11a.pos_y = -200;
			_invent02_pan_part_12a.pos_y = -200;
			_invent02_pan_part_13a.pos_y = -200;
			_invent02_pan_part_14a.pos_y = -200;
			_invent02_pan_part_15a.pos_y = -200;
			_invent02_pan_part_16a.pos_y = -200;
			_invent02_pan_part_17a.pos_y = -200;
			_invent02_pan_part_18a.pos_y = -200;
			_invent02_pan_part_19a.pos_y = -200;
			_invent02_pan_part_20a.pos_y = -200;
			_invent02_pan_part_21a.pos_y = -200;
			_invent02_pan_part_22a.pos_y = -200;
			_invent02_pan_part_23a.pos_y = -200;
			_invent02_pan_part_24a.pos_y = -200;
			_invent02_pan_part_25a.pos_y = -200;
			_invent02_pan_part_26a.pos_y = -200;
			_invent02_pan_part_27a.pos_y = -200;
			_invent02_pan_part_28a.pos_y = -200;
			_invent02_pan_part_29a.pos_y = -200;
			_invent02_pan_part_30a.pos_y = -200;
			_invent02_pan_part_31a.pos_y = -200;
			_invent02_pan_part_32a.pos_y = -200;
			_invent02_pan_part_33a.pos_y = -200;
			_invent02_pan_part_34a.pos_y = -200;
			_invent02_pan_part_35a.pos_y = -200;
			_invent02_pan_part_36a.pos_y = -200;
			_invent02_pan_part_37a.pos_y = -200;
			_invent02_pan_part_38a.pos_y = -200;
			_invent02_pan_part_39a.pos_y = -200;
		}
		if (_invent02_back_pos == 0)
		{
			_invent02_pan_part_01.pos_y = 0;
			_invent02_pan_part_02.pos_y = 0;
			_invent02_pan_part_03.pos_y = 0;
			_invent02_pan_part_04.pos_y = 0;
			_invent02_pan_part_05.pos_y = 0;
			_invent02_pan_part_06.pos_y = 0;
			_invent02_pan_part_07.pos_y = 0;
			_invent02_pan_part_08.pos_y = 0;
			_invent02_pan_part_09.pos_y = 0;
			_invent02_pan_part_10.pos_y = 0;
			_invent02_pan_part_11.pos_y = 0;
			_invent02_pan_part_12.pos_y = 0;
			_invent02_pan_part_13.pos_y = 0;
			_invent02_pan_part_14.pos_y = 0;
			_invent02_pan_part_15.pos_y = 0;
			_invent02_pan_part_16.pos_y = 0;
			_invent02_pan_part_17.pos_y = 0;
			_invent02_pan_part_18.pos_y = 0;
			_invent02_pan_part_19.pos_y = 0;
			_invent02_pan_part_20.pos_y = 0;
			_invent02_pan_part_21.pos_y = 0;
			_invent02_pan_part_22.pos_y = 0;
			_invent02_pan_part_23.pos_y = 0;
			_invent02_pan_part_24.pos_y = 0;
			_invent02_pan_part_25.pos_y = 0;
			_invent02_pan_part_26.pos_y = 0;
			_invent02_pan_part_27.pos_y = 0;
			_invent02_pan_part_28.pos_y = 0;
			_invent02_pan_part_29.pos_y = 0;
			_invent02_pan_part_30.pos_y = 0;
			_invent02_pan_part_31.pos_y = 0;
			_invent02_pan_part_32.pos_y = 0;
			_invent02_pan_part_33.pos_y = 0;
			_invent02_pan_part_34.pos_y = 0;
			_invent02_pan_part_35.pos_y = 0;
			_invent02_pan_part_36.pos_y = 0;
			_invent02_pan_part_37.pos_y = 0;
			_invent02_pan_part_38.pos_y = 0;
			_invent02_pan_part_39.pos_y = 0;
			_invent02_pan_part_40.pos_y = 0;
			_invent02_pan_part_02a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_03a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_04a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_05a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_06a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_07a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_08a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_09a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_10a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_11a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_12a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_13a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_14a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_15a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_16a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_17a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_18a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_19a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_20a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_21a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_22a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_23a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_24a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_25a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_26a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_27a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_28a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_29a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_30a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_31a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_32a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_33a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_34a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_35a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_36a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_37a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_38a.pos_y = _invent02_item_y_offset;
			_invent02_pan_part_39a.pos_y = _invent02_item_y_offset;
		}
		if (_invent02_back_pos == 1)
		{
			index = screen_size.y - bmap_height (_invent02_backgrnd2_bmp) - _invent02_bottom_offset;
			_invent02_pan_part_01.pos_y = index;
			_invent02_pan_part_02.pos_y = index;
			_invent02_pan_part_03.pos_y = index;
			_invent02_pan_part_04.pos_y = index;
			_invent02_pan_part_05.pos_y = index;
			_invent02_pan_part_06.pos_y = index;
			_invent02_pan_part_07.pos_y = index;
			_invent02_pan_part_08.pos_y = index;
			_invent02_pan_part_09.pos_y = index;
			_invent02_pan_part_10.pos_y = index;
			_invent02_pan_part_11.pos_y = index;
			_invent02_pan_part_12.pos_y = index;
			_invent02_pan_part_13.pos_y = index;
			_invent02_pan_part_14.pos_y = index;
			_invent02_pan_part_15.pos_y = index;
			_invent02_pan_part_16.pos_y = index;
			_invent02_pan_part_17.pos_y = index;
			_invent02_pan_part_18.pos_y = index;
			_invent02_pan_part_19.pos_y = index;
			_invent02_pan_part_20.pos_y = index;
			_invent02_pan_part_21.pos_y = index;
			_invent02_pan_part_22.pos_y = index;
			_invent02_pan_part_23.pos_y = index;
			_invent02_pan_part_24.pos_y = index;
			_invent02_pan_part_25.pos_y = index;
			_invent02_pan_part_26.pos_y = index;
			_invent02_pan_part_27.pos_y = index;
			_invent02_pan_part_28.pos_y = index;
			_invent02_pan_part_29.pos_y = index;
			_invent02_pan_part_30.pos_y = index;
			_invent02_pan_part_31.pos_y = index;
			_invent02_pan_part_32.pos_y = index;
			_invent02_pan_part_33.pos_y = index;
			_invent02_pan_part_34.pos_y = index;
			_invent02_pan_part_35.pos_y = index;
			_invent02_pan_part_36.pos_y = index;
			_invent02_pan_part_37.pos_y = index;
			_invent02_pan_part_38.pos_y = index;
			_invent02_pan_part_39.pos_y = index;
			_invent02_pan_part_40.pos_y = index;
			index += _invent02_item_y_offset;
			_invent02_pan_part_02a.pos_y = index;
			_invent02_pan_part_03a.pos_y = index;
			_invent02_pan_part_04a.pos_y = index;
			_invent02_pan_part_05a.pos_y = index;
			_invent02_pan_part_06a.pos_y = index;
			_invent02_pan_part_07a.pos_y = index;
			_invent02_pan_part_08a.pos_y = index;
			_invent02_pan_part_09a.pos_y = index;
			_invent02_pan_part_10a.pos_y = index;
			_invent02_pan_part_11a.pos_y = index;
			_invent02_pan_part_12a.pos_y = index;
			_invent02_pan_part_13a.pos_y = index;
			_invent02_pan_part_14a.pos_y = index;
			_invent02_pan_part_15a.pos_y = index;
			_invent02_pan_part_16a.pos_y = index;
			_invent02_pan_part_17a.pos_y = index;
			_invent02_pan_part_18a.pos_y = index;
			_invent02_pan_part_19a.pos_y = index;
			_invent02_pan_part_20a.pos_y = index;
			_invent02_pan_part_21a.pos_y = index;
			_invent02_pan_part_22a.pos_y = index;
			_invent02_pan_part_23a.pos_y = index;
			_invent02_pan_part_24a.pos_y = index;
			_invent02_pan_part_25a.pos_y = index;
			_invent02_pan_part_26a.pos_y = index;
			_invent02_pan_part_27a.pos_y = index;
			_invent02_pan_part_28a.pos_y = index;
			_invent02_pan_part_29a.pos_y = index;
			_invent02_pan_part_30a.pos_y = index;
			_invent02_pan_part_31a.pos_y = index;
			_invent02_pan_part_32a.pos_y = index;
			_invent02_pan_part_33a.pos_y = index;
			_invent02_pan_part_34a.pos_y = index;
			_invent02_pan_part_35a.pos_y = index;
			_invent02_pan_part_36a.pos_y = index;
			_invent02_pan_part_37a.pos_y = index;
			_invent02_pan_part_38a.pos_y = index;
			_invent02_pan_part_39a.pos_y = index;
		}
		if (screen_size.x == 640)
		{
			_invent02_pan_part_20.visible = OFF;
			_invent02_pan_part_20a.visible = OFF;
			_invent02_pan_part_40.pos_x = 608;
		}
		if (screen_size.x == 800)
		{
			_invent02_pan_part_20.visible = ON;
			_invent02_pan_part_20a.visible = ON;
			_invent02_pan_part_25.visible = OFF;
			_invent02_pan_part_25a.visible = OFF;
			_invent02_pan_part_40.pos_x = 768;
		}
		if (screen_size.x == 1024)
		{
			_invent02_pan_part_20.visible = ON;
			_invent02_pan_part_20a.visible = ON;
			_invent02_pan_part_25.visible = ON;
			_invent02_pan_part_25a.visible = ON;
			_invent02_pan_part_32.visible = OFF;
			_invent02_pan_part_32a.visible = OFF;
			_invent02_pan_part_40.pos_x = 992;
		
		}
		if (screen_size.x == 1280)
		{
			_invent02_pan_part_20.visible = ON;
			_invent02_pan_part_20a.visible = ON;
			_invent02_pan_part_25.visible = ON;
			_invent02_pan_part_25a.visible = ON;
			_invent02_pan_part_32.visible = ON;
			_invent02_pan_part_32a.visible = ON;
			_invent02_pan_part_40.pos_x = 1248;
		}
		wait(1);
		_invent02_update_display();
	};


	starter _invent02_starter()
	{
		var index;
		index = 0;
		while (index < _invent02_inventory_size)
		{
			_invent02_inventory[index] = -1;
			_invent02_inventory_items[index] = -1;
			index += 1;
		}
		index = 0;
		while (index < _invent02_inventory_used_size)
		{
			_invent02_inventory_used[index] = -1;
			index += 1;
		}
	};
	
	
	function _invent02_mouse_on()
	{
		MOUSE_MAP = _invent02_arrow;
		while(MOUSE_MODE > 0)
		{
			MOUSE_POS.X = POINTER.X;
			MOUSE_POS.Y = POINTER.Y;
			wait(1); 		      // now move it over the screen
		}
	};


	function togle_inventory()
	{
		if (_invent02_back_pos_def == _invent02_back_pos)
		{
			_invent02_back_pos = -1;
			mouse_mode = 0;
			
		} else {
			_invent02_back_pos = _invent02_back_pos_def;
			mouse_spot.x = 0; 
			mouse_spot.y = 0;			
			mouse_mode = 2;
			_invent02_mouse_on();
		}
		_invent02_update_panels();
	};
	
	
	function _invent02_scroll_right()
	{
		var index;
		_invent02_item_pos -= 1;
		if (_invent02_item_pos < 0)
		{
			_invent02_item_pos = _invent02_inventory_size - 1;
		}
		_invent02_update_display();
	};
	

	function _invent02_scroll_left()
	{
		var index;
		_invent02_item_pos += 1;
		if (_invent02_item_pos >= _invent02_inventory_size)
		{
			_invent02_item_pos = 0;
		}
		_invent02_update_display();
	};

	function _invent02_pickup_event()
	{
		var index = 0;
		if(you.GL_Entity_id > GL_Player2) { return; } // only react to player
		// only react to player activate scans
		if((event_type == event_scan) && (you.GL_Event_Message != GL_EVENT_SCAN)) 
		{ 
			return; 
		}
	
		// hide object
		my.passable = on;
		my.invisible = on;
		my.shadow = off;
		my.enable_scan = off;
		my.enable_impact = off;
		my.enable_sonar = off;
	
		// add Item, trigger playing sound, display message and run action
		_invent02_item_to_add = me;
	
		// remove object
		wait(6);		// need to wait 3 frames because we need to return to our action.
		//while (_invent02_in_decay)
		//{
		//	wait(1); //wait till we have finished displaying the message because if we kill
		//				//this function we kill the other functions we called.
		//}
		ent_remove(ME);
	};

	function _invent02_wait_for_add()
	{
		var MyId;
		var MyType;
		var snd;
		var act;
		
		MyId = me._id__0c0;
		MyType = me._item_type__0c0;
		snd = me._item_sound__0c0;
		act = me._item_action__0c0;
		me = null;
		while (1)
		{
			wait(1);
			if (_invent02_item_to_add == null)
			{
				continue;
			}
			if (MyID == _invent02_item_to_add._id__0c0 && MyType == _invent02_item_to_add._item_type__0c0)
			{
				if (MyID >= 1000) 
				{
					_invent02_AddItemToInventory(MyId,MyType);
		   	} else {
		   		_invent02_AddItemToUsed(MyId);
				}
				//snd_play(ptr_for_handle(snd),100,0); // some bug here use workaround for now
				invent02_play_snd(MyType);
				_invent02_format_msg(MyType);
				_invent02_move_msg();
				_invent02_show_msg();
				wait(2);
				if (MyID < 1000) 
				{
					if (str_cmp(ptr_for_handle(act),"") == 0)
					{
						execute(ptr_for_handle(act));
					}
				}
				break;
			}
		}
	};


	function _invent02_IsItemInInventory(item)
	{
		var index = 0;
		while (index < _invent02_inventory_size)
		{
			if (_invent02_inventory[index] == item)
			{
				return(true);
			}
			index += 1;
		}
		return(false);
	};
	

	function _invent02_HasItemBeenUsed(item)
	{
		var index = 0;
		while (index < _invent02_inventory_size)
		{
			if (_invent02_inventory_used[index] == item)
			{
				return(true);
			}
			index += 1;
		}
		return(false);
	};
	

	function _invent02_AddItemToInventory(item,item_type)
	{
		var index = 0;
		while (index < _invent02_inventory_size)
		{
			if (_invent02_inventory[index] == -1)
			{
				_invent02_inventory[index] = item;
				_invent02_inventory_items[index] = item_type;
				break;
			}
			index += 1;
		}
	};
	

	function _invent02_AddItemToUsed(item)
	{
		var index = 0;
		while (index < _invent02_inventory_size)
		{
			if (_invent02_inventory_used[index] == -1)
			{
				_invent02_inventory_used[index] = item;
				break;
			}
			index += 1;
		}
	};
	

	function _invent02_RemoveItemfromInventory(ItemIndex)
	{
		var index;
		index = ItemIndex;
		_invent02_AddItemToUsed(_invent02_inventory[index]);
		while (index < _invent02_inventory_size)
		{
			_invent02_inventory[index] = -1;
			_invent02_inventory_items[index] = -1;
			if (index+1 < _invent02_inventory_size)
			{
				_invent02_inventory[index] = _invent02_inventory[index + 1];
				_invent02_inventory_items[index] = _invent02_inventory_items[index + 1];
			}
			index += 1;
		}
	};


	on_y togle_inventory();
	
endif;